/* ======================================================================== *
 * IMGLIB -- TI Image and Video Processing Library                          *
 *                                                                          *
 *                                                                          *
 * Copyright (C) 2012 Texas Instruments Incorporated - http://www.ti.com/   *
 *                                                                          *
 *                                                                          *
 *  Redistribution and use in source and binary forms, with or without      *
 *  modification, are permitted provided that the following conditions      *
 *  are met:                                                                *
 *                                                                          *
 *    Redistributions of source code must retain the above copyright        *
 *    notice, this list of conditions and the following disclaimer.         *
 *                                                                          *
 *    Redistributions in binary form must reproduce the above copyright     *
 *    notice, this list of conditions and the following disclaimer in the   *
 *    documentation and/or other materials provided with the                *
 *    distribution.                                                         *
 *                                                                          *
 *    Neither the name of Texas Instruments Incorporated nor the names of   *
 *    its contributors may be used to endorse or promote products derived   *
 *    from this software without specific prior written permission.         *
 *                                                                          *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   *
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    *
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 * ======================================================================== */

int in_data[] = {
/* Test data for kernel size : 7 x 7 
 * kernel size */
 7,

/* Alignment data.
 * 0 = double word, 4 = word, 2 = half word, 1 = byte alignment respectively.
 * src align, mask align, dst align */
1, 1, 4,

/* Function parameters : 1 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
0, 2, 8, 11, 56, 2,

/* Image data : 1 */
 151, 140, 162, 91, 137, 28, 231, 155,
 57, 150, 6, 54, 150, 53, 127, 3,
 116, 60, 31, 154, 128, 211, 115, 103,
 170, 88, 143, 193, 224, 98, 203, 127,
 9, 77, 178, 161, 214, 217, 177, 16,
 247, 4, 3, 20, 113, 149, 42, 135,
 208, 6, 135, 162, 9, 233, 62, 131,

/* mask : 1 */
 1, 2, 3, 4, 5, 6, 7,
 8, 9, 10, 11, 12, 13, 14,
 15, 16, 17, 18, 19, 20, 21,
 22, 23, 24, 25, 26, 27, 28,
 29, 30, 31, 32, 33, 34, 35,
 36, 37, 38, 39, 40, 41, 42,
 43, 44, 45, 46, 47, 48, 49,

/* Function parameters : 2 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
1, 30, 36, 12, 252, 30,

/* Image data : 2 */
 202, 115, 196, 67, 240, 129, 102, 109, 11, 117, 3, 242, 44, 184, 191, 233, 144, 235, 217, 224, 191, 201, 75, 29, 205, 247, 55, 25, 236, 115, 204, 44, 73, 63, 139, 115,
 59, 154, 255, 144, 68, 182, 126, 124, 167, 237, 146, 127, 137, 37, 170, 71, 167, 167, 96, 14, 195, 98, 192, 5, 231, 87, 151, 90, 239, 110, 77, 255, 162, 103, 174, 40,
 122, 221, 221, 92, 198, 39, 7, 117, 127, 0, 177, 238, 69, 170, 99, 157, 174, 27, 252, 199, 93, 91, 110, 206, 164, 146, 57, 19, 61, 216, 143, 237, 11, 227, 63, 166,
 239, 91, 19, 230, 51, 211, 239, 245, 44, 246, 21, 160, 212, 147, 34, 53, 140, 102, 202, 251, 193, 151, 116, 112, 192, 100, 98, 229, 68, 27, 229, 147, 157, 91, 211, 109,
 192, 172, 221, 190, 15, 46, 81, 218, 133, 214, 33, 92, 247, 95, 239, 122, 6, 36, 7, 36, 247, 152, 75, 39, 187, 96, 127, 190, 20, 240, 66, 20, 165, 83, 182, 19,
 169, 47, 141, 58, 10, 138, 226, 88, 139, 233, 231, 188, 187, 180, 133, 90, 59, 162, 186, 67, 250, 44, 193, 49, 73, 252, 19, 62, 63, 23, 70, 211, 88, 10, 86, 127,
 192, 161, 40, 130, 134, 27, 4, 231, 111, 141, 155, 158, 207, 249, 101, 13, 210, 104, 36, 254, 62, 76, 87, 29, 148, 250, 163, 200, 253, 29, 135, 226, 89, 87, 25, 251,

/* mask : 2 */
 105, 79, 4, 1, 53, 114, 124,
 127, 5, 101, 42, 115, 95, 69,
 49, 125, 106, 74, 87, 58, 56,
 16, 24, 112, 108, 79, 43, 32,
 14, 39, 60, 26, 39, 36, 79,
 96, 121, 43, 69, 94, 112, 88,
 107, 14, 35, 4, 32, 24, 44,

/* Function parameters : 3 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
1, 10, 16, 16, 112, 10,

/* Image data : 3 */
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

/* mask : 3 */
 -128, -128, -128, -128, 125, -128, -44,
 -68, -123, -128, -128, -128, -128, -128,
 127, -114, -128, -128, -128, -128, -128,
 116, -95, 40, -128, -128, -128, -128,
 -128, 110, -125, -128, 78, -69, -128,
 127, -54, 127, 127, -128, -128, -128,
 -128, -128, -1, 127, -128, -128, -128,

/* Function parameters : 4 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
0, 8, 14, 16, 98, 8,

/* Image data : 4 */
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,

/* mask : 4 */
 -128, -128, -128, -128, 125, -128, -44,
 -68, -123, -128, -128, -128, -128, -128,
 127, -114, -128, -128, -128, -128, -128,
 116, -95, 40, -128, -128, -128, -128,
 -128, 110, -125, -128, 78, -69, -128,
 127, -54, 127, 127, -128, -128, -128,
 -128, -128, -1, 127, -128, -128, -128,

/* Function parameters : 5 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
1, 40, 46, 16, 322, 40,

/* Image data : 5 */
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

/* mask : 5 */
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,

/* Function parameters : 6 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
0, 4, 10, 16, 70, 4,

/* Image data : 6 */
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

/* mask : 6 */
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,

/* Function parameters : 7 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
1, 12, 18, 11, 126, 12,

/* Image data : 7 */
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

/* mask : 7 */
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,
 127, 127, 127, 127, 127, 127, 127,

/* Function parameters : 8 */
/* use_for_cycle_estimate, width, pitch, shift, in_size, out_size */
1, 14, 20, 16, 140, 14,

/* Image data : 8 */
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,

/* mask : 8 */
 -128, -128, -128, -128, -128, -128, -128,
 -128, -128, -128, -128, -128, -128, -128,
 -128, -128, -128, -128, -128, -128, -128,
 -128, -128, -128, -128, -128, -128, -128,
 -128, -128, -128, -128, -128, -128, -128,
 -128, -128, -128, -128, -128, -128, -128,
 -128, -128, -128, -128, -128, -128, -128,
};

int testcases = 8;
