/* ======================================================================== *
 * IMGLIB -- TI Image and Video Processing Library                          *
 *                                                                          *
 *                                                                          *
 * Copyright (C) 2012 Texas Instruments Incorporated - http://www.ti.com/   *
 *                                                                          *
 *                                                                          *
 *  Redistribution and use in source and binary forms, with or without      *
 *  modification, are permitted provided that the following conditions      *
 *  are met:                                                                *
 *                                                                          *
 *    Redistributions of source code must retain the above copyright        *
 *    notice, this list of conditions and the following disclaimer.         *
 *                                                                          *
 *    Redistributions in binary form must reproduce the above copyright     *
 *    notice, this list of conditions and the following disclaimer in the   *
 *    documentation and/or other materials provided with the                *
 *    distribution.                                                         *
 *                                                                          *
 *    Neither the name of Texas Instruments Incorporated nor the names of   *
 *    its contributors may be used to endorse or promote products derived   *
 *    from this software without specific prior written permission.         *
 *                                                                          *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   *
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    *
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 * ======================================================================== */

int in_data[] = {
/* Test data for kernel size : 11 x 11 
 * kernel size */
 11,
/* Alignment data.
 * 0 = double word, 4 = word, 2 = half word, 1 = byte alignment respectively.
 * src align, mask align, dst align */
2, 2, 0,

/* Function parameters : 1 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
0, 2, 12, 13, 1, 132, 2,

/* Image data : 1 */
 5922, -13139, -18818, -3893, -3329, 734, -11470, -24399, -13048, -25514, 10443, 23722,
 -18128, -31820, 6739, -30362, 19279, 21135, 26017, -20263, -14408, -14850, 16396, -27988,
 -3095, -31140, 16604, -25709, 12465, 7653, 16069, 24657, 7659, -30891, -3306, 23798,
 10834, 8651, 8557, -19117, -21978, -30471, 2343, 22422, 16558, -16394, 6622, 3418,
 -30429, -31255, -27685, 21185, -16864, -32349, -7789, 7654, 29299, -20262, 23731, -22422,
 30451, -24757, 8637, -7688, 6892, -5543, 31371, -10506, -10653, -10032, -9416, -15605,
 20433, 3822, 2422, 22667, -31959, 25363, 21630, -16624, 2504, 18860, 11174, 4031,
 3054, 12885, 5740, 5429, -6379, 30861, 5187, -25678, 15248, -17559, -20779, -9177,
 5556, -32103, 107, 26798, -197, 32756, 11557, -12973, 24750, -1578, 8330, 26048,
 -17341, 1688, 24583, 26488, -28652, -30004, -3205, -2072, 12378, 28411, 17514, 15744,
 -10155, -9480, 22004, -261, 1821, 19149, -4209, -19326, 22104, 16487, 32697, -17937,

/* mask : 1 */
 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22,
 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33,
 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44,
 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66,
 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77,
 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88,
 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99,
 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110,
 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,

/* Function parameters : 2 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
1, 30, 40, 5, 0, 440, 30,

/* Image data : 2 */
 -7776, 16681, 9258, 31178, 25877, -3334, -15840, 8698, -30139, 9764, 22931, 25198, -270, -2359, -12287, -28902, 25802, -112, 28302, -5369, 2814, 13821, 14283, -12928, -29056, -18460, -1912, 28142, -29550, 25906, -18019, -22690, -7281, -27577, -15054, 202, -3073, 8329, -10217, 13899,
 -9378, -10549, 16347, -18716, 15928, -4658, -14923, -29853, -10575, -4888, -15870, 13364, -14905, 490, -198, -852, 3996, 19276, 7444, 13419, -14302, 28609, -12237, -22040, 31865, -5712, -18291, 4448, -16687, -24231, -9939, -4212, -11513, -19257, 26662, -6766, -1619, 4585, -11065, 30454,
 5908, -25289, 15035, 5828, -16965, 22533, 1894, 7324, 2886, -27958, -1521, 15150, -30757, -28555, 7918, -30055, -21421, -32446, -1285, 17852, 18906, -9999, -11459, -12831, -5941, 15477, 16705, -22451, 29172, -3671, 14704, -17570, 28953, -31320, 30543, -9900, -4712, -2790, 27118, 4659,
 6164, -31365, -14006, -18164, 18512, -25859, -21472, 9494, 11732, -162, -6930, 17170, 17066, 3911, -20036, 12203, 25927, -3090, -29661, 10184, -30137, -17604, 20628, 22761, 22304, 7450, 12654, 29841, 19941, -26868, -8203, 9087, 9737, -8317, -13773, 6039, -24141, -27904, -27222, -10302,
 -21548, 19855, 5032, -7654, 27547, 28686, 32662, -10197, -16575, 31551, -19532, 23080, -18051, -69, -18885, 28454, 2942, 28144, 19874, -12066, 17792, 16245, 7279, 14998, 481, -20435, 7795, -7752, 5175, -20097, 22309, 19809, 4079, -2708, -5472, -18575, -11553, -10636, -7584, -5693,
 -13235, -4061, 30547, -384, 28413, -26872, 27826, -10011, 21318, 32291, -11539, 563, -22959, 26701, -1731, 16913, 28964, -14266, -19154, -30077, -16947, 7331, -15261, 15715, 27751, 26749, 6788, 5745, 10447, 6637, 20018, 10835, 9230, -30420, -29108, 15967, 8714, 28321, 9430, -1888,
 -13584, -22797, -10376, -27860, -17267, -25231, 4915, -16744, 13873, 8086, -7314, 17156, 3414, -30585, 9999, 31862, -10292, 22774, -14504, -19642, -4498, 531, 10101, 16769, -11895, -3892, -13361, 22850, 15621, 8055, -12640, -23309, 1464, -27960, 8566, -11764, -24489, -2169, 18513, -5084,
 16260, -20173, 4527, 8862, -15279, 19574, -27774, -6335, -10849, -27255, 16040, -19500, -22816, 26100, 16575, 14194, -27750, 26109, 18910, -24447, 25732, 11610, 32637, 28061, 29642, -16186, 26506, -8522, 11387, -19028, -30169, 13707, 27607, -26848, -19710, -969, -14635, -9747, -22436, 14403,
 -4562, -25419, -7292, -26411, -27632, -13160, 21198, 25263, -26364, 27222, 29944, 4658, -15528, 29084, -16005, 9272, 25238, -21213, 28262, 28880, 1138, -28711, -3787, 19039, -8232, -5403, -27560, -26858, 22298, 12844, -145, 7448, -5294, -10919, 15528, -26068, -9420, 19519, 12153, -14213,
 -3105, 19748, -8269, -9805, -16625, 3924, 25017, -9538, -3355, 6772, 24259, -29973, -13252, -25946, 25445, -10050, -32555, -12421, -6491, 19678, -16418, 2626, -8087, -27238, -14097, 24418, 8786, 3237, 29167, -11087, -14454, 7237, 15998, -9240, 6958, -23750, 18308, -18592, -18854, -1332,
 -13639, 26450, 31777, -28023, 32122, 25883, -14002, -11591, -22491, -15510, 28942, 11526, -31893, 845, 31528, -29598, 12981, 31189, 29635, 27736, -23793, 21779, 5844, -15884, -23229, 2421, 17163, 15533, 7422, -15224, 15163, -6945, -16461, 31085, 25326, 13850, 8696, -601, -8293, 30756,

/* mask : 2 */
 76, 3590, -1909, 2243, -2473, -3602, -3787, 204, 42, 1720, -2840,
 2666, -2622, 313, -3246, -823, -55, -3879, 3548, -1491, 3148, -3975,
 -603, -131, -358, 3739, 2889, -1286, 3296, -3748, 1261, -20, -2693,
 172, 338, -553, -366, 3487, -4086, 3781, 2761, 3360, 431, -4013,
 587, 1580, -3420, -3054, 3280, 879, 3663, -45, 3531, 1038, -1165,
 1906, 955, -2691, 293, -1887, 2689, 3813, 1901, 2529, 1807, -2916,
 1337, 619, -1050, 1675, 3869, 2011, 1334, -927, -3001, 3539, 175,
 -863, 3375, -1829, 943, -2393, -178, -1209, -3675, 507, 1241, 1462,
 386, -3914, -2204, 2618, 3411, 1247, -3223, -838, -2955, 1088, -768,
 2862, -1035, 3966, 2352, -3888, 1867, -2957, 3078, -3641, 2274, 3943,
 -2951, -1943, 4018, 2005, 2157, -1129, 2087, 3792, 3907, -2105, 2327,

/* Function parameters : 3 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
0, 10, 20, 5, 1, 220, 10,

/* Image data : 3 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* mask : 3 */
 28040, -406, -10831, 29786, -19903, -8285, 24124, -24503, -1255, 15715, 10778,
 4378, -11774, -29436, 2379, 7428, 334, -15109, 10375, -13480, 7810, 2311,
 -14610, 4727, 23134, -16562, -20085, -129, -3843, 25975, 29623, -6365, -20092,
 16696, -20429, -10193, -7404, 12933, -9934, 22856, -23214, -23210, -22767, 26909,
 -2095, -12864, -5532, 25389, 7389, -5754, 15941, 17563, 13647, -7110, -25447,
 -6628, 6335, -21618, -1009, 17294, 5660, -30270, 6481, 10949, -3640, 28460,
 -22890, -18690, -6918, -18225, 3091, -12920, -22685, 18696, -18777, 29727, -29159,
 -3313, 20286, 28943, -32189, -3620, -30610, -10706, 27871, -25351, -22309, -11390,
 3478, 569, -8298, -2373, 20907, -14562, -25860, 4688, 13103, 23146, -1553,
 -20599, 26049, 17789, 2355, -9695, -25056, 24718, 2960, 14285, -31779, 13974,
 -18952, -23308, -25978, -7783, 8511, -14551, 27735, -12764, -27228, 18876, -2642,

/* Function parameters : 4 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
0, 8, 18, 5, 0, 198, 8,

/* Image data : 4 */
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

/* mask : 4 */
 28040, -406, -10831, 29786, -19903, -8285, 24124, -24503, -1255, 15715, 10778,
 4378, -11774, -29436, 2379, 7428, 334, -15109, 10375, -13480, 7810, 2311,
 -14610, 4727, 23134, -16562, -20085, -129, -3843, 25975, 29623, -6365, -20092,
 16696, -20429, -10193, -7404, 12933, -9934, 22856, -23214, -23210, -22767, 26909,
 -2095, -12864, -5532, 25389, 7389, -5754, 15941, 17563, 13647, -7110, -25447,
 -6628, 6335, -21618, -1009, 17294, 5660, -30270, 6481, 10949, -3640, 28460,
 -22890, -18690, -6918, -18225, 3091, -12920, -22685, 18696, -18777, 29727, -29159,
 -3313, 20286, 28943, -32189, -3620, -30610, -10706, 27871, -25351, -22309, -11390,
 3478, 569, -8298, -2373, 20907, -14562, -25860, 4688, 13103, 23146, -1553,
 -20599, 26049, 17789, 2355, -9695, -25056, 24718, 2960, 14285, -31779, 13974,
 -18952, -23308, -25978, -7783, 8511, -14551, 27735, -12764, -27228, 18876, -2642,

/* Function parameters : 5 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
1, 28, 38, 8, 1, 418, 28,

/* Image data : 5 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* mask : 5 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* Function parameters : 6 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
0, 4, 14, 8, 0, 154, 4,

/* Image data : 6 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* mask : 6 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* Function parameters : 7 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
1, 12, 22, 8, 1, 242, 12,

/* Image data : 7 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* mask : 7 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* Function parameters : 8 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
1, 14, 24, 8, 0, 264, 14,

/* Image data : 8 */
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

/* mask : 8 */
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,
 -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767, -32767,

/* Function parameters : 9 */
/* use_for_cycle_estimate, width, pitch, shift round, in_size, out_size */
1, 16, 26, 8, 1, 286, 16,

/* Image data : 9 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* mask : 9 */
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
};

int testcases = 9;
