* ======================================================================== *
* IMGLIB -- TI Image and Video Processing Library                          *
*                                                                          *
*                                                                          *
* Copyright (C) 2012 Texas Instruments Incorporated - http://www.ti.com/   *
*                                                                          *
*                                                                          *
*  Redistribution and use in source and binary forms, with or without      *
*  modification, are permitted provided that the following conditions      *
*  are met:                                                                *
*                                                                          *
*    Redistributions of source code must retain the above copyright        *
*    notice, this list of conditions and the following disclaimer.         *
*                                                                          *
*    Redistributions in binary form must reproduce the above copyright     *
*    notice, this list of conditions and the following disclaimer in the   *
*    documentation and/or other materials provided with the                *
*    distribution.                                                         *
*                                                                          *
*    Neither the name of Texas Instruments Incorporated nor the names of   *
*    its contributors may be used to endorse or promote products derived   *
*    from this software without specific prior written permission.         *
*                                                                          *
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   *
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    *
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
* ======================================================================== *

* ######################################################################## *
* #  TI Disclaimer: This kernel is obsolete. It is provided here for     # *
* #  backward compatibility.                                             # *
* ######################################################################## *

                .if     __TI_EABI__
                    .asg    IMG_sad_8x8,  _IMG_sad_8x8
                .endif

                .sect ".text:optimized"
                .global _IMG_sad_8x8

_IMG_sad_8x8:  
* ===================== SYMBOLIC REGISTER ASSIGNMENTS ===================== *
        .asg            A0,         A_p
        .asg            A1,         A_i
        .asg            A2,         A_s0
        .asg            A3,         A_k1
        .asg            A4,         A_srcImg
        .asg            A4,         A_retval
        .asg            A5,         A_sad
        .asg            A6,         A_pitch
        .asg            A6,         A_s3210
        .asg            A7,         A_d7654
        .asg            A7,         A_s7654
        .asg            A8,         A_r3210
        .asg            A8,         A_s1
        .asg            A9,         A_d3210
        .asg            A9,         A_r7654
        .asg            B3,         B_retaddr
        .asg            B4,         B_refImg
        .asg            B5,         B_pitch
        .asg            B6,         B_r3210
        .asg            B7,         B_d7654
        .asg            B7,         B_r7654
        .asg            B8,         B_d3210
        .asg            B8,         B_s3210
        .asg            B9,         B_s7654
        .asg            B16,        B_sad
        .asg            B17,        B_srcImg
        .asg            B18,        B_s2
        .asg            B19,        B_s3
* ========================================================================= *
* =========================== PIPE LOOP PROLOG ============================ *
        LDNDW   .D2T2   *B_refImg,              B_r7654:B_r3210 ;[ 1,1] 
||      B       .S2     loop
||      MVK     .S1     0x0101,     A_k1
||      ADD     .L2X    A_srcImg,   8,          B_srcImg

        LDDW    .D2T1   *B_srcImg++(16),        A_s7654:A_s3210 ;[ 2,1] 
||      LDDW    .D1T2   *A_srcImg++(16),        B_s7654:B_s3210 ;[ 2,1] 
||      MV      .L2X    A_pitch,    B_pitch
||      PACK2   .L1     A_k1,       A_k1,       A_k1

        LDNDW   .D2T1   *++B_refImg(B_pitch),   A_r7654:A_r3210 ;[ 3,1] 
||      ZERO    .L2     B_sad
||      ZERO    .L1     A_sad
||      MVK     .S1     3,          A_i

* =========================== PIPE LOOP KERNEL ============================ *
loop:
  [!A_i]ADD     .L1     A_sad,      A_s1,       A_sad           ;[13,1] 
||[!A_i]ADD     .S2     B_sad,      B_s3,       B_sad           ;[13,1] 
||[ A_i]B       .S1     loop                                    ;[10,2] 
||      DOTPU4  .M1     A_d3210,    A_k1,       A_s0            ;[10,2] 
||      SUBABS4 .L2     B_s7654,    B_r7654,    B_d7654         ;[ 7,3] 
||      LDNDW   .D2T2   *++B_refImg(B_pitch),   B_r7654:B_r3210 ;[ 1,5] 

  [!A_i]ADD     .S2     B_sad,      B_s2,       B_sad           ;[14,1] 
||      DOTPU4  .M2X    B_d7654,    A_k1,       B_s3            ;[ 8,3] 
||      SUBABS4 .L1     A_s7654,    A_r7654,    A_d7654         ;[ 8,3] 
||      SUBABS4 .L2     B_s3210,    B_r3210,    B_d3210         ;[ 8,3] 
||      LDDW    .D2T1   *B_srcImg++(16),        A_s7654:A_s3210 ;[ 2,5] 
||      LDDW    .D1T2   *A_srcImg++(16),        B_s7654:B_s3210 ;[ 2,5] 

  [ A_i]SUB     .D1     A_i,        1,          A_i             ;[15,1] 
||[!A_i]ADD     .S1     A_sad,      A_s0,       A_sad           ;[15,1] 
||      DOTPU4  .M1     A_d7654,    A_k1,       A_s1            ;[ 9,3] 
||      DOTPU4  .M2X    B_d3210,    A_k1,       B_s2            ;[ 9,3] 
||      SUBABS4 .L1     A_s3210,    A_r3210,    A_d3210         ;[ 9,3] 
||      LDNDW   .D2T1   *++B_refImg(B_pitch),   A_r7654:A_r3210 ;[ 3,5] 

* =========================== PIPE LOOP EPILOG ============================ *
        ADD     .L1     A_sad,      A_s1,       A_sad           ;[13,4] 
||      ADD     .S2     B_sad,      B_s3,       B_sad           ;[13,4] 
||      DOTPU4  .M1     A_d3210,    A_k1,       A_s0            ;[10,5] 

        ADD     .L2     B_sad,      B_s2,       B_sad           ;[14,4] 
||      RET     .S2     B_retaddr

        ADD     .S1     A_sad,      A_s0,       A_sad           ;[15,4] 

        ADD     .L1     A_sad,      A_s1,       A_sad           ;[13,5] 
||      ADD     .S2     B_sad,      B_s3,       B_sad           ;[13,5] 

        ADD     .S2     B_sad,      B_s2,       B_sad           ;[14,5] 

        ADD     .S1     A_sad,      A_s0,       A_sad           ;[15,5] 

        ADD     .S1X    A_sad,      B_sad,      A_retval
* ========================================================================= *

* ========================================================================= *
*   End of file: IMG_sad_8x8.s                                              *
* ========================================================================= *
