/* ======================================================================== *
 * IMGLIB -- TI Image and Video Processing Library                          *
 *                                                                          *
 *                                                                          *
 * Copyright (C) 2012 Texas Instruments Incorporated - http://www.ti.com/   *
 *                                                                          *
 *                                                                          *
 *  Redistribution and use in source and binary forms, with or without      *
 *  modification, are permitted provided that the following conditions      *
 *  are met:                                                                *
 *                                                                          *
 *    Redistributions of source code must retain the above copyright        *
 *    notice, this list of conditions and the following disclaimer.         *
 *                                                                          *
 *    Redistributions in binary form must reproduce the above copyright     *
 *    notice, this list of conditions and the following disclaimer in the   *
 *    documentation and/or other materials provided with the                *
 *    distribution.                                                         *
 *                                                                          *
 *    Neither the name of Texas Instruments Incorporated nor the names of   *
 *    its contributors may be used to endorse or promote products derived   *
 *    from this software without specific prior written permission.         *
 *                                                                          *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   *
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    *
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 * ======================================================================== */

int in_data[] = {
/* Alignment data.
 * 0 = double word, 4 = word, 2 = half word, 1 = byte alignment respectively.
 * src align, dst align */
0, 0,

/* Function parameters : 1 */
/* use_for_cycle_estimate, cols, in_size, out_size */
0, 4, 12, 4,

/* Input data : 1 */
 5922, 10834, 20433, -17341,
 -18128, -30429, 3054, -10155,
 -3095, 30451, 5556, -13139,

/* Function parameters : 2 */
/* use_for_cycle_estimate, cols, in_size, out_size */
1, 28, 84, 28,

/* Input data : 2 */
 -31820, -31255, 12885, -9480, 16604, 8637, 107, -3893, -19117, 22667, 26488, 19279, -16864, -6379, 1821, 7653, -5543, 32756, -11470, 2343, 21630, -3205, -20263, 7654, -25678, -19326, 7659, -10653,
 -31140, -24757, -32103, -18818, 8557, 2422, 24583, -30362, 21185, 5429, -261, 12465, 6892, -197, 734, -30471, 25363, -30004, 26017, -7789, 5187, -4209, 24657, -10506, -12973, -13048, 16558, 2504,
 8651, 3822, 1688, 6739, -27685, 5740, 22004, -25709, -7688, 26798, -3329, -21978, -31959, -28652, 21135, -32349, 30861, 19149, 16069, 31371, 11557, -24399, 22422, -16624, -2072, -14408, 29299, 15248,

/* Function parameters : 3 */
/* use_for_cycle_estimate, cols, in_size, out_size */
1, 12, 36, 12,

/* Input data : 3 */
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,
 -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768, -32768,

/* Function parameters : 4 */
/* use_for_cycle_estimate, cols, in_size, out_size */
1, 24, 72, 24,

/* Input data : 4 */
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,
 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767, 32767,

/* Function parameters : 5 */
/* use_for_cycle_estimate, cols, in_size, out_size */
1, 128, 384, 128,

/* Input data : 5 */
  30249, 11799, 3428, -17824, 23356, 7120, 6003, -3775, 2125, -10713, -6301, 3456, -16833, 28552, -21246, -32689, 8209, -13931, 17197, 9538, -10010, -19781, 12740, 2116, 26637, 11235, -29037, 12231, 14871, -25158, -14102, -20593, 28370, -22810, -24175, 7512, 18988, 4545, 9327, 30872, -14492, 29973, -21456, 23499, 14758, 20357, -26870, -28796, 1924, 18942, 16530, -15081, 13789, 22961, -16032, 5552, 5547, -20252, 21402, -11921, 4652, -1568, -30609, -3187, -8894, 24345, 31119, -5644, 16959, 18425, 19809, -108, -27968, -20069, -30200, 3855, 1170, 30304, 28507, -6797, 16819, 2298, -29396, 2029, -4458, -31675, -1411, 10601, -19777, 24926, -21022, 22576, 24719, 20577, -10857, 13243, 29760, -12379, -26674, 27199, -30777, -24427, -9561, -4158, -26798, 22372, -727, 2411, -2541, -22179, -4371, -21039, -11276, 31521, -31219, -6065, -8585, 29897, 23390, 31391, 12142, 26213, -10075, 20906, 19996, -159, 21701, 7740, 
  17198, 13497, -18474, -8463, -6394, 26883, -10973, 26500, 14188, -20466, 3183, -14758, -22665, 20887, -9151, -12031, 2822, 109, 4984, -24693, -26729, 11290, -15939, -14458, -7033, 22097, -3256, 14381, -8268, -28990, 6224, -20117, -7165, -6743, -4257, -32048, -17343, -28744, -18267, 22700, 16162, 7881, -26847, 26940, -17702, -6302, -11735, 14791, 21626, -11938, -25568, 1615, -12330, 26978, -26957, 29367, -14083, -3766, 11591, -23999, -21642, 26745, -29238, -7691, 2120, -11227, -27789, -12508, 32454, -19936, -4966, 20250, 5963, -4432, 29250, -20720, 32391, 11727, -1345, 13440, 32472, 30400, -12822, 26294, 2796, 19721, -15936, -21653, -19984, -1894, 30731, 7558, 18668, 26112, 6334, -8031, 2806, -28100, -2393, 9355, -19106, -32201, 18379, -29543, 6163, 23410, -18330, 17178, 9131, 14132, 25182, 8738, 19855, -24443, 7041, 25171, -19114, -24640, -29924, -14204, 26834, -20091, -5333, 8187, -28362, 16721, -22511, 28324, 
 -32286, 9511, 17850, 25620, -11926, 26811, 23138, -30594, -21017, -11670, -29574, -16941, 29912, 14959, -20395, 13082, -3995, 17141, 16231, 288, -23079, -4488, -32128, 29244, -31139, 30900, 5405, 9833, 5347, 31442, 30288, -10378, -14862, -8210, -26771, 4801, -3407, -243, 22089, 393, -17241, 6571, -16039, 13083, 4984, 32010, 748, 3706, 23512, -3132, -25576, 30976, -13667, 9128, 22168, -28768, 21478, -6985, -19163, 11237, -23091, 3419, 19993, 18982, 13871, 9838, 5703, -15477, -20541, 32267, 14999, -9404, 26882, 16329, 17280, -134, 23256, -6324, -17577, 3838, 30306, -25190, 5255, 2658, 13921, -23429, -8579, -14498, -11348, -6293, -6065, -8086, -2297, -4637, 26345, 15398, 2628, -20842, -32156, -32675, -2951, 14882, -4151, -29515, -16968, 30383, -17943, -9990, 27351, 5095, -7009, 8127, 32734, -17548, -25506, 3154, -3870, -1916, 12558, -24001, 7266, 16674, -22563, 15634, 29543, 15886, -2798, 21960, 
};

int testcases = 5;
