/* ======================================================================== *
 * IMGLIB -- TI Image and Video Processing Library                          *
 *                                                                          *
 *                                                                          *
 * Copyright (C) 2012 Texas Instruments Incorporated - http://www.ti.com/   *
 *                                                                          *
 *                                                                          *
 *  Redistribution and use in source and binary forms, with or without      *
 *  modification, are permitted provided that the following conditions      *
 *  are met:                                                                *
 *                                                                          *
 *    Redistributions of source code must retain the above copyright        *
 *    notice, this list of conditions and the following disclaimer.         *
 *                                                                          *
 *    Redistributions in binary form must reproduce the above copyright     *
 *    notice, this list of conditions and the following disclaimer in the   *
 *    documentation and/or other materials provided with the                *
 *    distribution.                                                         *
 *                                                                          *
 *    Neither the name of Texas Instruments Incorporated nor the names of   *
 *    its contributors may be used to endorse or promote products derived   *
 *    from this software without specific prior written permission.         *
 *                                                                          *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR   *
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT    *
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 * ======================================================================== */

int in_data[] = {
/* Alignment data.
 * 0 = dooble word, 4 = word, 2 = half word, 1 = byte alignment respectively.
 * src align, dst align */
0, 0,

/* Function parameters : 1 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
0, 1, 8, 8, 256,

/* Input data.*/
 151, 57, 116, 170, 9, 247, 208, 140,

/* Function parameters : 2 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
1, -1, 8, 200, 256,

/* Input data.*/

  /* r 1, c 1:100 */  150, 60, 88, 77, 4, 6, 162, 6, 31, 143, 178, 3, 135, 91, 54, 154, 193, 161, 20, 162, 137, 150, 128, 224, 214, 113, 9, 28, 53, 211, 98, 217, 149, 233, 231, 127, 115, 203, 177, 42, 62, 155, 3, 103, 127, 16, 135, 131, 211, 158, 9, 2, 106, 227, 249, 256, 11, 203, 83, 230, 191, 137, 98, 251, 212, 148, 173, 115, 112, 33, 49, 224, 216, 158, 87, 63, 28, 77, 120, 53, 77, 72, 158, 193, 242, 86, 138, 188, 225, 176, 214, 28, 70, 7, 64, 49, 89, 202, 59, 122,
  /* r 1, c 101:200 */  239, 192, 169, 192, 115, 154, 221, 91, 172, 47, 161, 196, 256, 221, 19, 221, 141, 40, 67, 144, 92, 230, 190, 58, 130, 240, 68, 198, 51, 15, 10, 134, 129, 182, 39, 211, 46, 138, 27, 102, 126, 7, 239, 81, 226, 4, 109, 124, 117, 245, 218, 88, 231, 11, 167, 127, 44, 133, 139, 111, 117, 237, 0, 246, 214, 233, 141, 3, 146, 177, 21, 33, 231, 155, 242, 127, 238, 160, 92, 188, 158, 44, 137, 69, 212, 247, 187, 207, 184, 37, 170, 147, 95, 180, 249, 191, 170, 99, 34, 239,


/* Function parameters : 3 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
1, 1, 8, 2400, 256,

/* Input data.*/

  /* r 1, c 1:100 */  133, 101, 233, 71, 157, 53, 122, 90, 13, 144, 167, 174, 140, 6, 59, 210, 235, 167, 27, 102, 36, 162, 104, 217, 96, 252, 202, 7, 186, 36, 224, 14, 199, 251, 36, 67, 254, 191, 195, 93, 193, 247, 250, 62, 201, 98, 91, 151, 152, 44, 76, 75, 192, 110, 116, 75, 193, 87, 29, 5, 206, 112, 39, 49, 29, 205, 231, 164, 192, 187, 73, 148, 247, 87, 146, 100, 96, 252, 250, 55, 151, 57, 98, 127, 19, 163, 25, 90, 19, 229, 190, 62, 200, 236, 239, 61, 68, 20, 63, 253,
  /* r 1, c 101:200 */  115, 110, 216, 27, 240, 23, 29, 204, 77, 143, 229, 66, 70, 135, 44, 256, 237, 147, 20, 211, 226, 73, 162, 11, 157, 165, 88, 89, 63, 103, 227, 91, 83, 10, 87, 139, 174, 63, 211, 182, 86, 25, 115, 40, 166, 109, 19, 127, 251, 254, 160, 22, 234, 154, 67, 218, 66, 122, 101, 52, 83, 99, 191, 245, 223, 241, 226, 180, 187, 195, 218, 130, 195, 52, 146, 11, 173, 127, 70, 8, 195, 57, 38, 141, 39, 67, 76, 3, 119, 130, 16, 143, 128, 232, 9, 230, 242, 27, 131, 80,
  /* r 1, c 201:300 */  127, 159, 50, 54, 121, 167, 193, 65, 227, 251, 15, 125, 11, 176, 239, 194, 252, 183, 164, 89, 12, 229, 144, 44, 229, 139, 241, 88, 20, 227, 1, 179, 128, 203, 1, 116, 238, 72, 217, 230, 45, 79, 250, 239, 157, 123, 12, 206, 53, 71, 202, 238, 103, 244, 107, 180, 198, 168, 81, 11, 51, 33, 241, 205, 236, 139, 72, 202, 10, 197, 62, 110, 229, 132, 64, 35, 182, 240, 89, 59, 191, 157, 130, 173, 16, 138, 213, 184, 80, 83, 209, 156, 68, 167, 255, 113, 96, 151, 78, 42,
  /* r 1, c 301:400 */  78, 217, 187, 189, 194, 238, 202, 22, 66, 15, 252, 105, 215, 130, 236, 82, 244, 96, 73, 37, 56, 106, 188, 157, 48, 232, 113, 65, 107, 223, 137, 121, 57, 193, 177, 158, 155, 76, 232, 20, 162, 195, 238, 145, 40, 245, 98, 150, 217, 95, 23, 141, 189, 13, 63, 242, 206, 148, 169, 189, 172, 215, 242, 157, 229, 33, 114, 23, 49, 154, 159, 54, 178, 85, 69, 58, 89, 185, 96, 215, 206, 79, 10, 127, 72, 187, 39, 112, 59, 163, 205, 170, 37, 182, 157, 156, 101, 100, 83, 241,
  /* r 1, c 401:500 */  166, 144, 164, 134, 236, 107, 190, 64, 20, 53, 6, 96, 117, 9, 19, 23, 85, 92, 249, 69, 232, 247, 74, 107, 14, 161, 51, 189, 155, 227, 129, 102, 89, 152, 55, 190, 82, 124, 26, 35, 182, 116, 122, 110, 34, 83, 162, 32, 71, 91, 200, 162, 161, 146, 117, 19, 86, 239, 120, 90, 204, 55, 126, 88, 85, 234, 22, 98, 165, 200, 40, 175, 54, 96, 182, 247, 146, 88, 106, 121, 108, 184, 72, 123, 248, 238, 126, 86, 244, 50, 96, 222, 32, 123, 189, 170, 145, 82, 13, 137,
  /* r 1, c 501:600 */  157, 129, 69, 169, 75, 159, 137, 71, 146, 218, 63, 50, 127, 113, 229, 244, 103, 50, 193, 48, 88, 99, 179, 89, 217, 37, 37, 39, 233, 120, 78, 106, 227, 157, 106, 190, 197, 181, 100, 29, 102, 153, 44, 124, 196, 150, 10, 153, 171, 114, 239, 39, 55, 101, 57, 140, 78, 39, 201, 55, 244, 14, 115, 207, 241, 2, 114, 8, 86, 237, 29, 41, 84, 142, 130, 96, 119, 210, 71, 27, 146, 179, 218, 122, 48, 230, 197, 137, 90, 30, 225, 140, 184, 4, 183, 54, 37, 27, 98, 161,
  /* r 1, c 601:700 */  71, 236, 78, 22, 202, 118, 8, 203, 140, 188, 63, 210, 7, 122, 7, 74, 113, 42, 203, 177, 50, 221, 61, 124, 187, 42, 179, 104, 93, 201, 129, 188, 69, 35, 27, 170, 38, 217, 183, 70, 246, 83, 158, 202, 184, 149, 124, 76, 197, 161, 125, 205, 147, 206, 116, 138, 49, 229, 108, 57, 60, 171, 225, 145, 235, 110, 151, 252, 221, 100, 80, 182, 164, 14, 126, 135, 16, 5, 97, 187, 24, 188, 169, 169, 163, 101, 26, 248, 52, 204, 132, 164, 30, 228, 49, 255, 216, 173, 182, 190,
  /* r 1, c 701:800 */  164, 29, 153, 100, 151, 217, 170, 192, 190, 193, 124, 238, 13, 117, 89, 1, 75, 137, 176, 35, 157, 208, 21, 23, 84, 231, 83, 116, 233, 85, 92, 252, 11, 106, 67, 204, 151, 68, 238, 159, 231, 64, 13, 29, 108, 70, 72, 141, 226, 203, 51, 108, 23, 254, 109, 192, 179, 29, 86, 195, 135, 82, 239, 137, 25, 73, 12, 249, 100, 190, 148, 199, 40, 134, 229, 165, 185, 69, 88, 204, 184, 21, 58, 235, 13, 136, 233, 10, 96, 241, 129, 144, 108, 241, 44, 172, 30, 8, 85, 81,
  /* r 1, c 801:900 */  144, 204, 127, 246, 208, 51, 43, 194, 116, 74, 198, 109, 90, 164, 12, 201, 83, 56, 113, 174, 88, 19, 129, 13, 213, 210, 108, 180, 116, 64, 104, 210, 54, 8, 250, 72, 34, 181, 39, 51, 235, 139, 178, 192, 239, 50, 232, 200, 6, 18, 159, 125, 225, 180, 44, 105, 207, 210, 253, 253, 238, 69, 26, 205, 108, 75, 89, 81, 21, 213, 142, 175, 204, 251, 175, 136, 221, 103, 218, 213, 29, 216, 54, 85, 85, 217, 201, 101, 155, 102, 234, 214, 238, 137, 139, 205, 27, 236, 229, 45,
  /* r 1, c 901:1000 */  251, 102, 7, 99, 175, 44, 167, 123, 65, 22, 123, 153, 208, 134, 223, 74, 38, 173, 252, 234, 178, 141, 148, 256, 254, 67, 172, 72, 121, 199, 67, 147, 97, 67, 251, 185, 60, 174, 245, 56, 233, 104, 92, 176, 1, 134, 219, 69, 16, 116, 188, 66, 9, 23, 75, 178, 165, 72, 247, 120, 31, 126, 179, 155, 214, 42, 251, 184, 228, 211, 28, 10, 21, 155, 7, 248, 217, 197, 132, 153, 234, 8, 192, 159, 176, 178, 106, 72, 45, 66, 139, 124, 185, 78, 87, 206, 123, 126, 61, 71,
  /* r 1, c 1001:1100 */  65, 163, 116, 238, 142, 177, 162, 25, 104, 161, 23, 187, 157, 109, 231, 145, 220, 29, 88, 169, 201, 47, 113, 192, 151, 152, 146, 26, 183, 177, 76, 103, 253, 18, 251, 29, 163, 77, 250, 252, 13, 102, 191, 69, 101, 182, 217, 149, 51, 141, 218, 132, 6, 86, 116, 251, 65, 243, 217, 11, 113, 250, 50, 250, 162, 174, 118, 72, 12, 181, 206, 58, 32, 83, 158, 16, 72, 142, 72, 54, 210, 82, 9, 214, 112, 81, 25, 20, 29, 32, 26, 32, 155, 174, 100, 26, 97, 239, 41, 59,
  /* r 1, c 1101:1200 */  160, 3, 250, 133, 22, 123, 211, 220, 26, 213, 152, 43, 178, 249, 65, 83, 30, 176, 82, 210, 60, 49, 211, 3, 200, 79, 18, 156, 218, 1, 182, 183, 215, 208, 125, 14, 228, 190, 130, 214, 129, 156, 225, 100, 145, 30, 118, 228, 224, 240, 231, 218, 205, 146, 75, 89, 183, 199, 179, 151, 116, 239, 66, 208, 27, 96, 5, 28, 27, 77, 243, 143, 218, 201, 121, 183, 210, 139, 172, 115, 48, 222, 91, 80, 116, 152, 109, 115, 246, 171, 53, 24, 128, 113, 177, 36, 219, 145, 3, 49,
  /* r 1, c 1201:1300 */  23, 224, 41, 73, 174, 5, 221, 194, 158, 20, 203, 182, 209, 132, 250, 218, 71, 255, 171, 57, 199, 65, 0, 32, 3, 138, 225, 243, 176, 159, 221, 63, 229, 34, 192, 237, 42, 8, 60, 4, 0, 159, 28, 105, 165, 53, 64, 34, 145, 246, 167, 200, 236, 195, 28, 107, 75, 138, 218, 18, 14, 24, 54, 85, 17, 35, 73, 36, 144, 56, 212, 46, 159, 221, 118, 230, 109, 229, 211, 176, 159, 111, 63, 141, 143, 32, 164, 255, 77, 126, 2, 123, 29, 219, 185, 235, 3, 21, 47, 105,
  /* r 1, c 1301:1400 */  73, 17, 59, 222, 70, 54, 135, 26, 33, 126, 228, 134, 55, 54, 231, 167, 227, 133, 32, 8, 210, 109, 77, 137, 109, 53, 237, 177, 87, 165, 220, 215, 151, 226, 123, 166, 214, 178, 12, 145, 223, 105, 144, 206, 43, 201, 132, 27, 156, 118, 252, 115, 77, 173, 208, 11, 195, 153, 139, 23, 36, 109, 11, 56, 19, 127, 36, 122, 172, 195, 132, 219, 48, 90, 181, 254, 12, 47, 157, 17, 99, 203, 24, 239, 94, 253, 232, 163, 193, 209, 33, 175, 38, 140, 174, 80, 81, 191, 91, 154,
  /* r 1, c 1401:1500 */  51, 207, 7, 60, 62, 181, 144, 11, 233, 109, 37, 231, 63, 30, 197, 58, 144, 169, 91, 75, 14, 48, 9, 106, 166, 1, 48, 191, 77, 41, 123, 184, 201, 155, 215, 10, 50, 13, 184, 163, 55, 73, 226, 132, 89, 184, 228, 60, 86, 68, 114, 52, 170, 240, 207, 184, 167, 125, 73, 39, 216, 176, 62, 209, 3, 116, 105, 23, 177, 68, 147, 108, 242, 156, 255, 15, 198, 102, 88, 47, 156, 38, 1, 162, 132, 193, 14, 153, 122, 98, 113, 203, 244, 163, 245, 98, 124, 117, 115, 45,
  /* r 1, c 1501:1600 */  34, 139, 20, 31, 189, 35, 205, 134, 237, 129, 191, 90, 252, 119, 109, 16, 77, 169, 84, 246, 50, 40, 130, 51, 103, 163, 16, 154, 224, 151, 202, 100, 84, 238, 235, 28, 203, 188, 56, 30, 84, 159, 6, 51, 225, 110, 120, 47, 64, 177, 202, 140, 252, 204, 232, 211, 70, 128, 211, 231, 172, 136, 250, 125, 140, 129, 64, 103, 249, 92, 60, 196, 70, 226, 44, 232, 5, 80, 137, 88, 130, 255, 246, 116, 253, 15, 29, 137, 93, 179, 41, 63, 6, 15, 115, 209, 90, 116, 184, 169,
  /* r 1, c 1601:1700 */  72, 125, 30, 3, 31, 59, 180, 80, 168, 226, 3, 182, 182, 116, 47, 82, 85, 77, 54, 29, 110, 153, 132, 133, 38, 225, 14, 136, 146, 244, 30, 173, 28, 155, 208, 44, 167, 228, 166, 144, 200, 183, 98, 96, 110, 154, 52, 252, 166, 21, 200, 115, 159, 48, 33, 189, 46, 184, 213, 142, 21, 138, 69, 130, 78, 137, 93, 180, 215, 130, 90, 216, 136, 96, 221, 37, 228, 127, 142, 146, 65, 190, 174, 68, 160, 242, 229, 151, 249, 133, 131, 145, 95, 102, 66, 149, 41, 42, 117, 25,
  /* r 1, c 1701:1800 */  235, 240, 210, 66, 189, 209, 49, 75, 227, 97, 193, 196, 200, 170, 105, 35, 95, 175, 35, 208, 22, 112, 185, 203, 216, 125, 133, 84, 91, 251, 165, 207, 240, 97, 176, 134, 215, 227, 132, 175, 44, 164, 250, 134, 80, 225, 189, 211, 183, 36, 10, 124, 112, 221, 87, 187, 115, 148, 88, 231, 172, 152, 156, 66, 226, 240, 100, 211, 223, 215, 65, 115, 233, 16, 22, 150, 0, 47, 108, 79, 59, 182, 125, 95, 174, 102, 25, 193, 60, 20, 87, 256, 130, 40, 91, 144, 94, 184, 44, 71,
  /* r 1, c 1801:1900 */  58, 170, 77, 95, 57, 47, 236, 64, 215, 26, 202, 218, 104, 190, 163, 220, 45, 233, 220, 162, 14, 80, 141, 58, 205, 6, 145, 68, 144, 115, 41, 11, 27, 28, 149, 139, 23, 21, 76, 95, 181, 197, 203, 16, 236, 47, 201, 234, 216, 150, 11, 188, 201, 68, 201, 100, 251, 148, 135, 159, 114, 160, 132, 21, 63, 66, 135, 222, 39, 232, 61, 98, 157, 221, 24, 197, 250, 104, 46, 243, 171, 223, 125, 41, 216, 254, 176, 51, 254, 198, 198, 180, 207, 8, 192, 118, 229, 131, 213, 41,
  /* r 1, c 1901:2000 */  89, 64, 195, 183, 64, 68, 140, 65, 251, 198, 239, 193, 233, 152, 50, 151, 173, 68, 228, 193, 202, 71, 161, 182, 158, 250, 130, 212, 253, 44, 213, 139, 239, 84, 198, 71, 202, 3, 202, 19, 196, 88, 157, 244, 71, 228, 22, 195, 219, 239, 80, 126, 94, 136, 72, 122, 159, 250, 114, 232, 214, 115, 57, 148, 147, 160, 109, 236, 42, 61, 70, 159, 135, 242, 67, 155, 30, 92, 246, 207, 174, 226, 92, 125, 185, 23, 214, 210, 144, 47, 124, 245, 197, 98, 137, 255, 23, 107, 184, 139,
  /* r 1, c 2001:2100 */  99, 68, 149, 107, 156, 162, 82, 235, 154, 134, 225, 202, 180, 203, 202, 183, 221, 238, 216, 26, 128, 166, 256, 228, 37, 128, 98, 6, 202, 44, 1, 4, 200, 129, 204, 219, 76, 75, 152, 93, 82, 130, 180, 2, 204, 151, 177, 90, 10, 94, 249, 64, 204, 39, 7, 7, 120, 120, 12, 201, 61, 191, 43, 111, 21, 169, 33, 206, 177, 213, 216, 245, 233, 198, 208, 172, 22, 138, 7, 170, 174, 42, 171, 24, 99, 30, 28, 6, 203, 90, 97, 215, 81, 175, 74, 236, 129, 94, 87, 166,
  /* r 1, c 2101:2200 */  166, 99, 218, 223, 248, 235, 13, 149, 101, 103, 20, 139, 127, 103, 102, 147, 203, 106, 60, 104, 146, 33, 180, 97, 179, 93, 186, 116, 188, 208, 252, 63, 56, 115, 11, 85, 196, 67, 115, 150, 54, 19, 14, 159, 149, 129, 99, 128, 22, 88, 207, 139, 15, 110, 234, 160, 121, 195, 74, 73, 250, 243, 139, 16, 56, 250, 139, 88, 165, 50, 94, 51, 241, 100, 74, 18, 224, 143, 19, 83, 171, 214, 168, 121, 27, 130, 69, 220, 74, 71, 115, 241, 49, 95, 174, 81, 216, 246, 87, 213,
  /* r 1, c 2201:2300 */  2, 237, 52, 50, 22, 249, 1, 204, 27, 30, 130, 92, 210, 255, 69, 214, 69, 64, 103, 135, 17, 34, 202, 182, 130, 29, 76, 207, 205, 152, 41, 105, 32, 245, 53, 240, 180, 3, 115, 16, 255, 147, 129, 243, 165, 84, 64, 223, 20, 43, 218, 97, 214, 72, 44, 119, 73, 252, 170, 210, 89, 255, 246, 15, 125, 1, 41, 32, 133, 48, 187, 224, 247, 253, 223, 42, 2, 96, 215, 204, 74, 70, 77, 117, 200, 213, 186, 207, 161, 31, 207, 247, 152, 58, 18, 57, 102, 20, 41, 186,
  /* r 1, c 2301:2400 */  46, 214, 199, 29, 171, 201, 182, 78, 15, 43, 194, 120, 16, 55, 248, 120, 186, 195, 225, 13, 252, 168, 99, 169, 121, 128, 132, 104, 244, 90, 91, 33, 126, 151, 21, 153, 86, 211, 21, 62, 1, 153, 79, 73, 11, 99, 199, 78, 80, 195, 4, 12, 228, 159, 145, 62, 166, 131, 67, 201, 251, 59, 75, 108, 23, 73, 62, 91, 180, 221, 235, 239, 221, 86, 202, 103, 240, 181, 124, 125, 9, 212, 194, 138, 74, 74, 215, 114, 225, 115, 160, 245, 215, 19, 255, 32, 58, 132, 215, 216,


/* Function parameters : 4 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
1, 1, 8, 8000, 256,

/* Input data.*/

  /* r 1, c 1:100 */        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 101:200 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 201:300 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 301:400 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 401:500 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 501:600 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 601:700 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 701:800 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 801:900 */      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 901:1000 */     0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1001:1100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1101:1200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1201:1300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1301:1400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1401:1500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1501:1600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1601:1700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1701:1800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1801:1900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 1901:2000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2001:2100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2101:2200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2201:2300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2301:2400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2401:2500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2501:2600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2601:2700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2701:2800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2801:2900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 2901:3000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3001:3100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3101:3200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3201:3300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3301:3400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3401:3500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3501:3600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3601:3700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3701:3800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3801:3900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 3901:4000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4001:4100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4101:4200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4201:4300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4301:4400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4401:4500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4501:4600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4601:4700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4701:4800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4801:4900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 4901:5000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5001:5100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5101:5200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5201:5300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5301:5400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5401:5500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5501:5600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5601:5700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5701:5800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5801:5900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 5901:6000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6001:6100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6101:6200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6201:6300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6301:6400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6401:6500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6501:6600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6601:6700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6701:6800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6801:6900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 6901:7000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7001:7100 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7101:7200 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7201:7300 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7301:7400 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7401:7500 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7501:7600 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7601:7700 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7701:7800 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7801:7900 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  /* r 1, c 7901:8000 */    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,


/* Function parameters : 5 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
1, 1, 10, 64, 1024,

/* Input data.*/
 510, 1021, 620, 766, 48, 712, 66, 1018, 845, 464, 144, 621, 613, 896, 941, 907, 452, 561, 351, 289, 286, 975, 686, 537, 29, 334, 584, 373, 196, 756, 940, 782, 669, 539, 565, 477, 303, 688, 143, 21, 729, 410, 260, 524, 939, 379, 865, 626, 70, 294, 845, 684, 468, 65, 808, 180, 615, 326, 519, 421, 317, 519, 418, 106,

/* Function parameters : 6 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
1, -1, 11, 1000, 2048,

/* Input data.*/

  /* r 1, c 1:100 */     1669, 1856, 261, 1871, 1296, 200, 571, 1121, 1961, 1977, 323, 1988, 1961, 995, 1639, 291, 864, 1876, 1623, 1966, 1343, 74, 1740, 1913, 1391, 1552, 1522, 804, 1343, 351, 1446, 66, 568, 95, 199, 1687, 1424, 650, 1947, 71, 899, 782, 1568, 1629, 383, 1004, 913, 1324, 1453, 1546, 566, 1393, 1342, 334, 244, 1021, 1966, 698, 1199, 459, 1539, 523, 1037, 1432, 1825, 1965, 1121, 284, 306, 528, 1722, 521, 1668, 499, 1904, 717, 403, 515, 1262, 970, 721, 1702, 1199, 1126, 1879, 586, 1551, 1544, 780, 1163, 156, 111, 1088, 1596, 1913, 267, 1165, 962, 25, 691, 
  /* r 1, c 101:200 */   333, 1627, 638, 1083, 340, 1233, 539, 1340, 1412, 1533, 923, 172, 469, 1871, 313, 1692, 1103, 2041, 161, 907, 219, 1970, 10, 1588, 1674, 1780, 173, 819, 533, 1639, 884, 1866, 373, 541, 299, 279, 1781, 1188, 1127, 297, 1748, 1274, 719, 1052, 823, 156, 492, 253, 377, 492, 855, 102, 1849, 1935, 1006, 1002, 692, 1844, 757, 228, 1598, 799, 495, 828, 198, 271, 1930, 1959, 1179, 123, 481, 724, 1682, 32, 89, 347, 1330, 1499, 1327, 924, 1121, 607, 1526, 387, 1407, 376, 755, 1282, 1598, 167, 1904, 1589, 997, 893, 916, 628, 1042, 1047, 1675, 1628, 
  /* r 1, c 201:300 */   1320, 776, 1663, 1092, 719, 1924, 1794, 1127, 1275, 1203, 426, 617, 965, 473, 1730, 399, 463, 350, 467, 893, 638, 1892, 882, 379, 1854, 2007, 899, 228, 529, 838, 1219, 538, 1235, 1457, 455, 241, 608, 653, 869, 1041, 176, 538, 1641, 60, 1903, 1496, 1001, 1185, 486, 940, 1973, 1120, 1068, 475, 1002, 1279, 1391, 811, 753, 2024, 78, 1813, 1871, 1631, 203, 537, 687, 1393, 280, 1478, 219, 1339, 1013, 1596, 1465, 1851, 1825, 685, 1432, 406, 63, 1524, 1025, 983, 1853, 1250, 1265, 1761, 1650, 1182, 375, 492, 1816, 59, 1004, 344, 2005, 1460, 1025, 965, 
  /* r 1, c 301:400 */   123, 1397, 87, 147, 1069, 199, 1676, 1675, 1480, 307, 1351, 1063, 1993, 1330, 1640, 930, 886, 1691, 171, 273, 356, 801, 1703, 1646, 124, 818, 1080, 854, 1346, 1287, 598, 885, 32, 2016, 343, 218, 763, 406, 1003, 696, 1949, 1885, 108, 1512, 552, 866, 1123, 1931, 856, 2014, 618, 1436, 1365, 1105, 1430, 1366, 365, 263, 2047, 351, 67, 1150, 1807, 1371, 391, 756, 944, 2011, 321, 1753, 1321, 771, 392, 878, 988, 248, 1208, 464, 788, 1194, 516, 595, 1264, 544, 1689, 2013, 1496, 705, 1197, 221, 1857, 1802, 1675, 534, 1218, 47, 871, 641, 331, 367, 
  /* r 1, c 401:500 */   867, 193, 1226, 965, 1426, 1434, 1308, 69, 141, 655, 1088, 1341, 835, 1680, 1472, 1984, 1089, 666, 217, 1252, 1595, 868, 187, 546, 315, 576, 902, 1080, 937, 1793, 1061, 1933, 1307, 1962, 493, 1385, 593, 1376, 1424, 140, 522, 459, 1368, 1730, 706, 1599, 1384, 14, 1234, 793, 1876, 3, 948, 870, 944, 1578, 661, 1608, 966, 74, 361, 1479, 970, 313, 699, 1244, 393, 1513, 498, 1879, 552, 1568, 387, 589, 187, 1181, 1400, 1120, 872, 1320, 1327, 1391, 1303, 1936, 428, 1453, 484, 245, 1244, 922, 940, 1356, 1578, 718, 1356, 853, 1725, 1706, 526, 1257, 
  /* r 1, c 501:600 */   1193, 1108, 1782, 543, 652, 245, 1925, 1323, 982, 1310, 1116, 1326, 1114, 1477, 1071, 2036, 448, 217, 225, 131, 829, 919, 750, 1564, 1286, 1582, 1911, 1993, 394, 285, 1426, 193, 1077, 1087, 1764, 993, 806, 1376, 1519, 1066, 713, 308, 1201, 537, 92, 1547, 498, 907, 1409, 736, 1509, 809, 1400, 1442, 906, 41, 678, 869, 554, 404, 1683, 881, 1819, 802, 1576, 813, 1656, 1547, 773, 443, 1619, 1945, 671, 1375, 899, 1708, 1575, 343, 1766, 2028, 1054, 1812, 1205, 317, 410, 834, 1534, 1691, 1618, 653, 1094, 185, 229, 280, 1390, 1015, 389, 1014, 303, 113, 
  /* r 1, c 601:700 */   1743, 1149, 1904, 1427, 1194, 1670, 1801, 2026, 2, 1773, 1255, 2028, 1081, 983, 1642, 467, 1021, 1845, 1177, 1731, 1513, 1201, 506, 1365, 171, 1282, 1354, 1495, 1825, 2012, 1575, 1191, 1902, 1189, 35, 248, 1767, 992, 1731, 429, 1132, 1291, 66, 1259, 743, 102, 1003, 395, 253, 421, 301, 388, 88, 1301, 578, 1104, 1424, 1023, 1098, 912, 254, 1005, 1747, 1790, 554, 427, 1158, 1312, 855, 422, 1942, 169, 217, 291, 341, 1272, 1175, 107, 1908, 1493, 1512, 130, 1763, 1914, 2017, 1760, 1609, 1052, 364, 817, 275, 64, 1924, 618, 606, 682, 957, 1328, 52, 1725,
  /* r 1, c 701:800 */   1145, 1750, 713, 914, 112, 363, 1358, 678, 1841, 242, 2025, 1106, 1448, 2047, 590, 849, 952, 1565, 1676, 206, 365, 737, 117, 1069, 688, 360, 428, 1854, 1384, 960, 1869, 214, 1527, 1508, 1151, 378, 1224, 615, 275, 436, 1833, 147, 497, 111, 905, 28, 1838, 403, 192, 630, 935, 209, 2039, 681, 609, 128, 611, 95, 1036, 1560, 1293, 185, 166, 1592, 1854, 1094, 224, 1692, 693, 603, 1529, 22, 100, 1368, 1236, 1078, 1495, 1449, 1601, 590, 1419, 1141, 813, 127, 1598, 692, 1245, 1519, 215, 262, 1126, 994, 1824, 1637, 1504, 106, 150, 182, 1636, 1932, 
  /* r 1, c 801:900 */   1401, 271, 1481, 227, 241, 1313, 674, 1340, 1535, 1195, 1516, 481, 1506, 1988, 1776, 177, 751, 757, 1403, 1225, 1617, 753, 422, 178, 1581, 422, 796, 1131, 469, 1315, 993, 311, 1602, 207, 603, 487, 1088, 188, 831, 215, 230, 1607, 598, 1237, 1976, 886, 1423, 1553, 887, 1343, 225, 1913, 384, 546, 1634, 999, 1575, 812, 559, 77, 1379, 880, 926, 1249, 122, 647, 1583, 1427, 257, 267, 190, 17, 867, 1343, 1481, 1088, 223, 1294, 260, 276, 202, 291, 345, 402, 651, 649, 446, 515, 1829, 1441, 1139, 378, 435, 159, 1872, 1448, 1143, 642, 341, 1275, 
  /* r 1, c 901:1000 */  2024, 350, 528, 813, 152, 1402, 825, 2013, 824, 1272, 317, 781, 331, 1553, 1785, 719, 1404, 603, 1087, 1705, 1224, 687, 613, 927, 866, 737, 1144, 1521, 870, 880, 256, 51, 595, 651, 1339, 1960, 1917, 938, 493, 1565, 1556, 1517, 1524, 217, 1396, 949, 435, 202, 1687, 359, 335, 1364, 1832, 1058, 1440, 315, 1953, 1108, 1393, 75, 1658, 1534, 247, 1076, 668, 1120, 817, 851, 371, 524, 43, 1892, 1339, 1910, 335, 1887, 1628, 1183, 902, 528, 1540, 469, 132, 1572, 1375, 1465, 1315, 859, 801, 1672, 651, 1669, 1617, 1746, 1036, 1302, 1948, 910, 123, 1776, 


/* Function parameters : 7 */
/* use_for_cycle_estimate, acc, bits_arr, in_size, out_size */
1, 1, 12, 16000, 4096,

/* Input data.*/

  /* r 1, c 1:100 */        918, 636, 1932, 596, 2707, 2259, 2861, 3344, 202, 3951, 3700, 2745, 3779, 3689, 1042, 1397, 1980, 1724, 325, 3542, 1966, 1021, 3367, 2205, 329, 1545, 1359, 2782, 409, 3079, 332, 2291, 625, 2560, 2050, 1920, 3756, 3876, 2643, 3026, 3573, 1239, 1414, 934, 1954, 2366, 1671, 1045, 2366, 2548, 1197, 4037, 377, 2547, 1766, 3687, 1044, 86, 2077, 3937, 2367, 2278, 957, 2832, 717, 769, 2911, 1950, 2811, 1865, 2748, 1308, 3594, 2213, 330, 0, 4042, 1002, 1908, 1593, 858, 3993, 1331, 1860, 1705, 399, 3056, 1143, 2403, 1906, 3107, 432, 3969, 3669, 4000, 165, 2089, 1570, 798, 3752,
  /* r 1, c 101:200 */      2011, 3935, 273, 3794, 3659, 3518, 28, 2895, 2574, 1311, 925, 2364, 2480, 1491, 1380, 2798, 1634, 1487, 1883, 296, 1420, 3913, 3329, 1174, 1477, 2324, 2100, 1100, 1530, 1177, 3849, 2119, 1877, 2224, 900, 3381, 3463, 551, 3809, 1245, 3588, 3273, 444, 3920, 3780, 1983, 2553, 447, 3484, 2536, 3951, 2614, 3929, 2244, 2400, 1217, 1300, 3663, 2283, 2428, 317, 2993, 2208, 2875, 1813, 495, 1282, 3349, 3731, 1139, 2202, 660, 3361, 647, 79, 1815, 1160, 2860, 391, 340, 2493, 2722, 2483, 51, 1701, 1799, 3979, 1676, 2483, 726, 573, 397, 316, 2841, 1828, 3649, 3025, 1067, 1850, 2989,
  /* r 1, c 201:300 */      3937, 1367, 3565, 3533, 2036, 1774, 3780, 1724, 1094, 700, 3684, 1851, 454, 14, 2533, 2317, 138, 2490, 3107, 3685, 872, 1054, 2228, 1868, 3285, 3085, 1882, 4060, 3007, 215, 2280, 1128, 1961, 1910, 658, 3986, 3631, 2625, 3183, 2288, 1724, 1014, 2519, 3179, 1200, 2097, 326, 749, 1538, 3175, 995, 2421, 1410, 2350, 2832, 927, 1835, 2897, 2868, 2072, 2280, 1869, 1188, 3438, 1823, 883, 1301, 2243, 2145, 1180, 795, 3003, 485, 3481, 3166, 3327, 1624, 2099, 1622, 1073, 3972, 3908, 3945, 2697, 145, 3423, 2769, 1620, 2360, 2011, 2413, 2562, 490, 266, 254, 447, 3007, 1288, 2115, 113,
  /* r 1, c 301:400 */      2666, 2078, 2433, 1522, 519, 734, 1055, 267, 1017, 2785, 4028, 598, 2090, 787, 1049, 3434, 635, 450, 3595, 3802, 570, 2983, 867, 1297, 2862, 852, 3871, 3712, 2926, 311, 403, 1470, 3609, 3638, 635, 2407, 2323, 929, 1804, 2856, 3947, 1724, 2394, 544, 3215, 218, 1420, 1236, 124, 1604, 1522, 1474, 3703, 2229, 627, 2907, 1100, 1123, 2654, 155, 405, 2103, 1926, 2762, 4027, 1484, 347, 3519, 3312, 3481, 1296, 568, 3490, 3622, 365, 2839, 2100, 3792, 3723, 245, 2057, 2095, 3092, 3727, 2805, 917, 3468, 611, 2398, 1047, 822, 706, 1341, 707, 468, 1340, 955, 1518, 2086, 2214,
  /* r 1, c 401:500 */      1038, 1639, 2790, 3129, 385, 2554, 993, 2081, 782, 1978, 1643, 891, 328, 1525, 287, 3574, 2850, 1507, 3392, 2222, 1080, 2102, 3329, 257, 1140, 2062, 1773, 505, 3054, 706, 3041, 553, 1228, 1143, 3832, 3967, 2898, 1882, 2438, 3686, 1565, 3946, 2136, 884, 166, 768, 1289, 3856, 2649, 2854, 2651, 1861, 174, 688, 1588, 1577, 3473, 2030, 3392, 2810, 3562, 3353, 3393, 76, 3195, 2374, 593, 1761, 3673, 3316, 3239, 2194, 425, 450, 1866, 3733, 2227, 2453, 1145, 3592, 652, 3785, 1541, 2073, 4079, 1131, 2697, 2351, 876, 1595, 116, 1455, 2091, 3372, 2722, 3539, 625, 2486, 772, 498,
  /* r 1, c 501:600 */      1190, 1304, 3102, 3205, 962, 785, 3767, 702, 1569, 3761, 1071, 2803, 2879, 1112, 2530, 1056, 2128, 1036, 859, 289, 975, 592, 1564, 1083, 3468, 1950, 5, 3844, 1877, 2672, 3391, 44, 3018, 600, 3383, 2455, 941, 793, 1089, 1235, 476, 746, 1600, 810, 3872, 51, 2807, 3168, 1158, 1758, 2444, 3470, 3749, 1259, 3571, 1874, 1497, 3316, 1225, 3364, 3604, 2563, 1982, 3323, 3656, 3234, 4053, 3060, 18, 3985, 3463, 2581, 4061, 1629, 774, 2243, 1292, 2847, 1274, 2351, 1294, 2527, 3043, 2474, 2218, 61, 181, 2646, 2268, 2066, 963, 1493, 3959, 1407, 2734, 3645, 2402, 1634, 3445, 1052,
  /* r 1, c 601:700 */      3269, 2616, 3974, 722, 1054, 1243, 2968, 1315, 2388, 2666, 3506, 2467, 2411, 4055, 3931, 3642, 3698, 2750, 1371, 2261, 670, 2087, 2861, 1817, 2270, 1223, 3338, 3408, 391, 3936, 2984, 3834, 926, 2640, 3862, 2548, 3859, 3294, 3470, 571, 622, 3292, 693, 2863, 146, 1647, 1126, 2161, 1691, 3283, 14, 818, 2678, 3225, 843, 2059, 2574, 3002, 2542, 2047, 2876, 3498, 1619, 1036, 3950, 673, 2554, 965, 1060, 981, 3312, 3953, 1971, 3689, 1099, 3056, 2445, 3928, 3060, 3431, 2620, 1576, 3599, 2688, 3848, 2352, 2387, 616, 2130, 470, 3163, 3204, 3343, 1509, 2595, 24, 3896, 2826, 427, 380,
  /* r 1, c 701:800 */      18, 3952, 3694, 1875, 1791, 2915, 2330, 3310, 2560, 342, 1197, 1638, 307, 2430, 3475, 1902, 2798, 3014, 915, 2828, 2209, 2120, 339, 1740, 3721, 2296, 45, 3720, 3570, 3269, 543, 2928, 2847, 177, 3449, 3669, 1835, 3162, 348, 528, 2330, 2106, 2891, 3725, 55, 3569, 3779, 780, 262, 3185, 1236, 4033, 2156, 789, 1760, 3567, 50, 3617, 3802, 3975, 59, 3403, 3442, 2338, 3924, 3231, 2139, 746, 1973, 3160, 692, 3544, 3952, 2386, 2842, 2863, 3644, 3825, 1415, 968, 4033, 3025, 1823, 1643, 3249, 1628, 1247, 1646, 1436, 404, 920, 1428, 4045, 370, 442, 3990, 1695, 2801, 1985, 1368,
  /* r 1, c 801:900 */      377, 3460, 1492, 117, 2840, 681, 110, 2858, 1177, 2290, 1712, 260, 469, 1716, 1046, 3918, 2000, 1833, 3685, 943, 1682, 2891, 4071, 3591, 3922, 1579, 1407, 1496, 2104, 3296, 3403, 2338, 1197, 957, 1805, 1716, 167, 3058, 3344, 3555, 342, 283, 179, 3945, 2366, 1348, 587, 2497, 739, 799, 781, 674, 3025, 816, 3293, 3502, 1722, 1484, 2792, 22, 1460, 306, 573, 2645, 3355, 3920, 3800, 1374, 975, 1579, 159, 1733, 3934, 1241, 843, 1699, 3530, 2107, 948, 3771, 1406, 508, 1536, 2891, 2767, 313, 276, 2071, 650, 1477, 3554, 3607, 1458, 2852, 2587, 3448, 2922, 3503, 2067, 1047,
  /* r 1, c 901:1000 */     2323, 3648, 3837, 2175, 3006, 2178, 586, 2061, 1566, 3249, 1048, 1908, 1314, 2293, 3010, 1129, 2110, 564, 1128, 2751, 524, 1559, 3033, 3546, 2158, 333, 1384, 2139, 3230, 894, 2036, 3000, 3041, 2790, 1429, 2623, 1018, 3287, 2395, 4086, 1560, 3304, 2371, 3362, 3272, 3371, 1268, 1938, 597, 1596, 3226, 2146, 2312, 2205, 2492, 54, 2433, 2784, 1243, 1416, 97, 168, 1815, 1862, 806, 2770, 2525, 2838, 2817, 3219, 1796, 1815, 1214, 2760, 2252, 3029, 3519, 2540, 824, 3733, 2947, 880, 3133, 398, 451, 890, 2542, 4055, 2861, 1328, 743, 1576, 3704, 2150, 2439, 389, 770, 3348, 1539, 3440,
  /* r 1, c 1001:1100 */    313, 1524, 542, 638, 1129, 676, 3469, 1294, 2568, 196, 4068, 2359, 1162, 2607, 295, 1804, 2401, 825, 3733, 1305, 3408, 999, 1492, 1299, 4045, 1447, 2127, 1747, 1493, 3581, 3536, 1086, 4044, 1620, 2749, 1596, 2627, 1682, 1820, 218, 2424, 2209, 2320, 1963, 2091, 1171, 627, 3570, 4093, 2262, 80, 1299, 650, 2859, 1243, 2477, 755, 3075, 113, 2432, 309, 3414, 824, 1635, 3599, 1803, 3377, 43, 2150, 728, 491, 3767, 3633, 1878, 2631, 2025, 1902, 2706, 47, 695, 477, 2842, 1714, 1421, 640, 1653, 2458, 2707, 1227, 4042, 3210, 76, 2676, 2143, 4078, 3030, 1882, 3146, 3502, 1048,
  /* r 1, c 1101:1200 */    1469, 602, 1598, 1304, 350, 2422, 2709, 3128, 1046, 1633, 3438, 669, 3776, 2661, 3412, 404, 2216, 2018, 3518, 938, 1472, 268, 2697, 3435, 3152, 3755, 3713, 1152, 3926, 2031, 1795, 959, 4050, 2372, 2846, 2956, 995, 3945, 4015, 2807, 2155, 990, 4052, 849, 2221, 1624, 738, 1144, 896, 3229, 3791, 115, 720, 86, 2662, 537, 443, 2233, 2611, 162, 2450, 1770, 3409, 3348, 1837, 1007, 1210, 642, 1605, 4013, 2225, 1920, 706, 3748, 1362, 3812, 1091, 2661, 1361, 1325, 2047, 642, 1992, 3702, 863, 1200, 3024, 780, 1045, 760, 3000, 1075, 3970, 2941, 3741, 2094, 3585, 1821, 1336, 924,
  /* r 1, c 1201:1300 */    1360, 450, 597, 3710, 3517, 2014, 3670, 3286, 465, 2543, 3357, 890, 2946, 1967, 2722, 416, 517, 1431, 292, 3601, 2864, 699, 1503, 3965, 3178, 2986, 3487, 3868, 3109, 1171, 1151, 2899, 804, 233, 460, 3465, 1695, 176, 56, 966, 3324, 315, 2995, 3630, 3922, 301, 3850, 1407, 36, 711, 3374, 1400, 2252, 2457, 3044, 2789, 3447, 2770, 1915, 2815, 3850, 1035, 1717, 2393, 1551, 1532, 119, 1834, 1825, 3501, 1217, 2130, 2442, 2476, 1622, 2019, 1402, 1121, 73, 371, 931, 376, 3191, 2266, 2150, 1196, 1244, 2545, 156, 2121, 905, 3792, 544, 1964, 669, 305, 3931, 2684, 977, 2574,
  /* r 1, c 1301:1400 */    1157, 570, 1939, 1417, 1770, 1122, 2390, 1727, 1883, 1138, 3011, 4066, 4054, 1150, 521, 1437, 117, 3958, 1252, 1198, 411, 864, 1027, 3986, 2176, 1959, 1839, 3737, 719, 3308, 2861, 1286, 337, 2592, 2229, 2785, 954, 2091, 821, 1693, 3337, 2497, 497, 1197, 2044, 3899, 2570, 2603, 905, 646, 1201, 3315, 3721, 3935, 2191, 2746, 2, 2724, 1670, 4064, 3492, 430, 2771, 1333, 3573, 4025, 2374, 1798, 2351, 719, 2117, 3953, 1993, 3652, 3300, 2897, 900, 2240, 3196, 1656, 718, 762, 3897, 877, 1381, 2711, 57, 2117, 2496, 3942, 3580, 2862, 3701, 1252, 1319, 2867, 2881, 1837, 2593, 3924,
  /* r 1, c 1401:1500 */    34, 1, 3182, 2500, 434, 2945, 1383, 3389, 2227, 1626, 2983, 216, 2329, 1079, 2262, 1484, 1521, 797, 33, 466, 3520, 3262, 251, 3129, 3162, 3812, 3099, 2951, 3639, 2767, 2563, 3179, 784, 2970, 3133, 756, 709, 2149, 3450, 2764, 2778, 4019, 4006, 3432, 77, 2099, 1057, 3753, 1591, 497, 3027, 1633, 1285, 1798, 4057, 3856, 3449, 2904, 1405, 1365, 791, 419, 3948, 2994, 1788, 87, 2198, 706, 1125, 1360, 967, 36, 988, 1901, 2329, 2631, 3986, 2856, 663, 1353, 3018, 2595, 1302, 3395, 2823, 3172, 2428, 554, 23, 3804, 1534, 1622, 3750, 2828, 2272, 3423, 207, 1298, 2177, 2738,
  /* r 1, c 1501:1600 */    1795, 3194, 3070, 206, 2219, 969, 2646, 1332, 3253, 2497, 1456, 2095, 1152, 164, 3878, 1415, 3148, 3886, 685, 123, 703, 2764, 2345, 581, 2439, 1113, 1599, 394, 1987, 4074, 2630, 1270, 596, 3742, 403, 3921, 2592, 2854, 95, 3429, 3750, 1765, 224, 1958, 3694, 1439, 437, 702, 2681, 3456, 800, 686, 1135, 2747, 3944, 104, 2522, 3186, 3199, 1846, 386, 3340, 1807, 338, 1888, 3271, 3068, 98, 3873, 3203, 1352, 1760, 248, 1480, 2560, 1525, 4064, 631, 1931, 986, 2403, 1942, 3908, 1034, 1728, 1388, 3193, 38, 2286, 271, 2503, 2103, 1289, 1153, 2526, 3692, 267, 2368, 516, 678,
  /* r 1, c 1601:1700 */    227, 2704, 1773, 491, 1924, 3336, 1380, 3450, 2102, 459, 3277, 2006, 588, 449, 3673, 1276, 831, 525, 1749, 794, 513, 3759, 299, 3367, 2860, 1238, 3106, 53, 1008, 725, 1322, 3488, 2099, 1862, 1135, 3890, 3569, 1577, 3574, 498, 817, 2440, 1482, 3267, 3963, 96, 3356, 830, 2870, 3717, 479, 905, 676, 827, 2415, 3919, 3389, 3254, 4041, 2012, 2303, 3639, 1029, 585, 3581, 997, 2811, 3481, 841, 3405, 2526, 2209, 1832, 1870, 3199, 3922, 4017, 707, 1385, 866, 1713, 1236, 3795, 679, 1707, 2716, 2471, 2187, 2487, 2263, 303, 3106, 2757, 1787, 1822, 2313, 148, 3244, 2867, 399,
  /* r 1, c 1701:1800 */    1398, 3001, 4080, 129, 4029, 3028, 156, 3915, 76, 3809, 1235, 2438, 2376, 4050, 1638, 400, 2787, 3597, 288, 3447, 4049, 1965, 3195, 2954, 3308, 3594, 3219, 1146, 1367, 3833, 274, 1725, 1964, 2948, 2963, 2934, 2515, 3256, 2900, 2094, 57, 3594, 1411, 955, 2611, 1974, 2732, 3823, 2837, 3937, 2512, 2827, 1072, 2119, 3903, 1223, 996, 2005, 3308, 4008, 658, 3732, 1160, 347, 2131, 158, 1388, 2612, 2139, 3886, 1757, 562, 184, 3678, 3417, 2070, 3201, 895, 580, 3970, 415, 1163, 3586, 3998, 1020, 598, 1091, 3795, 2173, 2330, 1086, 2204, 3322, 1514, 1170, 1943, 3948, 2510, 1761, 758,
  /* r 1, c 1801:1900 */    3359, 2917, 3217, 3236, 2052, 3771, 3209, 1283, 2455, 521, 3704, 1184, 314, 632, 1005, 3044, 3152, 1324, 435, 2263, 1972, 2794, 2497, 1853, 2058, 1489, 343, 3051, 2669, 2718, 3385, 1575, 1010, 2903, 1376, 3207, 3130, 3532, 546, 3429, 1291, 3905, 3139, 2155, 8, 810, 1977, 1379, 2209, 600, 84, 2127, 3538, 2760, 240, 1376, 2321, 2043, 1149, 873, 871, 3260, 2940, 3356, 1360, 3537, 3805, 2442, 316, 1251, 2950, 3812, 1734, 3556, 3603, 1938, 1659, 858, 1336, 1977, 551, 3853, 3695, 4031, 3577, 311, 1965, 1644, 1516, 3824, 1758, 1505, 1815, 3411, 3802, 733, 1067, 3553, 284, 3116,
  /* r 1, c 1901:2000 */    2040, 2982, 2974, 3618, 646, 2385, 3216, 3954, 2965, 1746, 815, 1723, 3749, 1814, 2273, 575, 3286, 3906, 3114, 1491, 1997, 2861, 525, 2920, 655, 2758, 3461, 1062, 450, 652, 3973, 152, 3663, 4025, 2251, 2952, 1449, 1881, 2008, 3780, 2197, 2022, 1769, 3204, 951, 2517, 3474, 2908, 2901, 2962, 3447, 1532, 3146, 1585, 3725, 3507, 1511, 449, 3269, 475, 158, 2507, 3411, 698, 2756, 560, 2820, 370, 4064, 4080, 107, 2204, 3799, 639, 2761, 517, 3849, 2759, 2759, 4051, 850, 806, 169, 702, 2148, 3581, 1884, 3087, 3101, 1340, 3403, 3285, 1529, 365, 3631, 91, 1637, 1646, 2218, 2744,
  /* r 1, c 2001:2100 */    2874, 1756, 1017, 1385, 1061, 2084, 1299, 2682, 3981, 3744, 1011, 2062, 298, 1577, 3690, 1090, 1841, 51, 1013, 2056, 1232, 390, 2506, 1255, 775, 2387, 601, 3090, 2661, 407, 3771, 1821, 3932, 1624, 2954, 2532, 3975, 2993, 2693, 3669, 1709, 2530, 368, 1580, 4056, 1304, 421, 181, 1861, 558, 247, 3, 1458, 478, 2123, 1807, 3835, 4034, 3714, 2384, 3265, 4042, 3211, 3841, 2685, 665, 3974, 2428, 2361, 1298, 1734, 1299, 2524, 2133, 3210, 3581, 2012, 1752, 3535, 451, 2085, 1665, 2565, 279, 1744, 2127, 3729, 3319, 2783, 3765, 2371, 3205, 1326, 1492, 1921, 3991, 3659, 2815, 1537, 1309,
  /* r 1, c 2101:2200 */    2274, 3834, 2273, 1838, 2082, 1967, 54, 4066, 2729, 3174, 1033, 1327, 75, 3029, 2823, 2368, 2904, 3643, 301, 2760, 546, 2105, 2601, 2997, 1675, 1546, 200, 1475, 347, 2573, 1175, 1468, 532, 2944, 1233, 3847, 1176, 598, 2620, 1681, 2704, 2617, 3257, 451, 3630, 3668, 1653, 1066, 1624, 1201, 1261, 1267, 4069, 3855, 1155, 5, 3321, 1484, 1155, 239, 1533, 3598, 3732, 1305, 3661, 3042, 3403, 965, 4028, 3817, 1542, 2692, 1324, 3207, 418, 4051, 4001, 1571, 350, 1540, 1128, 2008, 3744, 2351, 3499, 506, 3580, 178, 1358, 595, 867, 690, 2514, 2102, 541, 2575, 563, 724, 1392, 2389,
  /* r 1, c 2201:2300 */    747, 1380, 3424, 2872, 913, 2965, 1479, 985, 3259, 1898, 1472, 897, 2839, 1336, 1649, 3586, 1326, 1600, 2629, 2662, 4023, 1277, 4001, 3200, 282, 3056, 82, 1050, 139, 275, 428, 620, 3455, 438, 2323, 3618, 2362, 3336, 1707, 2162, 2815, 1407, 105, 3578, 4090, 2170, 2950, 734, 3785, 718, 1120, 3397, 1778, 3521, 3264, 1407, 2203, 381, 472, 387, 3309, 2577, 922, 2150, 2271, 1754, 1928, 384, 589, 3297, 3658, 1064, 961, 2395, 1127, 756, 2248, 1957, 2523, 883, 3428, 561, 2484, 2527, 3438, 879, 947, 1447, 303, 2697, 1170, 2216, 267, 1072, 2984, 970, 3264, 4094, 605, 4028,
  /* r 1, c 2301:2400 */    1571, 3962, 1500, 416, 497, 3818, 3999, 812, 791, 1731, 2345, 611, 3447, 2659, 3777, 92, 3531, 3070, 1392, 1068, 1875, 3263, 797, 415, 668, 2616, 3748, 5, 2556, 1125, 227, 2004, 2866, 3049, 901, 1802, 82, 3131, 2206, 2920, 2395, 3574, 1005, 1943, 485, 562, 3229, 2436, 1475, 1897, 3382, 1491, 1848, 1163, 1674, 3223, 3478, 964, 3635, 324, 3808, 2978, 839, 2380, 131, 3318, 3530, 2538, 3763, 3250, 514, 994, 1327, 2768, 2879, 286, 3855, 1448, 3173, 424, 1570, 439, 1332, 452, 3373, 1982, 2630, 602, 1452, 2703, 1319, 2056, 2078, 1870, 3060, 3575, 767, 1569, 1331, 992,
  /* r 1, c 2401:2500 */    2158, 418, 3506, 847, 1305, 2099, 817, 2860, 3705, 3408, 1280, 1616, 3890, 3040, 248, 376, 1685, 1148, 1690, 1590, 3135, 2653, 225, 293, 2676, 1527, 2321, 1002, 3439, 1486, 1827, 1279, 1737, 2503, 3004, 2968, 2745, 3416, 1593, 3363, 1981, 652, 3502, 1287, 3355, 1589, 1112, 3415, 1144, 1203, 2050, 4009, 3979, 958, 3920, 468, 19, 434, 2462, 2524, 2227, 2625, 3007, 2477, 2347, 2498, 3254, 1838, 3143, 217, 1663, 2565, 3518, 1846, 789, 3953, 1935, 2966, 3378, 2201, 1489, 3996, 2591, 52, 3496, 1801, 159, 449, 2605, 1903, 1929, 123, 3375, 2366, 651, 2259, 13, 1418, 3765, 1709,
  /* r 1, c 2501:2600 */    1945, 119, 2334, 2307, 2931, 187, 2867, 1926, 1777, 693, 3411, 1937, 1057, 401, 3824, 1676, 3947, 270, 3883, 3387, 3986, 3845, 3205, 2349, 1161, 3680, 948, 1469, 1960, 2972, 109, 3608, 859, 1759, 2928, 5, 1770, 960, 1892, 3922, 3418, 1685, 3661, 943, 1614, 4003, 3548, 4084, 97, 1683, 2687, 3485, 347, 780, 777, 3799, 1952, 3995, 636, 4031, 3585, 1778, 1469, 939, 1764, 3267, 9, 1508, 2253, 3142, 1105, 3913, 2777, 1524, 905, 274, 2461, 2547, 190, 1338, 3520, 2164, 2758, 3493, 3609, 208, 3369, 1166, 1029, 3833, 2022, 2626, 1498, 2580, 3426, 449, 477, 3176, 3782, 2401,
  /* r 1, c 2601:2700 */    3815, 1559, 2538, 2395, 1571, 164, 1443, 2765, 4018, 1392, 439, 994, 3467, 353, 3561, 3619, 900, 1299, 397, 2789, 3182, 2979, 3506, 787, 1729, 989, 1283, 2844, 3761, 2168, 342, 1454, 2175, 3722, 475, 1515, 2128, 3821, 677, 2625, 1294, 4000, 2425, 1845, 2379, 3538, 563, 4053, 3253, 3050, 164, 1972, 1185, 3845, 359, 411, 2373, 853, 1201, 1468, 2872, 4022, 468, 2549, 2344, 3909, 912, 3823, 3473, 2930, 3708, 418, 3389, 2143, 1042, 3324, 18, 3136, 275, 1733, 2633, 235, 225, 2339, 2390, 2170, 3971, 2136, 2348, 2047, 412, 2755, 1769, 2554, 646, 3614, 971, 1590, 245, 1303,
  /* r 1, c 2701:2800 */    1458, 2512, 3927, 818, 2223, 2687, 3311, 1678, 4026, 2339, 3574, 195, 3989, 3567, 790, 2850, 2410, 3384, 48, 3857, 3930, 2132, 3580, 179, 1780, 3883, 4009, 3841, 1793, 220, 3239, 1272, 2502, 3628, 1590, 1865, 202, 916, 1801, 3864, 2616, 1754, 3975, 3214, 3610, 1098, 2470, 3735, 603, 1197, 2925, 1390, 770, 2244, 3279, 3368, 2234, 247, 2873, 3865, 3748, 1073, 3065, 2443, 376, 372, 3218, 1366, 3148, 882, 1398, 2497, 585, 840, 877, 1506, 2180, 3047, 70, 596, 1933, 2568, 4058, 124, 689, 225, 2053, 442, 446, 948, 2852, 2141, 2131, 538, 3518, 234, 631, 965, 1250, 1384,
  /* r 1, c 2801:2900 */    1061, 2252, 252, 3260, 3742, 2711, 285, 594, 942, 1396, 1832, 636, 2178, 288, 644, 698, 2268, 234, 1186, 3561, 1150, 3104, 2714, 1506, 1399, 688, 3750, 3448, 3828, 2424, 2103, 398, 2928, 2413, 2276, 3813, 1980, 2905, 3425, 2986, 2498, 2157, 80, 457, 85, 2394, 3868, 2460, 704, 1211, 3593, 3239, 38, 2650, 2257, 1552, 1026, 2583, 540, 357, 532, 1421, 2360, 3552, 885, 1256, 228, 2407, 3167, 1650, 2967, 225, 1637, 3367, 1793, 2124, 1522, 459, 925, 1297, 1172, 2889, 631, 4007, 358, 1992, 3282, 3671, 580, 1289, 319, 3895, 25, 1309, 2918, 231, 2820, 2312, 3823, 1008,
  /* r 1, c 2901:3000 */    1343, 411, 1836, 2023, 1405, 1951, 1786, 1768, 3880, 1531, 3214, 2362, 1751, 3284, 395, 2149, 2177, 3779, 1173, 1984, 4060, 851, 720, 1441, 1121, 3956, 3524, 1928, 534, 1956, 2157, 1877, 2232, 2153, 2701, 18, 3822, 173, 2050, 1825, 1932, 2315, 944, 2228, 1040, 3487, 3412, 3765, 1444, 3264, 3650, 3554, 3726, 155, 1940, 3119, 1155, 3959, 1968, 2909, 3025, 1730, 1468, 3465, 2395, 2497, 21, 126, 3466, 2307, 114, 3158, 3904, 3548, 1787, 2384, 3112, 1617, 1688, 692, 2333, 1933, 1795, 473, 121, 1635, 3745, 963, 3967, 3203, 2001, 2013, 4, 2141, 3148, 2738, 333, 74, 295, 2275,
  /* r 1, c 3001:3100 */    3693, 1731, 126, 3780, 1550, 1685, 2051, 3298, 509, 3356, 2836, 1718, 98, 1865, 1401, 3629, 1027, 2417, 496, 3526, 526, 98, 3918, 2895, 1207, 2534, 2770, 319, 523, 3425, 1527, 1403, 1412, 2151, 1351, 1345, 927, 3404, 2176, 1179, 1830, 1037, 623, 1583, 2060, 307, 3674, 3198, 3276, 3596, 2834, 1580, 939, 178, 3851, 204, 426, 2610, 2971, 2685, 2087, 3541, 3863, 2601, 4077, 1958, 1522, 3287, 927, 1258, 1981, 1497, 1211, 656, 717, 2689, 2208, 2795, 62, 1702, 3933, 940, 400, 3178, 3404, 894, 1544, 1402, 2656, 2407, 2353, 1028, 210, 1854, 3137, 441, 278, 469, 2187, 1851,
  /* r 1, c 3101:3200 */    38, 1017, 2435, 3731, 478, 3526, 4008, 815, 3718, 571, 2197, 3577, 1552, 3701, 1504, 3660, 826, 438, 2749, 1895, 1058, 394, 1954, 476, 417, 2149, 3265, 2985, 2053, 2827, 3767, 651, 3546, 1148, 2164, 2941, 3395, 1219, 2476, 1635, 157, 505, 1603, 1669, 3205, 109, 764, 1446, 3945, 2159, 3638, 1835, 1719, 410, 4016, 3214, 281, 67, 3872, 1747, 30, 2577, 3090, 3308, 3367, 873, 171, 1134, 600, 1925, 1159, 1397, 2795, 3047, 3955, 2029, 3414, 1026, 3479, 246, 2325, 1828, 211, 3662, 1153, 3901, 465, 15, 2823, 714, 101, 1619, 3669, 1421, 3399, 2813, 834, 1423, 1791, 318,
  /* r 1, c 3201:3300 */    2837, 905, 1547, 2497, 1674, 1292, 1000, 3241, 1544, 3936, 3125, 955, 2198, 3126, 2157, 2892, 1854, 3780, 77, 89, 2267, 3729, 865, 3352, 2590, 2617, 2948, 3831, 1606, 3298, 3214, 1863, 4034, 554, 1287, 1900, 3655, 3976, 3800, 1029, 2146, 1931, 2899, 1056, 76, 1049, 1646, 3925, 3038, 528, 3940, 3179, 2970, 3746, 1090, 236, 2886, 2550, 2629, 3448, 502, 1517, 2553, 3662, 482, 2043, 2839, 822, 1152, 1709, 2188, 2200, 4074, 1639, 935, 3902, 580, 536, 2142, 3760, 1865, 3930, 2403, 1632, 3737, 3280, 1481, 31, 3575, 3510, 1156, 3845, 746, 912, 515, 743, 2406, 2606, 2357, 701,
  /* r 1, c 3301:3400 */    167, 2554, 3932, 2883, 2711, 719, 1760, 2610, 1560, 743, 1231, 2499, 1050, 775, 3202, 3845, 4070, 910, 184, 1058, 3923, 1505, 2525, 2279, 1415, 2091, 483, 3507, 2305, 1251, 3140, 424, 3931, 77, 1860, 197, 1618, 3993, 2021, 2583, 1943, 864, 1730, 2659, 3, 1413, 1215, 1798, 984, 3038, 422, 2485, 1437, 2414, 1073, 503, 304, 300, 3587, 1213, 767, 4074, 3803, 2917, 1920, 3554, 3427, 1634, 3059, 3408, 1995, 2165, 2158, 251, 937, 3879, 676, 1915, 952, 514, 945, 3706, 883, 2104, 2442, 422, 2433, 90, 1542, 3606, 934, 3926, 3477, 1520, 415, 2513, 3173, 1564, 4090, 770,
  /* r 1, c 3401:3500 */    1567, 3466, 946, 1792, 3073, 2484, 3967, 1545, 1178, 1887, 3793, 2482, 1703, 2524, 3860, 110, 1236, 1888, 3487, 2869, 443, 3062, 1773, 3588, 867, 211, 3864, 3076, 3428, 1988, 3421, 2253, 1630, 1441, 511, 2297, 905, 1384, 967, 714, 580, 2964, 1786, 3830, 2609, 343, 268, 2800, 267, 3313, 1582, 1773, 3669, 3151, 923, 751, 479, 777, 3368, 72, 4036, 1206, 508, 3083, 3375, 1139, 3564, 3844, 4012, 1166, 957, 2380, 471, 1238, 168, 1289, 3461, 2570, 2710, 3737, 3658, 1397, 3139, 2006, 698, 697, 1163, 2851, 2117, 325, 1577, 167, 585, 3970, 1771, 3751, 2755, 2474, 3986, 2190,
  /* r 1, c 3501:3600 */    590, 1838, 1926, 3235, 1898, 2787, 359, 199, 2072, 2401, 1391, 3455, 3807, 182, 2702, 604, 176, 510, 426, 2859, 1034, 1274, 2499, 2505, 688, 1268, 1873, 1819, 2833, 2204, 2502, 224, 3417, 2868, 1576, 38, 1901, 2782, 1091, 212, 820, 3630, 1785, 619, 2431, 925, 2230, 471, 2175, 2713, 3177, 1094, 636, 51, 2730, 664, 2214, 1877, 925, 3328, 2781, 1147, 3299, 2669, 1131, 2353, 678, 2483, 810, 2610, 112, 1154, 45, 3688, 413, 2807, 1383, 1689, 498, 1280, 2589, 1699, 3599, 3202, 710, 346, 2403, 1339, 2321, 2282, 4021, 3785, 469, 2641, 1727, 2652, 451, 724, 122, 1677,
  /* r 1, c 3601:3700 */    2547, 3496, 1042, 1833, 2595, 2042, 2122, 2278, 194, 3505, 3781, 2120, 3250, 2151, 920, 3827, 3557, 3026, 35, 2459, 4009, 2441, 2831, 1537, 2871, 169, 1634, 4069, 252, 2410, 3112, 3651, 2414, 1705, 1060, 318, 3694, 3477, 3513, 2560, 547, 2367, 1015, 3394, 2630, 1997, 3906, 2824, 1399, 2155, 1191, 749, 3232, 2241, 4031, 1026, 379, 2321, 4093, 928, 1078, 929, 3215, 2708, 308, 2427, 3020, 2026, 2826, 265, 3419, 655, 2693, 925, 2498, 1237, 158, 146, 481, 1759, 3942, 1783, 3489, 1755, 2500, 1858, 3648, 3430, 4029, 532, 8, 2229, 2381, 1120, 784, 1972, 3589, 2105, 3919, 3608,
  /* r 1, c 3701:3800 */    1867, 2692, 3135, 620, 122, 1368, 3064, 1135, 2336, 1286, 3710, 3645, 673, 2928, 56, 151, 2235, 3523, 4068, 294, 2030, 3066, 1015, 3444, 3737, 4015, 1480, 1140, 2004, 600, 3988, 887, 3518, 2605, 2893, 908, 3039, 1056, 2542, 2506, 3752, 1099, 3235, 3302, 489, 3834, 3839, 1058, 1039, 3648, 3131, 3716, 2234, 3378, 2234, 4010, 19, 2052, 1211, 2460, 3861, 3885, 1901, 1247, 3503, 4052, 3093, 1916, 2854, 1146, 2075, 3850, 2653, 3414, 3462, 2202, 1081, 3481, 3938, 4010, 3528, 3647, 1497, 1480, 2908, 2699, 254, 795, 4089, 1405, 2702, 3370, 3381, 2507, 2146, 4024, 7, 2017, 1185, 911,
  /* r 1, c 3801:3900 */    466, 1493, 2141, 1715, 4021, 2327, 108, 2616, 3406, 1572, 2460, 3751, 2572, 3701, 2682, 4086, 2901, 3345, 1877, 2802, 1524, 1686, 582, 241, 2621, 2894, 2139, 944, 1474, 137, 319, 464, 396, 968, 1900, 520, 3251, 639, 1606, 2007, 3462, 3694, 3315, 2736, 783, 359, 3490, 3535, 3319, 1752, 3777, 812, 1180, 1304, 1175, 1155, 2639, 2168, 1385, 1053, 1356, 3690, 1239, 754, 3738, 4028, 1708, 2933, 3479, 4011, 3399, 1898, 2627, 1613, 1627, 130, 1939, 3096, 1205, 850, 50, 2868, 732, 1492, 3388, 1555, 975, 1287, 3527, 2516, 477, 1336, 2894, 3627, 340, 3291, 467, 2458, 4013, 3525,
  /* r 1, c 3901:4000 */    1874, 2964, 2607, 2362, 3869, 3983, 1199, 1969, 226, 3656, 41, 3941, 3430, 547, 678, 2118, 1473, 586, 2888, 845, 2386, 2298, 3475, 3387, 0, 588, 2099, 2114, 841, 3081, 10, 3592, 2618, 2929, 2940, 92, 16, 2747, 1922, 2021, 2515, 1315, 3329, 1615, 2403, 2235, 443, 3003, 3269, 3396, 2750, 1467, 2930, 1352, 3123, 2531, 3295, 232, 942, 3557, 2522, 1441, 663, 1788, 387, 3440, 1444, 3284, 3418, 4035, 1741, 2766, 399, 3048, 3343, 2531, 1225, 711, 3023, 2634, 136, 4, 617, 133, 1213, 1974, 3515, 1982, 734, 924, 3725, 1796, 1418, 2563, 3164, 1296, 2236, 2172, 2137, 2092,
  /* r 1, c 4001:4100 */    153, 1413, 3978, 3666, 2733, 2855, 2607, 2021, 3923, 252, 438, 2903, 3476, 3230, 3442, 149, 3719, 991, 1940, 3973, 3071, 3153, 1989, 98, 3968, 2593, 1140, 3066, 713, 2624, 3158, 2910, 2524, 2474, 3785, 2384, 133, 1902, 886, 939, 3178, 1113, 3993, 542, 1020, 3941, 707, 1162, 188, 10, 2376, 3793, 1341, 1740, 3981, 3087, 3698, 233, 904, 3808, 409, 660, 2610, 763, 1810, 530, 2479, 3018, 71, 2625, 2198, 3498, 2481, 810, 3338, 1461, 1865, 3544, 1325, 3469, 137, 1722, 1185, 1778, 851, 617, 1460, 1026, 2947, 46, 498, 995, 1069, 342, 1961, 1971, 2565, 3513, 1963, 1564,
  /* r 1, c 4101:4200 */    602, 916, 1517, 2630, 3148, 1519, 1585, 530, 2758, 2506, 3287, 3929, 870, 3486, 2761, 98, 970, 3812, 731, 1318, 1896, 425, 4024, 1272, 3416, 3101, 910, 3185, 1553, 1705, 605, 1740, 437, 594, 1466, 1536, 2144, 3312, 1444, 2465, 1491, 1843, 2967, 314, 2734, 2256, 40, 3842, 3021, 4051, 1805, 1061, 3789, 3041, 184, 2377, 776, 1896, 1385, 268, 2917, 983, 1093, 3792, 3899, 380, 249, 3845, 3465, 2887, 3608, 3813, 3133, 668, 1709, 3867, 1778, 2279, 3378, 1287, 1159, 3941, 2596, 2598, 2680, 926, 3415, 3702, 37, 3298, 1062, 3265, 725, 481, 2124, 3513, 2454, 274, 175, 2368,
  /* r 1, c 4201:4300 */    2029, 3984, 2786, 1203, 3789, 1488, 1881, 607, 2111, 3040, 1878, 4001, 1504, 4059, 2860, 906, 3005, 1749, 3854, 461, 2637, 3961, 426, 1685, 4081, 3368, 555, 1389, 4003, 3158, 3382, 26, 3732, 2496, 739, 1059, 4000, 829, 1688, 3583, 2437, 3748, 3432, 3288, 71, 2074, 2062, 3074, 394, 3815, 1235, 1223, 1792, 1086, 3663, 2256, 991, 1533, 1517, 413, 2338, 2558, 1435, 1981, 2459, 285, 2792, 1225, 3614, 1103, 2515, 1355, 4072, 1765, 3599, 700, 1217, 1692, 1801, 3487, 2674, 3104, 2289, 1801, 2155, 1575, 1996, 3608, 889, 833, 1645, 3845, 1001, 683, 2527, 2351, 2822, 3867, 3022, 2730,
  /* r 1, c 4301:4400 */    1168, 1360, 4057, 3601, 1509, 3512, 1899, 2371, 3692, 2613, 2285, 1663, 3996, 1742, 3888, 386, 1134, 3692, 2497, 2445, 3917, 2813, 1371, 882, 755, 1290, 910, 3761, 2294, 3914, 556, 461, 868, 222, 99, 3292, 968, 2292, 4007, 777, 21, 3045, 1079, 56, 363, 3062, 3687, 3085, 2448, 1548, 2537, 761, 2586, 1487, 663, 2723, 1218, 3858, 1725, 953, 703, 2984, 1010, 1638, 3969, 3834, 883, 3870, 339, 3529, 3982, 3630, 2989, 2404, 1377, 2220, 2243, 3683, 3767, 3015, 1568, 3710, 2456, 2881, 1688, 2855, 3444, 1930, 3421, 1028, 3238, 2494, 1523, 2711, 4042, 2485, 2791, 1151, 1240, 3220,
  /* r 1, c 4401:4500 */    3469, 1477, 3607, 223, 1987, 620, 2077, 537, 2909, 243, 2348, 3803, 768, 180, 1357, 1938, 617, 2064, 3743, 2940, 3352, 3196, 2861, 146, 816, 1704, 1418, 2465, 2456, 560, 1376, 185, 3426, 2731, 2130, 824, 604, 2229, 1893, 3469, 3873, 1353, 2262, 2386, 2057, 2893, 2933, 3472, 1907, 3552, 2903, 2299, 2882, 2444, 2992, 983, 3770, 1447, 154, 1129, 3510, 3927, 163, 1340, 1602, 1115, 4004, 172, 363, 1364, 2160, 573, 115, 2017, 1319, 2686, 1135, 598, 3651, 46, 1995, 762, 1833, 3485, 2948, 4038, 2224, 1325, 3839, 1890, 188, 626, 965, 69, 1217, 1367, 2161, 3461, 2380, 166,
  /* r 1, c 4501:4600 */    3184, 516, 621, 424, 3154, 3009, 1409, 1526, 2911, 1108, 4076, 2677, 1462, 720, 1120, 2468, 1629, 2741, 829, 1134, 2168, 2086, 3939, 3086, 1880, 3741, 434, 1983, 3841, 3354, 1925, 3246, 1665, 2074, 303, 2659, 3615, 2054, 2075, 2150, 2450, 3993, 935, 3137, 1241, 2216, 821, 1961, 1623, 1573, 3565, 952, 1304, 3688, 357, 3517, 1194, 1548, 3469, 3961, 151, 1743, 3988, 3606, 3753, 494, 1258, 1108, 3228, 2255, 1411, 3250, 214, 2881, 1222, 1440, 588, 2452, 2969, 1552, 2431, 156, 2825, 2590, 2445, 2093, 2076, 2345, 3412, 1364, 2108, 738, 2880, 3841, 3161, 659, 458, 263, 453, 3045,
  /* r 1, c 4601:4700 */    2446, 1028, 469, 3599, 677, 1644, 3900, 3523, 767, 999, 557, 1097, 2795, 2622, 1446, 967, 2607, 615, 320, 3330, 3964, 522, 983, 1059, 219, 1325, 418, 3047, 906, 3225, 161, 3706, 1514, 2018, 1905, 3785, 3199, 1345, 2805, 2977, 2352, 252, 20, 2783, 3314, 1386, 1779, 731, 3809, 3134, 3427, 3972, 2170, 4064, 2869, 3690, 4074, 2478, 312, 512, 3905, 199, 2592, 1210, 2629, 2471, 3088, 1609, 2067, 1732, 2598, 1090, 2575, 1193, 1618, 2572, 1409, 3834, 2968, 1510, 2025, 2010, 2785, 3647, 3700, 1951, 608, 3542, 3127, 109, 1840, 963, 227, 4059, 1744, 3450, 200, 346, 1846, 1391,
  /* r 1, c 4701:4800 */    3540, 2262, 3353, 2164, 3957, 1019, 3453, 524, 2939, 701, 824, 2547, 3468, 807, 1061, 3945, 2688, 2656, 983, 2650, 2291, 2326, 2958, 3191, 2176, 2760, 3569, 17, 2180, 1052, 3073, 1888, 1154, 3206, 1565, 1813, 124, 2372, 3627, 3718, 2877, 469, 804, 3488, 771, 2198, 3912, 1491, 3259, 2507, 3209, 2300, 287, 1763, 2153, 470, 1154, 1623, 2883, 1761, 737, 806, 3177, 327, 3101, 3500, 3008, 1788, 20, 2551, 3920, 2850, 3476, 2504, 2808, 1695, 3009, 247, 503, 1610, 4013, 3711, 2439, 2718, 3814, 936, 2007, 4050, 937, 974, 713, 1612, 1802, 383, 776, 921, 1031, 272, 1086, 232,
  /* r 1, c 4801:4900 */    3237, 1355, 1054, 1756, 2315, 3488, 3204, 4030, 3790, 475, 3952, 1149, 3833, 1811, 1618, 997, 313, 3469, 1522, 1267, 1, 2507, 681, 703, 3496, 1929, 3673, 65, 2239, 3840, 189, 2893, 3739, 945, 279, 2105, 354, 3944, 1964, 3177, 2441, 593, 2725, 917, 3207, 1553, 3740, 714, 873, 381, 32, 3207, 849, 1841, 1877, 680, 3291, 3469, 2655, 1651, 639, 160, 95, 4067, 2321, 2801, 857, 1173, 3413, 3284, 3072, 986, 2078, 2341, 1646, 4007, 1479, 3284, 2738, 248, 302, 3400, 1252, 2965, 2294, 1243, 2083, 3395, 693, 3647, 3031, 2807, 3665, 361, 1262, 3691, 856, 3928, 372, 1076,
  /* r 1, c 4901:5000 */    1547, 461, 3330, 2906, 825, 364, 3686, 887, 1996, 2181, 2035, 3589, 18, 1956, 354, 2070, 678, 3692, 1998, 2105, 2965, 3827, 3940, 3903, 366, 3902, 2485, 1129, 1282, 65, 1418, 1855, 3575, 3380, 1933, 2820, 849, 2961, 3136, 3548, 3039, 3594, 2453, 2625, 2891, 4027, 31, 1537, 2122, 2097, 2083, 2053, 3962, 1016, 3576, 2123, 1800, 1608, 76, 1555, 3979, 1159, 3187, 1926, 2172, 3389, 3860, 1052, 1120, 305, 2932, 1959, 2776, 3874, 1309, 1142, 1146, 1890, 2539, 3926, 2015, 678, 1844, 2972, 3261, 1095, 4012, 2103, 3515, 1555, 776, 1442, 2048, 749, 1266, 780, 1503, 2785, 3563, 3675,
  /* r 1, c 5001:5100 */    3851, 3204, 3569, 2349, 1109, 3306, 618, 1415, 1620, 47, 3336, 492, 3070, 929, 1808, 2239, 1099, 932, 3498, 3454, 2345, 3851, 3115, 3874, 274, 1661, 2965, 2826, 956, 3221, 2756, 2057, 679, 1072, 1925, 682, 1240, 340, 2878, 1003, 3, 201, 3597, 1559, 933, 271, 1197, 3816, 368, 66, 88, 2989, 3636, 1580, 2045, 579, 1664, 1117, 152, 2396, 2872, 1332, 3098, 3025, 1405, 2964, 1759, 1848, 3649, 2840, 1391, 2678, 4045, 640, 2830, 3274, 1000, 1602, 3001, 753, 2228, 1002, 3959, 3496, 1308, 3883, 2648, 1546, 1723, 1964, 1735, 308, 2968, 2454, 384, 2630, 2355, 3333, 2019, 782,
  /* r 1, c 5101:5200 */    844, 1966, 2302, 1036, 4054, 881, 119, 3291, 3653, 1837, 763, 3309, 2959, 1519, 1768, 556, 384, 3842, 3725, 2198, 2017, 1307, 3120, 648, 723, 127, 1139, 3417, 1043, 3428, 2648, 3383, 975, 2150, 666, 3135, 149, 1751, 1120, 997, 494, 4008, 3571, 3235, 2442, 787, 1089, 3800, 3660, 2102, 644, 3958, 1567, 531, 2150, 3430, 3418, 651, 3615, 29, 1512, 108, 32, 2428, 327, 2909, 1149, 1048, 2480, 3230, 715, 2452, 2062, 3754, 2590, 541, 3751, 2567, 3837, 1920, 1651, 3015, 1026, 2465, 1285, 3808, 1303, 398, 1296, 3558, 3822, 2433, 3156, 1139, 3063, 194, 3893, 1542, 2233, 429,
  /* r 1, c 5201:5300 */    3048, 1982, 651, 139, 1170, 1529, 3289, 3218, 1560, 1480, 660, 3795, 196, 654, 440, 1716, 765, 133, 952, 2469, 1932, 3444, 1600, 3502, 2093, 3230, 82, 1220, 1651, 837, 303, 1719, 3725, 2462, 290, 4064, 1430, 2311, 567, 723, 3085, 2884, 1072, 3474, 226, 3013, 1574, 2296, 870, 2271, 3163, 3155, 3079, 2939, 1025, 3865, 2876, 1889, 3889, 1774, 3405, 478, 1910, 123, 2936, 2245, 1361, 2839, 1724, 1332, 1048, 2363, 827, 973, 1475, 139, 2422, 441, 4060, 824, 3016, 2819, 2772, 2881, 2811, 1349, 1290, 1241, 3531, 1575, 1599, 666, 3668, 2147, 912, 2646, 392, 1818, 3518, 888,
  /* r 1, c 5301:5400 */    3423, 2111, 535, 3443, 1754, 1657, 1196, 2807, 2050, 1969, 3116, 2773, 4027, 1398, 782, 2504, 602, 685, 3182, 3630, 3590, 2427, 3247, 2237, 2173, 2091, 3153, 2739, 3824, 194, 1967, 155, 2924, 2759, 924, 2508, 2302, 2899, 737, 3279, 2765, 2296, 2434, 2101, 3792, 3288, 1960, 992, 530, 3699, 1617, 4058, 1935, 3763, 2713, 503, 1647, 3996, 375, 2780, 2977, 2953, 2391, 122, 2952, 1091, 2381, 1108, 1640, 1644, 673, 1682, 1222, 326, 1614, 3026, 4031, 3231, 2130, 4043, 2659, 3056, 3793, 2964, 243, 1951, 2568, 712, 2611, 1976, 3134, 456, 967, 1859, 2660, 3705, 2138, 2659, 3814, 2250,
  /* r 1, c 5401:5500 */    2846, 3649, 3321, 2924, 1340, 1844, 794, 1525, 2044, 1678, 2935, 3951, 246, 213, 2115, 3493, 4005, 476, 4058, 3662, 176, 3774, 3003, 1508, 1137, 3311, 945, 2203, 162, 1197, 2722, 1239, 4002, 167, 4043, 1057, 704, 885, 3291, 103, 2894, 3550, 2977, 2499, 756, 2033, 1994, 1141, 795, 418, 786, 3130, 3345, 4026, 433, 2338, 504, 3557, 793, 1820, 1150, 3560, 3947, 2831, 3653, 3187, 2804, 143, 1233, 3207, 1736, 1540, 639, 130, 2514, 2331, 953, 3849, 451, 3539, 987, 3322, 117, 1099, 352, 2419, 2014, 2593, 1834, 1355, 2306, 688, 1550, 2009, 1698, 403, 3142, 1194, 628, 3872,
  /* r 1, c 5501:5600 */    2465, 3781, 2216, 1881, 1581, 3458, 2041, 2038, 1019, 137, 3785, 2192, 697, 392, 3764, 2842, 3498, 3019, 3321, 891, 3697, 3363, 2823, 1645, 238, 48, 1423, 3702, 1964, 3465, 3895, 1290, 3371, 3848, 1177, 1701, 2547, 1155, 2729, 2557, 2321, 940, 1130, 1230, 1268, 322, 75, 2997, 2146, 813, 2204, 4049, 3454, 3285, 3631, 4075, 1071, 2421, 3846, 3441, 3943, 50, 1460, 1075, 951, 1068, 497, 3771, 2451, 172, 1246, 3276, 2303, 1440, 3647, 1529, 3825, 3866, 1249, 2606, 3132, 3183, 2534, 2787, 15, 266, 692, 2224, 316, 4080, 1025, 1151, 440, 743, 21, 3920, 1653, 1886, 3343, 3417,
  /* r 1, c 5601:5700 */    1722, 1690, 411, 2702, 2661, 1735, 1747, 342, 2034, 1716, 2855, 3784, 1940, 459, 119, 1027, 2158, 887, 3519, 1826, 4072, 1224, 3750, 3358, 2698, 3688, 268, 3602, 1855, 1115, 3059, 307, 1377, 747, 57, 2494, 1912, 881, 1963, 135, 606, 1049, 3907, 1700, 2917, 759, 3116, 2355, 388, 2093, 4083, 1615, 3081, 1795, 1659, 2969, 1197, 2445, 2531, 2736, 635, 615, 1835, 3091, 3647, 910, 3646, 2039, 3089, 658, 79, 340, 2070, 1621, 2538, 2471, 1712, 7, 1600, 1668, 278, 917, 784, 1410, 3758, 2, 548, 1920, 2892, 1336, 2459, 2376, 3775, 1794, 1651, 846, 596, 1881, 1442, 449,
  /* r 1, c 5701:5800 */    3643, 1190, 1517, 3545, 972, 2191, 2526, 3979, 1611, 3595, 3331, 3153, 718, 3489, 2848, 2953, 1851, 714, 3265, 2534, 470, 2080, 1207, 1060, 3732, 2323, 415, 2190, 2190, 4079, 3075, 327, 1954, 4036, 3541, 3644, 3001, 3500, 751, 1838, 618, 73, 3124, 4024, 2678, 2826, 2775, 3659, 3572, 1558, 3137, 1282, 2829, 3877, 1749, 3016, 285, 3809, 2698, 4013, 1667, 3198, 3672, 1617, 3263, 1081, 649, 923, 95, 2634, 157, 2427, 3263, 1615, 180, 2560, 1737, 2521, 519, 2981, 1529, 3446, 3196, 3055, 3652, 2688, 3763, 3482, 232, 2441, 2863, 2104, 1699, 377, 1193, 2081, 2617, 74, 1917, 1168,
  /* r 1, c 5801:5900 */    1976, 2775, 1067, 2794, 211, 2141, 1190, 3257, 4024, 2413, 1263, 3412, 1531, 1749, 4064, 2747, 3195, 428, 3261, 2302, 2500, 2300, 739, 2463, 2527, 1097, 417, 3592, 1528, 2178, 3640, 2475, 3769, 1857, 2422, 3111, 170, 2885, 3468, 875, 53, 1924, 347, 3424, 1027, 1706, 2816, 2543, 3417, 986, 497, 2465, 3788, 2126, 614, 3517, 982, 3020, 1875, 154, 1840, 126, 103, 281, 2322, 3673, 1626, 758, 600, 3108, 3344, 2912, 2556, 211, 3577, 2965, 60, 1490, 2562, 2407, 607, 218, 3973, 3887, 1626, 1604, 912, 1399, 2330, 3734, 240, 685, 2396, 4023, 2717, 3043, 3018, 899, 2365, 1549,
  /* r 1, c 5901:6000 */    1530, 1275, 422, 1834, 905, 1944, 1350, 70, 2318, 729, 3128, 3022, 3633, 2899, 294, 3346, 1860, 2281, 894, 1139, 2957, 875, 3781, 3488, 3060, 203, 2551, 694, 2372, 3818, 2894, 2974, 879, 611, 73, 3248, 1969, 648, 2913, 1422, 2761, 1853, 222, 472, 3506, 255, 3283, 1653, 3730, 2270, 2852, 1595, 3508, 1815, 801, 654, 3112, 2519, 1179, 541, 967, 3846, 2058, 2178, 3740, 3079, 1986, 2555, 3420, 646, 2018, 1626, 1461, 2415, 2952, 2205, 96, 2198, 1762, 1893, 3866, 1765, 591, 354, 927, 741, 692, 384, 1726, 3876, 952, 2629, 366, 488, 2981, 898, 3013, 3198, 2825, 1838,
  /* r 1, c 6001:6100 */    3763, 3642, 2963, 2381, 217, 2532, 1158, 1420, 804, 2989, 2534, 3029, 3842, 193, 2971, 3847, 591, 817, 667, 3150, 553, 2705, 3505, 3215, 627, 3889, 1181, 3611, 3173, 628, 3927, 541, 477, 956, 2524, 1481, 3372, 3776, 2074, 1125, 873, 3977, 2139, 1315, 832, 2785, 2633, 2006, 3322, 1146, 2839, 2112, 2975, 977, 897, 650, 3053, 854, 3149, 2883, 4075, 516, 3492, 3578, 336, 143, 2831, 1326, 117, 1481, 515, 493, 668, 80, 3000, 743, 3649, 3277, 1506, 1760, 3134, 3979, 1161, 2298, 378, 1996, 4065, 3231, 3, 3051, 1692, 1422, 3662, 3830, 154, 4002, 1964, 611, 1184, 1858,
  /* r 1, c 6101:6200 */    1687, 3286, 1481, 3932, 667, 122, 3724, 3267, 1268, 1031, 1793, 1367, 2611, 571, 1069, 1746, 936, 1069, 3596, 2708, 2247, 316, 1876, 1819, 2962, 752, 3129, 598, 3068, 3725, 536, 3966, 25, 2928, 421, 4052, 1553, 3964, 600, 2372, 982, 2703, 308, 506, 959, 384, 1617, 4037, 1271, 1525, 94, 3619, 804, 3422, 150, 775, 33, 281, 3150, 1134, 870, 399, 780, 3951, 3494, 3471, 3080, 3212, 3089, 3366, 1034, 3727, 1962, 1235, 3376, 1072, 2709, 2938, 3233, 1423, 4091, 4068, 349, 645, 2858, 1633, 2173, 438, 26, 1900, 3959, 1842, 2907, 2212, 142, 181, 3264, 4084, 3448, 1579,
  /* r 1, c 6201:6300 */    2929, 641, 2068, 884, 3123, 1104, 1923, 3060, 3120, 1852, 2209, 734, 3890, 2873, 2898, 2635, 2880, 2545, 3636, 1896, 977, 1459, 1429, 1962, 2478, 3937, 1589, 3275, 1774, 1727, 1542, 160, 2511, 1710, 1936, 2624, 1978, 2509, 88, 2822, 691, 3391, 1871, 3074, 1181, 1078, 504, 3886, 589, 740, 2090, 3799, 876, 2220, 2711, 561, 3904, 523, 1881, 3750, 2538, 25, 3489, 3310, 986, 2998, 3554, 138, 1917, 3457, 3986, 1245, 693, 3006, 1818, 1957, 150, 2782, 887, 1197, 1534, 3961, 2122, 1589, 1197, 3830, 2686, 2257, 1903, 395, 3391, 3854, 3316, 3232, 3355, 2610, 4027, 1518, 1765, 1906,
  /* r 1, c 6301:6400 */    3951, 147, 648, 37, 3286, 587, 3733, 1767, 545, 390, 3825, 3898, 1044, 3788, 1900, 2448, 1535, 2082, 3788, 448, 2685, 2155, 274, 199, 2786, 3269, 2362, 3567, 2463, 3843, 748, 2419, 3814, 3225, 1148, 1009, 3983, 82, 3949, 3847, 3223, 3863, 3088, 3209, 2659, 1941, 2755, 3615, 1560, 1995, 2481, 3699, 1228, 571, 3441, 2372, 1323, 403, 3780, 2368, 587, 2034, 1402, 87, 1059, 321, 2422, 3628, 1452, 2823, 613, 2756, 1130, 1114, 1358, 871, 231, 762, 2662, 2648, 2278, 2456, 664, 1780, 3567, 3481, 1169, 2837, 2576, 93, 2742, 3748, 2538, 3660, 17, 3867, 86, 6, 923, 849,
  /* r 1, c 6401:6500 */    1563, 3571, 1110, 3898, 2009, 512, 2093, 1235, 2456, 3345, 3512, 391, 1305, 3346, 2761, 760, 146, 2537, 3324, 2259, 4039, 1660, 1124, 854, 3976, 3849, 1077, 532, 760, 2080, 3094, 3567, 4014, 2569, 2677, 2138, 1676, 3038, 901, 1888, 3742, 50, 820, 1621, 509, 512, 904, 3138, 1700, 1164, 3156, 41, 2045, 3499, 1614, 3391, 2973, 639, 1555, 1380, 1926, 3164, 3730, 2568, 3892, 405, 3511, 791, 2261, 2557, 693, 768, 3888, 376, 1023, 3030, 2500, 1839, 1330, 3173, 2135, 3026, 2308, 2501, 2838, 2645, 2779, 3121, 1269, 1338, 2528, 1018, 2463, 3817, 759, 2514, 638, 445, 2978, 1215,
  /* r 1, c 6501:6600 */    926, 3143, 353, 2562, 3069, 1023, 2074, 3030, 1344, 3102, 3472, 2792, 3575, 2285, 234, 3585, 2891, 3468, 3542, 3381, 315, 1299, 2201, 1786, 1972, 2265, 1649, 1428, 942, 180, 359, 1187, 1940, 2770, 3344, 2954, 2196, 2724, 1857, 1033, 1222, 1684, 1261, 2107, 1161, 3279, 3750, 2059, 2218, 3814, 2202, 2557, 1344, 2592, 2540, 2501, 2798, 1792, 3997, 1432, 2769, 1729, 2634, 3235, 3147, 3977, 2204, 2300, 2092, 3537, 3123, 2290, 1921, 3670, 2059, 3450, 1738, 1921, 2502, 712, 1173, 1330, 347, 2405, 1767, 884, 225, 1701, 2079, 26, 2730, 2394, 660, 2048, 1671, 1603, 3203, 1910, 3480, 4079,
  /* r 1, c 6601:6700 */    1599, 2931, 593, 532, 790, 719, 269, 3681, 2101, 1543, 3456, 300, 852, 3431, 2052, 1328, 352, 523, 2051, 3814, 960, 3035, 1899, 3951, 1705, 3444, 393, 3924, 2516, 3673, 865, 1328, 1144, 202, 2694, 1938, 3152, 2890, 1790, 2848, 2059, 1178, 2508, 792, 3560, 3374, 4025, 3305, 3661, 505, 506, 2787, 4043, 332, 2017, 2547, 3590, 1964, 3721, 12, 957, 844, 357, 846, 1819, 714, 3107, 1407, 3368, 1586, 1143, 2820, 1527, 1197, 2229, 1620, 451, 2293, 2601, 2328, 1797, 3883, 1507, 1583, 3180, 1190, 1226, 3402, 1984, 2775, 2020, 2848, 1903, 2323, 241, 445, 3112, 1121, 3393, 233,
  /* r 1, c 6701:6800 */    168, 959, 348, 2471, 1453, 2787, 331, 1852, 2899, 4021, 1191, 1697, 2701, 3835, 746, 206, 3134, 2065, 3267, 427, 2004, 3636, 435, 89, 3949, 379, 365, 2321, 2161, 345, 1196, 15, 460, 3873, 1185, 3237, 940, 974, 2485, 1729, 467, 3759, 3675, 2719, 1087, 2031, 324, 213, 3824, 3235, 310, 196, 1949, 2880, 929, 2432, 1725, 2130, 2830, 2016, 607, 3072, 1419, 1056, 4071, 2996, 3205, 3009, 1032, 2233, 1891, 1793, 784, 954, 3337, 2278, 3000, 2403, 3849, 348, 689, 3478, 1637, 3727, 1299, 3233, 3993, 58, 4030, 980, 3122, 143, 3713, 2835, 3628, 121, 2029, 3954, 2297, 193,
  /* r 1, c 6801:6900 */    2574, 2839, 2103, 469, 401, 3772, 2400, 77, 793, 849, 1387, 742, 3827, 946, 3013, 964, 326, 820, 1166, 529, 442, 3318, 3810, 1065, 3724, 1620, 2094, 3875, 2023, 3905, 3087, 1171, 3069, 216, 1687, 1080, 2613, 2813, 700, 1608, 3589, 2806, 1923, 2214, 42, 2764, 3361, 3521, 1149, 2901, 2382, 1141, 1603, 4071, 672, 336, 3615, 3560, 479, 960, 4036, 2345, 1308, 769, 3918, 663, 2396, 2740, 1790, 338, 2235, 1341, 2358, 2687, 2298, 303, 3036, 3771, 888, 2406, 541, 2888, 962, 3173, 947, 2911, 2859, 2738, 2159, 2525, 790, 1194, 3482, 968, 343, 2398, 1949, 1702, 81, 198,
  /* r 1, c 6901:7000 */    1859, 3996, 1617, 2159, 3945, 1609, 4016, 771, 2350, 1372, 896, 964, 524, 1470, 1943, 2574, 3589, 2129, 1311, 1670, 1663, 650, 3404, 190, 15, 2609, 3763, 3642, 3625, 1395, 1164, 2790, 1333, 3285, 3635, 2388, 2238, 1646, 3, 1888, 1715, 1532, 1206, 41, 3492, 1588, 1515, 3495, 190, 1631, 775, 3470, 1235, 1389, 3471, 1569, 2029, 3066, 1255, 7, 2976, 1544, 1020, 3045, 619, 57, 3765, 384, 3125, 1280, 2123, 108, 2418, 153, 1873, 2887, 882, 3077, 1011, 2176, 1494, 3098, 1509, 1526, 346, 546, 106, 2078, 3265, 2839, 3069, 562, 82, 3282, 243, 2347, 3810, 1943, 2520, 353,
  /* r 1, c 7001:7100 */    626, 1486, 2896, 412, 816, 1004, 174, 499, 2957, 687, 1178, 3450, 1267, 122, 2444, 1932, 3882, 1865, 1271, 1497, 728, 2674, 2848, 2680, 826, 1447, 1502, 2371, 3190, 2176, 956, 2768, 427, 3302, 4032, 1316, 919, 993, 3969, 3984, 1958, 3762, 3008, 2763, 2834, 2991, 3297, 18, 3608, 3027, 3870, 2006, 3814, 2206, 129, 616, 3965, 1675, 1512, 3398, 3624, 670, 2860, 3590, 855, 1884, 2411, 3762, 516, 2414, 1380, 3218, 1722, 0, 793, 2412, 1594, 2591, 3504, 1244, 1684, 2257, 1144, 2465, 1125, 3752, 1990, 3330, 2454, 1261, 2406, 2805, 1618, 1952, 1989, 2366, 3575, 1814, 1635, 1770,
  /* r 1, c 7101:7200 */    3603, 3712, 1692, 3659, 1370, 924, 304, 3635, 3709, 2927, 3752, 143, 1636, 3190, 3533, 51, 1466, 1198, 3127, 216, 2769, 993, 1576, 2591, 1877, 3656, 805, 2112, 3583, 2630, 3307, 862, 3574, 341, 1033, 1828, 3797, 757, 1108, 2955, 1333, 3696, 3735, 1090, 1653, 1654, 3703, 756, 1186, 3214, 853, 2016, 2142, 680, 138, 3794, 2822, 1058, 4014, 901, 360, 3837, 826, 2951, 3223, 2491, 1570, 767, 1920, 3673, 2572, 3648, 1796, 300, 128, 953, 4066, 3945, 2188, 38, 4020, 1177, 2151, 2481, 126, 2823, 101, 1227, 3323, 1816, 3424, 3277, 3343, 2018, 3708, 3911, 2392, 700, 1525, 20,
  /* r 1, c 7201:7300 */    991, 878, 2464, 605, 327, 216, 3350, 2124, 2163, 88, 529, 2764, 3668, 147, 253, 1516, 3912, 3127, 62, 1454, 1410, 1676, 1681, 417, 3665, 2747, 987, 1371, 1597, 2850, 3041, 1000, 941, 3818, 853, 1391, 1066, 3128, 1390, 3377, 3536, 115, 3145, 482, 2883, 3813, 62, 1005, 2690, 2102, 2989, 3356, 2177, 2886, 2617, 2848, 3175, 146, 758, 1486, 2884, 891, 3364, 2639, 2431, 1280, 1982, 3545, 2704, 2461, 2798, 2570, 319, 2908, 1248, 321, 3298, 3138, 2572, 621, 2838, 3537, 3912, 2508, 2531, 1584, 2288, 1134, 3096, 366, 1583, 2071, 35, 1103, 3973, 3047, 42, 1658, 519, 468,
  /* r 1, c 7301:7400 */    945, 122, 2191, 2647, 755, 2382, 2356, 2759, 1784, 17, 3934, 1784, 3523, 368, 2327, 3466, 1234, 819, 3172, 981, 1466, 910, 945, 812, 2194, 3549, 188, 1071, 3566, 427, 3273, 1401, 1598, 3053, 3945, 1047, 3541, 2214, 3044, 559, 877, 3175, 2745, 1984, 3823, 2165, 268, 2073, 269, 1106, 571, 1109, 1521, 1720, 3097, 1827, 523, 1756, 729, 3819, 2194, 2471, 807, 3060, 1319, 2486, 2407, 2235, 3376, 3370, 1493, 2428, 1625, 397, 2756, 2031, 3922, 3353, 1829, 2804, 259, 1702, 121, 278, 2995, 150, 3919, 2758, 769, 1406, 612, 991, 1274, 473, 3746, 1252, 1883, 3653, 1998, 3792,
  /* r 1, c 7401:7500 */    2427, 290, 2926, 1227, 2141, 2642, 2735, 1515, 2818, 1915, 1517, 871, 3791, 179, 2665, 504, 2252, 2214, 1930, 416, 3285, 903, 1159, 186, 3359, 2915, 2295, 1971, 2958, 704, 1295, 1548, 241, 3548, 1992, 464, 2877, 1608, 292, 434, 2092, 3343, 2836, 1221, 271, 273, 1038, 59, 3030, 15, 3425, 769, 1818, 1127, 2773, 3499, 491, 872, 2737, 4084, 3309, 1407, 2099, 978, 398, 3089, 185, 306, 151, 3213, 3649, 1529, 2897, 3716, 469, 171, 2860, 3148, 143, 2157, 2714, 2932, 1856, 1736, 149, 1554, 2625, 1149, 3302, 1819, 2895, 566, 3249, 444, 3002, 269, 3115, 1893, 2446, 1115,
  /* r 1, c 7501:7600 */    819, 3644, 3402, 2775, 1467, 3997, 3549, 2306, 1446, 1460, 1109, 213, 3459, 1814, 3995, 2311, 2967, 2208, 1399, 2645, 2276, 1774, 896, 3360, 2547, 3846, 1495, 1815, 3815, 169, 1207, 1371, 2741, 2118, 1756, 3423, 2065, 4044, 994, 3134, 343, 1330, 1946, 3633, 2319, 741, 2830, 4071, 3814, 2120, 279, 1807, 3949, 37, 3840, 2288, 1877, 2979, 3828, 1355, 230, 3289, 1716, 838, 573, 940, 516, 1765, 731, 2941, 3262, 535, 1188, 766, 1052, 315, 385, 1404, 342, 2855, 397, 510, 2991, 1499, 3560, 2112, 2366, 3103, 846, 3641, 419, 2236, 3387, 3754, 19, 375, 2237, 3783, 321, 392,
  /* r 1, c 7601:7700 */    3331, 3935, 3473, 330, 1890, 4031, 388, 3951, 4089, 111, 113, 407, 3485, 2710, 3872, 3882, 1504, 1122, 3934, 2321, 3950, 2794, 2468, 1773, 2952, 745, 2708, 2108, 183, 2906, 1326, 3982, 3957, 1019, 1545, 462, 1753, 413, 3985, 1024, 639, 3391, 2073, 4043, 2726, 2009, 1718, 801, 2790, 665, 226, 2933, 2457, 2272, 541, 2856, 89, 3994, 2518, 3377, 2064, 3057, 1016, 875, 3428, 2217, 3366, 2138, 2395, 3939, 3880, 1572, 1672, 1230, 2217, 44, 3712, 1622, 992, 3551, 223, 2638, 3898, 4043, 1868, 2273, 1418, 1923, 1749, 2483, 86, 1982, 1866, 776, 2443, 4006, 1742, 3717, 2666, 220,
  /* r 1, c 7701:7800 */    1498, 1423, 3488, 482, 1367, 2175, 1969, 2365, 3383, 3527, 3924, 2971, 3542, 2303, 2518, 438, 2002, 3024, 127, 1875, 1145, 2253, 3798, 171, 1009, 3363, 1908, 3529, 597, 3556, 137, 2508, 4024, 741, 3314, 1651, 4082, 1990, 3789, 1980, 357, 1534, 4003, 1346, 1022, 762, 1887, 2230, 3930, 1968, 2121, 88, 2391, 3192, 388, 2408, 2066, 1592, 498, 3540, 156, 2570, 3429, 301, 3686, 1188, 3913, 3317, 3717, 3947, 3705, 1896, 1668, 1456, 1155, 3151, 2171, 2363, 2484, 3932, 2393, 1514, 1063, 3604, 1456, 113, 813, 865, 3781, 1413, 520, 2217, 1210, 2572, 688, 2609, 337, 1255, 2565, 272,
  /* r 1, c 7801:7900 */    484, 1631, 739, 1052, 3636, 2090, 3301, 3781, 1578, 2719, 2399, 3200, 4009, 4075, 1783, 368, 63, 1036, 764, 3898, 630, 2805, 3793, 3110, 1149, 1564, 1918, 508, 3196, 2766, 1022, 358, 885, 2756, 1747, 599, 3486, 1255, 2323, 1327, 3682, 3462, 1547, 231, 2243, 1233, 1415, 3344, 3472, 1719, 3091, 1574, 1253, 1200, 1385, 438, 528, 3265, 2794, 735, 4021, 2610, 2445, 3816, 2462, 263, 660, 3098, 998, 3276, 1858, 2395, 194, 1691, 1609, 3532, 1464, 2357, 3565, 3093, 3362, 2331, 572, 2401, 307, 2814, 1204, 3136, 2494, 590, 3431, 3219, 1319, 658, 3642, 3931, 3987, 2567, 3421, 463,
  /* r 1, c 7901:8000 */    1109, 2790, 854, 1226, 3, 2720, 2461, 1140, 3760, 1807, 1940, 2915, 4055, 847, 3817, 2580, 2589, 1617, 3074, 2061, 1250, 507, 2058, 3544, 3407, 3620, 1545, 163, 758, 3801, 4058, 3311, 223, 932, 397, 2874, 1948, 3582, 3529, 3111, 4043, 2117, 1596, 2438, 1150, 2881, 511, 2974, 576, 1232, 1425, 2773, 2561, 3950, 2306, 759, 1788, 68, 1684, 1250, 2917, 2732, 287, 2065, 2414, 3587, 3560, 1359, 1521, 2548, 2732, 3722, 402, 3606, 194, 1979, 3220, 4090, 670, 2540, 387, 2618, 556, 3132, 386, 3631, 445, 961, 257, 1361, 344, 434, 150, 1266, 684, 3859, 1184, 1110, 2732, 3362,
  /* r 1, c 8001:8100 */    1630, 3217, 1426, 407, 863, 710, 1634, 3498, 1063, 3762, 1701, 939, 3471, 601, 79, 3438, 313, 2556, 2243, 3667, 507, 1096, 3840, 2104, 1657, 3632, 666, 976, 2109, 1936, 3761, 953, 95, 2785, 1914, 632, 1037, 2663, 1076, 3278, 893, 542, 2397, 3972, 1311, 1849, 1370, 1604, 1760, 2562, 181, 3152, 2265, 3804, 4071, 877, 1934, 3359, 3938, 2827, 1544, 931, 1805, 3252, 1826, 2838, 476, 622, 2812, 3489, 3685, 3342, 26, 3283, 329, 2891, 641, 963, 3169, 3225, 3148, 1824, 879, 3313, 3987, 2058, 2035, 166, 3882, 20, 642, 1976, 2078, 2596, 1832, 906, 1801, 3709, 1521, 3530,
  /* r 1, c 8101:8200 */    964, 2374, 3916, 3518, 2913, 1058, 2320, 2192, 82, 3860, 2140, 371, 2415, 1842, 2978, 2593, 775, 152, 3321, 2268, 3897, 2921, 4088, 2588, 798, 2802, 2821, 3185, 3195, 3988, 63, 2000, 156, 414, 3466, 2169, 462, 2865, 1108, 2927, 1662, 2399, 3461, 373, 3641, 915, 1693, 1, 1381, 745, 1893, 1467, 2221, 2185, 1270, 3282, 2949, 3347, 1202, 1911, 3396, 2236, 2768, 2484, 2907, 3977, 1979, 2589, 723, 1758, 3304, 2842, 2408, 3917, 864, 209, 884, 642, 1606, 1221, 1790, 2898, 89, 872, 3755, 3747, 1732, 41, 814, 3491, 3509, 2785, 836, 3140, 528, 686, 2290, 120, 1915, 3518,
  /* r 1, c 8201:8300 */    1972, 2576, 716, 1545, 2368, 1139, 365, 3316, 3237, 2901, 1636, 1472, 3388, 857, 3536, 1189, 1721, 1132, 677, 1814, 634, 2512, 2876, 706, 1521, 4017, 394, 1415, 2879, 3543, 2861, 3745, 2404, 2405, 2525, 2410, 418, 1756, 3490, 1389, 2014, 131, 4006, 988, 4002, 223, 1522, 2528, 1576, 3715, 2164, 1757, 2566, 3479, 3447, 439, 130, 433, 109, 2542, 3323, 246, 3042, 106, 2676, 2814, 2275, 2198, 705, 1865, 3256, 2915, 1154, 424, 3169, 1978, 1607, 1524, 481, 2056, 3119, 3566, 3815, 2127, 2713, 3936, 978, 97, 3502, 1561, 1518, 2811, 1096, 1097, 3166, 869, 2154, 33, 610, 2174,
  /* r 1, c 8301:8400 */    2408, 371, 345, 2795, 269, 470, 2221, 464, 3961, 2625, 21, 1120, 3717, 3975, 1370, 3592, 2282, 263, 3607, 1058, 2247, 2667, 1151, 479, 2232, 3242, 1212, 232, 785, 74, 2431, 1555, 1125, 1421, 432, 2515, 29, 1883, 3438, 2665, 1578, 3793, 2461, 3752, 1936, 3358, 2983, 4007, 3612, 2413, 646, 2284, 1930, 3327, 3066, 3030, 1235, 2614, 2064, 3413, 1086, 1588, 754, 4078, 2118, 1397, 2262, 2938, 2297, 773, 3173, 1507, 61, 30, 1395, 3215, 2583, 2922, 1919, 1632, 2599, 3752, 3513, 976, 164, 2229, 2852, 3568, 2568, 3124, 3097, 1302, 298, 2451, 816, 551, 3096, 2623, 2877, 2059,
  /* r 1, c 8401:8500 */    1226, 3550, 2280, 717, 2919, 2743, 4085, 3113, 2594, 2807, 3545, 3917, 3610, 303, 1583, 775, 3418, 1614, 242, 3941, 390, 3081, 3931, 2684, 2684, 3835, 2273, 1922, 238, 1865, 3634, 2344, 3572, 1479, 2580, 3422, 1870, 817, 803, 2146, 2171, 1364, 2440, 3208, 1460, 3059, 940, 1914, 2297, 2536, 1251, 985, 1338, 901, 541, 773, 645, 538, 2438, 1651, 4000, 3412, 3731, 1442, 3074, 385, 2211, 333, 188, 1329, 1922, 3275, 1402, 2448, 1775, 2942, 1828, 2142, 1161, 2599, 4060, 620, 2853, 571, 2119, 1507, 56, 3450, 1128, 171, 3811, 592, 2704, 383, 2997, 1777, 255, 576, 997, 3616,
  /* r 1, c 8501:8600 */    2356, 122, 757, 1353, 3466, 4047, 989, 1024, 774, 3309, 1828, 3803, 582, 848, 3559, 3048, 3658, 476, 3439, 3054, 2079, 131, 3004, 489, 3403, 3413, 317, 814, 1810, 945, 3391, 257, 2183, 1570, 785, 895, 820, 241, 685, 3142, 1192, 3562, 2785, 1471, 3607, 3502, 2495, 3329, 1687, 2564, 1509, 3524, 2991, 3782, 1434, 1495, 81, 948, 2151, 3332, 1938, 1432, 3978, 1423, 1051, 3616, 1446, 364, 3513, 2153, 3745, 1317, 3089, 3014, 1074, 677, 3120, 3555, 2432, 1746, 1229, 3121, 841, 3963, 2669, 2711, 3677, 2479, 577, 641, 1676, 2603, 3441, 875, 4023, 1259, 520, 889, 3577, 1330,
  /* r 1, c 8601:8700 */    2640, 663, 1481, 4085, 3151, 1967, 2862, 3346, 130, 1278, 3031, 931, 2177, 3881, 96, 2543, 2228, 1097, 3582, 1930, 2175, 2460, 1906, 925, 2409, 361, 3466, 223, 3351, 669, 919, 1981, 929, 983, 4065, 3564, 2025, 2801, 2704, 16, 3724, 1251, 1361, 3084, 2157, 1165, 1435, 2888, 1249, 3226, 735, 662, 318, 1096, 3270, 2947, 2855, 1713, 1225, 1607, 2806, 3387, 2432, 3750, 1180, 1235, 1047, 760, 1137, 1405, 3513, 3543, 84, 584, 1411, 2689, 2472, 3469, 2940, 1567, 2286, 2928, 1014, 4061, 3137, 3891, 1966, 3749, 195, 777, 2402, 2705, 3293, 2388, 463, 776, 3123, 4093, 3702, 882,
  /* r 1, c 8701:8800 */    689, 2791, 3829, 3809, 2446, 3723, 2248, 2716, 2258, 1659, 2468, 1136, 3174, 520, 1005, 1456, 705, 2230, 438, 751, 3151, 197, 1336, 2597, 3807, 2102, 2934, 969, 1201, 1406, 900, 3965, 1719, 742, 3039, 3520, 1870, 63, 763, 888, 239, 1286, 679, 688, 2126, 2445, 3554, 2132, 1888, 2937, 2941, 3123, 1376, 2760, 1781, 1301, 1070, 2421, 1301, 745, 2404, 55, 907, 2146, 332, 1931, 3722, 374, 1202, 2043, 1334, 1191, 594, 2234, 1266, 2937, 2179, 3173, 1384, 2987, 82, 2657, 2809, 3952, 3082, 2923, 615, 61, 3474, 3927, 3686, 612, 3905, 1827, 3374, 3253, 4023, 2666, 1852, 2008,
  /* r 1, c 8801:8900 */    1992, 47, 4023, 4084, 1691, 4079, 1536, 3154, 1650, 2937, 1787, 3263, 3322, 2642, 1690, 1818, 3261, 2039, 2806, 171, 2715, 2385, 3940, 129, 2550, 3496, 2230, 4013, 1968, 1551, 340, 2185, 3083, 2552, 3438, 3530, 295, 2678, 2495, 3979, 824, 3300, 677, 1576, 52, 1090, 244, 2075, 1947, 3533, 988, 1175, 1421, 3671, 449, 1312, 112, 3475, 2914, 4050, 3989, 415, 3342, 719, 3897, 968, 855, 3427, 2616, 2388, 2617, 1991, 3479, 1705, 1051, 3134, 1607, 1580, 63, 1214, 2906, 2529, 3475, 1414, 1252, 807, 365, 436, 1030, 1334, 589, 3096, 2307, 1219, 2242, 768, 811, 4088, 507, 153,
  /* r 1, c 8901:9000 */    3625, 568, 2742, 292, 2855, 1917, 1589, 2655, 3529, 3697, 3727, 2725, 2307, 2596, 2669, 1893, 3393, 51, 493, 819, 3492, 3320, 1889, 1223, 1030, 1377, 235, 1722, 917, 2428, 1064, 559, 3574, 416, 3239, 1595, 3700, 1296, 1250, 3382, 2894, 1888, 972, 3791, 548, 1016, 3732, 1478, 1207, 568, 17, 3705, 3975, 1170, 2105, 3329, 458, 1394, 1350, 4011, 730, 2445, 3844, 1685, 2730, 2728, 534, 1914, 3692, 2802, 1434, 2251, 1725, 948, 943, 3773, 823, 2791, 1797, 662, 1880, 517, 1994, 2610, 722, 931, 3078, 3639, 243, 3672, 1799, 2815, 1206, 2532, 1997, 382, 2526, 3504, 2188, 1860,
  /* r 1, c 9001:9100 */    2771, 2323, 3538, 675, 140, 3341, 2199, 2728, 2953, 2076, 3105, 2342, 2843, 870, 1473, 1218, 1628, 965, 75, 802, 448, 3526, 3551, 2802, 3194, 2822, 2461, 1269, 1451, 1699, 3637, 2368, 789, 1833, 684, 1779, 3103, 3929, 273, 374, 1149, 507, 4013, 143, 80, 595, 1010, 1569, 2620, 2867, 3831, 3630, 2264, 2626, 3658, 186, 1698, 2273, 3473, 2826, 1052, 3792, 2094, 1176, 2451, 62, 3244, 1951, 3724, 3688, 3043, 2341, 904, 3702, 1953, 2458, 1477, 785, 298, 2973, 892, 333, 1259, 3117, 3167, 1146, 3121, 2105, 279, 2660, 2625, 933, 450, 3722, 3876, 3089, 3233, 4017, 2072, 3804,
  /* r 1, c 9101:9200 */    4079, 1125, 866, 3009, 612, 2067, 498, 1882, 1904, 1520, 1159, 1188, 3351, 265, 813, 168, 3349, 2079, 3718, 1280, 4090, 271, 1493, 1844, 2447, 2069, 2424, 835, 2698, 1458, 2528, 630, 2293, 2407, 3781, 1835, 2841, 2734, 2531, 2039, 2683, 188, 3493, 3800, 3837, 2127, 205, 1119, 1905, 856, 1748, 2979, 3860, 792, 1913, 1994, 275, 3805, 1258, 2784, 1293, 1887, 1771, 2139, 52, 3178, 2415, 241, 2146, 3530, 726, 469, 371, 3088, 3765, 1133, 2203, 1219, 1043, 2995, 936, 1540, 688, 2061, 487, 1752, 3967, 2169, 1007, 196, 1649, 3242, 3996, 3237, 4076, 1309, 1237, 3684, 775, 1495,
  /* r 1, c 9201:9300 */    1195, 3427, 3431, 2646, 1441, 3488, 2699, 359, 1243, 509, 3623, 2452, 4094, 3305, 1133, 3795, 3920, 1212, 2894, 2165, 3412, 286, 1773, 648, 39, 3708, 3875, 2779, 823, 3919, 2603, 2427, 2596, 2983, 2597, 2099, 1925, 990, 1619, 2166, 1439, 291, 945, 2770, 2428, 3137, 2469, 3360, 2310, 227, 3704, 2024, 223, 3258, 3869, 1798, 1716, 2194, 3147, 2821, 416, 2593, 1881, 1975, 506, 2895, 2038, 1449, 265, 1253, 2438, 1556, 2578, 3548, 2171, 2612, 1716, 688, 2043, 3744, 3482, 2526, 2432, 2510, 3574, 2059, 3925, 3355, 674, 120, 250, 202, 3490, 1058, 1270, 308, 717, 1648, 3245, 2990,
  /* r 1, c 9301:9400 */    1881, 1068, 2954, 3085, 560, 2624, 2894, 1892, 2368, 2557, 3190, 3447, 3628, 2468, 1991, 2234, 3682, 3021, 3775, 3721, 1883, 3372, 1700, 2877, 3957, 3105, 2599, 576, 2467, 1920, 600, 2631, 3915, 969, 1664, 335, 545, 555, 1480, 1154, 733, 1944, 0, 1300, 500, 3270, 416, 2601, 2381, 2112, 632, 2911, 2618, 520, 2149, 3542, 2621, 827, 2358, 644, 1831, 3606, 2950, 3528, 1072, 2934, 642, 905, 3542, 2000, 3860, 1126, 2559, 3601, 3735, 1201, 2595, 2100, 1620, 1475, 735, 2613, 1395, 1133, 42, 2775, 499, 3410, 2971, 993, 2683, 3434, 1441, 435, 721, 306, 2937, 1511, 1173, 217,
  /* r 1, c 9401:9500 */    1802, 3347, 119, 615, 1986, 479, 1347, 4050, 3894, 3822, 101, 2863, 3093, 359, 1557, 2076, 143, 1246, 3786, 2819, 2746, 1613, 2012, 2539, 3402, 2738, 2276, 184, 2901, 3896, 3188, 2568, 1094, 943, 2870, 1604, 2611, 460, 3223, 2087, 264, 941, 1515, 2328, 1154, 3403, 2345, 3781, 3577, 2592, 404, 3761, 270, 3981, 1778, 3594, 387, 215, 4030, 3600, 3649, 1572, 1887, 407, 473, 118, 194, 1944, 906, 3947, 3619, 3409, 2746, 2503, 2723, 2734, 1522, 3929, 2757, 2183, 837, 1746, 2073, 3316, 293, 2124, 314, 3899, 3349, 2079, 1686, 1204, 3836, 1907, 1280, 2745, 3663, 3940, 3465, 3886,
  /* r 1, c 9501:9600 */    510, 2519, 564, 1316, 252, 174, 2352, 613, 2434, 3166, 1535, 681, 160, 2919, 947, 3791, 3031, 2741, 330, 1385, 3457, 2724, 1229, 255, 2978, 3488, 1350, 1109, 3877, 3345, 2601, 237, 3540, 2251, 67, 3734, 965, 3429, 3808, 1893, 2685, 3955, 3885, 3751, 3609, 1989, 3058, 657, 1090, 638, 2771, 3971, 1232, 2233, 110, 2662, 2851, 3688, 1655, 1556, 3183, 2986, 1039, 1328, 1924, 1581, 2361, 1341, 2983, 3730, 3, 3655, 183, 3484, 29, 842, 1314, 2380, 3075, 122, 771, 3276, 1878, 1306, 4036, 1030, 4021, 1964, 3419, 1581, 3212, 2718, 49, 3881, 3152, 634, 2126, 1239, 984, 3319,
  /* r 1, c 9601:9700 */    3239, 71, 1633, 3934, 3806, 1405, 1574, 33, 304, 2925, 1822, 3313, 2055, 995, 3476, 1555, 2767, 419, 3490, 3384, 2731, 1714, 1145, 3029, 1781, 841, 1103, 1573, 2211, 3455, 172, 1532, 1900, 1673, 1806, 3224, 746, 2715, 1725, 3206, 3762, 590, 3977, 596, 3090, 3136, 3192, 691, 2774, 2639, 2151, 1273, 2327, 1279, 2984, 707, 3661, 2134, 2158, 2852, 2689, 2864, 1251, 1386, 3183, 693, 737, 154, 3989, 2249, 1438, 993, 78, 2616, 2106, 111, 1837, 3845, 3252, 3885, 417, 553, 1362, 1068, 666, 1971, 3846, 3505, 1052, 2670, 3197, 1634, 3001, 2079, 1522, 1439, 3622, 963, 3900, 1076,
  /* r 1, c 9701:9800 */    2213, 1182, 474, 2273, 2402, 3595, 1596, 1286, 2881, 2185, 2773, 1108, 1869, 1796, 2825, 1414, 1280, 1251, 3404, 2149, 2040, 2452, 302, 3092, 1685, 644, 246, 841, 1153, 629, 1593, 3955, 3086, 2793, 4006, 4055, 1561, 2523, 2284, 1039, 740, 364, 2562, 3398, 443, 3869, 330, 166, 3509, 1071, 866, 2141, 1499, 3629, 578, 2729, 1555, 1569, 3231, 3844, 781, 2310, 439, 467, 2034, 2828, 491, 2961, 3070, 3894, 983, 2979, 1476, 1379, 697, 3903, 374, 1579, 2342, 2742, 1506, 2291, 1081, 1242, 2763, 2956, 2746, 951, 1382, 499, 1603, 112, 1817, 870, 3352, 4037, 1277, 1694, 1208, 180,
  /* r 1, c 9801:9900 */    665, 332, 973, 1676, 595, 510, 2748, 3222, 2851, 3134, 2428, 1144, 2187, 2352, 2793, 3475, 1551, 4085, 44, 303, 1131, 996, 1180, 2089, 3995, 818, 2752, 1646, 2137, 2524, 2085, 519, 1154, 3823, 582, 2553, 1387, 51, 3869, 3080, 994, 3960, 2900, 754, 2255, 3172, 2626, 3145, 708, 2431, 49, 942, 481, 503, 1369, 3523, 3426, 1392, 2938, 876, 1596, 1083, 822, 1259, 3606, 1584, 2718, 2839, 635, 321, 2626, 494, 1822, 1413, 2831, 983, 2462, 207, 2824, 2128, 64, 3836, 2855, 2132, 2688, 2357, 3364, 2605, 1331, 533, 2236, 800, 2483, 773, 3186, 1748, 946, 3523, 3220, 2740,
  /* r 1, c 9901:10000 */   3490, 2176, 1212, 2228, 911, 252, 1381, 1105, 3398, 2806, 1360, 973, 919, 263, 1250, 3179, 1160, 3873, 942, 1279, 3311, 711, 2557, 1388, 329, 1104, 4022, 3719, 3775, 2264, 1366, 1681, 1376, 77, 3347, 3228, 3221, 3445, 2838, 401, 188, 4000, 3686, 2848, 647, 3651, 260, 2652, 2809, 1707, 2204, 2143, 2393, 1919, 2675, 3782, 83, 1433, 919, 2521, 2615, 777, 1012, 4088, 3919, 1579, 2174, 608, 1985, 1292, 2040, 2126, 273, 462, 3271, 2343, 80, 1398, 1930, 3278, 810, 2146, 2676, 2587, 1830, 109, 3414, 4020, 3058, 3002, 2584, 1018, 267, 1152, 10, 596, 3253, 1323, 3335, 1926,
  /* r 1, c 10001:10100 */  4066, 3975, 1599, 3050, 1478, 3654, 135, 2234, 370, 622, 114, 2009, 3876, 2314, 517, 3004, 2278, 1418, 391, 266, 60, 421, 3351, 446, 1105, 2188, 3085, 176, 3441, 2441, 2990, 3106, 1725, 625, 1888, 718, 1910, 3770, 2249, 4092, 743, 2039, 2938, 1310, 4008, 3799, 1225, 199, 865, 1564, 3478, 987, 2422, 3183, 2070, 3267, 3061, 1390, 2536, 2212, 3389, 2907, 2309, 168, 3441, 2261, 582, 2853, 1836, 584, 3674, 3711, 1825, 1260, 964, 2471, 1327, 2376, 1710, 3889, 599, 889, 1132, 751, 2955, 657, 3337, 1139, 525, 3302, 1681, 2743, 3132, 1840, 331, 2980, 920, 2430, 1129, 2543,
  /* r 1, c 10101:10200 */  3210, 2490, 2715, 1671, 1028, 1794, 3607, 242, 2008, 2306, 569, 2392, 2708, 289, 1374, 470, 1940, 2016, 2785, 1160, 3397, 1597, 2425, 3752, 740, 542, 2074, 2631, 1069, 2205, 644, 503, 1878, 1708, 1383, 3222, 4078, 3473, 1491, 1141, 282, 1480, 517, 2785, 2996, 2577, 77, 2695, 618, 1444, 1304, 2728, 2185, 3346, 1525, 2135, 522, 388, 959, 3530, 3829, 101, 2992, 3096, 205, 1137, 3413, 3412, 2380, 1971, 1220, 148, 1070, 1475, 2592, 2638, 2450, 3176, 3884, 3732, 1576, 3622, 2566, 1993, 2947, 986, 979, 1992, 1044, 918, 2583, 2886, 1585, 2419, 3961, 2255, 547, 2761, 2666, 3401,
  /* r 1, c 10201:10300 */  922, 1338, 1260, 2779, 1994, 2054, 1027, 97, 873, 2637, 2701, 1338, 3687, 1391, 3005, 550, 2953, 4048, 3353, 280, 1196, 1822, 3384, 2741, 1980, 1669, 1587, 3735, 2280, 120, 3292, 427, 3955, 2110, 1550, 3429, 4056, 1436, 969, 70, 990, 3545, 716, 3179, 873, 1139, 3447, 902, 1175, 2407, 948, 151, 2225, 1977, 2651, 2006, 872, 1294, 537, 3391, 3762, 2148, 347, 1698, 3496, 1624, 2919, 147, 2126, 3185, 1698, 1358, 3059, 519, 1158, 2759, 3000, 3555, 3306, 1768, 2677, 1551, 973, 658, 615, 1189, 560, 2817, 3946, 399, 1029, 3105, 1465, 2120, 354, 2273, 2607, 3428, 3853, 461,
  /* r 1, c 10301:10400 */  54, 243, 1152, 3518, 1172, 1767, 768, 1840, 3174, 102, 1340, 2137, 841, 3266, 3639, 190, 1578, 2920, 3068, 1472, 866, 214, 2793, 2027, 1437, 1187, 2026, 3717, 2710, 3547, 1140, 1320, 592, 1781, 2636, 2208, 323, 1240, 300, 3700, 3636, 4036, 3878, 2713, 311, 2582, 2531, 457, 3007, 1131, 1682, 1871, 2610, 1447, 3941, 2983, 561, 1593, 2271, 3248, 3304, 2033, 845, 3592, 2564, 1705, 3051, 3702, 2569, 2579, 3948, 868, 2470, 2827, 2844, 2379, 1046, 487, 3104, 2211, 2275, 3355, 2863, 1617, 672, 2802, 1606, 738, 3204, 2241, 3315, 3053, 2363, 1391, 2947, 1318, 2249, 2559, 1532, 352,
  /* r 1, c 10401:10500 */  2766, 2668, 2343, 1036, 2464, 959, 2130, 1829, 953, 1370, 1128, 1999, 628, 1907, 3172, 2727, 1873, 3643, 2869, 356, 3952, 764, 1424, 347, 1976, 4022, 979, 618, 494, 2906, 3021, 705, 1293, 2904, 3179, 2845, 1634, 1415, 1488, 2375, 2874, 1718, 606, 258, 3430, 3773, 98, 2241, 2336, 1284, 1042, 97, 2727, 339, 1582, 1393, 3085, 821, 1214, 162, 3103, 1998, 2559, 2841, 2345, 3374, 2192, 853, 1006, 1506, 617, 1509, 2276, 3442, 1700, 2120, 9, 2522, 726, 970, 159, 1853, 2950, 2064, 2268, 1519, 3697, 2449, 1974, 1891, 714, 1968, 1580, 2127, 2552, 848, 1539, 2680, 2369, 1970,
  /* r 1, c 10501:10600 */  1864, 1270, 783, 3405, 1320, 2281, 3801, 4016, 2743, 203, 2654, 688, 3850, 3403, 318, 751, 883, 2298, 3377, 3218, 2359, 1607, 2294, 203, 1673, 3742, 2203, 4047, 2753, 121, 2861, 1500, 3663, 3255, 2710, 3671, 4076, 1046, 1186, 2894, 26, 1134, 1120, 2007, 2116, 1900, 2284, 2024, 3911, 659, 2734, 999, 3075, 1026, 2249, 1004, 690, 320, 3468, 2390, 2327, 360, 2783, 2811, 2986, 1703, 335, 1695, 3595, 3540, 422, 849, 2297, 3038, 300, 2788, 9, 1135, 3908, 2058, 2131, 3867, 3854, 4066, 2181, 2104, 121, 1649, 2071, 610, 3934, 1648, 1904, 527, 3790, 3253, 2783, 3495, 3988, 3752,
  /* r 1, c 10601:10700 */  2445, 3790, 1201, 640, 94, 110, 1182, 2890, 1299, 366, 1301, 2960, 3104, 1352, 2573, 610, 2824, 123, 1735, 3894, 2432, 2685, 1502, 1014, 415, 2461, 2995, 2954, 1765, 370, 2591, 2802, 2059, 3528, 2172, 3861, 297, 1599, 2841, 528, 2507, 41, 2054, 546, 2303, 3549, 2113, 2264, 1155, 368, 1360, 1023, 3837, 161, 756, 3464, 1568, 849, 1445, 2343, 710, 403, 2348, 3462, 1068, 574, 2828, 3121, 2424, 886, 3150, 574, 3583, 1830, 383, 2680, 3716, 3298, 1505, 2861, 1432, 2782, 418, 2119, 75, 871, 4055, 2041, 2173, 523, 908, 735, 39, 2014, 3712, 3282, 1640, 3548, 1708, 3540,
  /* r 1, c 10701:10800 */  3593, 18, 3072, 828, 2781, 2419, 1336, 3370, 817, 3198, 3527, 3996, 886, 2556, 2389, 3067, 1756, 3495, 1220, 2930, 3075, 621, 3733, 1613, 3403, 3688, 830, 3849, 2941, 3200, 661, 901, 1254, 56, 370, 2699, 1914, 2196, 3269, 3414, 2764, 2945, 1090, 65, 1167, 2980, 2352, 271, 4033, 2917, 3653, 2201, 1431, 441, 320, 1342, 2560, 2447, 3817, 2825, 2392, 2282, 2006, 1502, 1072, 2697, 918, 218, 3682, 3569, 217, 2713, 2021, 2286, 1909, 2443, 2728, 2088, 3859, 1360, 921, 2110, 1879, 895, 463, 3579, 2287, 3622, 2990, 3749, 731, 1269, 2230, 1175, 322, 2925, 3423, 425, 2339, 589,
  /* r 1, c 10801:10900 */  480, 1027, 3736, 1536, 4086, 3058, 1085, 1029, 1657, 3533, 3885, 2253, 2680, 138, 3016, 3592, 307, 1593, 2612, 325, 1429, 2118, 2904, 1971, 1314, 765, 2605, 670, 1532, 2673, 3214, 349, 3448, 820, 3149, 2732, 864, 3092, 2416, 844, 1123, 1347, 1226, 3029, 984, 364, 1014, 2771, 3593, 634, 1648, 3913, 4082, 4004, 3170, 3279, 2795, 1642, 1657, 576, 3822, 2125, 2206, 467, 3132, 3644, 2482, 1075, 2285, 519, 3793, 3508, 1787, 2299, 1619, 2076, 972, 570, 57, 2136, 1530, 3703, 1987, 3349, 1411, 783, 593, 3227, 2477, 3763, 2272, 699, 965, 3382, 53, 2851, 3411, 558, 1552, 671,
  /* r 1, c 10901:11000 */  910, 117, 67, 2455, 421, 2990, 239, 3219, 3696, 539, 4087, 1065, 11, 3075, 2446, 835, 852, 1751, 306, 1648, 714, 1593, 762, 3312, 3361, 2248, 3994, 2574, 532, 624, 695, 2738, 1929, 2334, 874, 2292, 736, 3139, 1821, 1529, 678, 511, 2561, 807, 2521, 3488, 2870, 3558, 507, 586, 845, 1890, 1134, 1504, 547, 2018, 770, 2421, 1812, 1852, 1020, 307, 3881, 461, 3198, 2072, 3979, 1267, 2280, 3600, 997, 3496, 3633, 2364, 3074, 3467, 1543, 554, 2642, 164, 1257, 1135, 3554, 3195, 3734, 1505, 3480, 4046, 480, 3721, 4027, 750, 1438, 1791, 3120, 605, 701, 281, 2984, 791,
  /* r 1, c 11001:11100 */  1603, 1849, 2997, 56, 453, 3724, 1032, 1702, 3022, 2298, 2176, 1375, 2122, 2315, 2605, 4025, 740, 3294, 2351, 1732, 435, 1919, 2487, 244, 526, 4059, 3876, 3125, 2378, 2505, 556, 902, 2320, 1844, 1745, 1144, 3161, 142, 792, 1418, 752, 3615, 4059, 2416, 3705, 2212, 671, 3204, 2244, 1342, 2331, 185, 2803, 1837, 3110, 1883, 1713, 2681, 1260, 2588, 2695, 1941, 1549, 2213, 914, 2585, 2880, 3889, 2295, 2085, 526, 3615, 2332, 2302, 3164, 1606, 3783, 359, 589, 178, 2921, 711, 2548, 790, 3911, 1069, 1964, 1679, 1142, 2794, 1382, 1431, 493, 1589, 3429, 3122, 1157, 934, 244, 3545,
  /* r 1, c 11101:11200 */  3503, 2426, 3395, 2176, 1453, 265, 2765, 3433, 66, 3195, 3680, 729, 2421, 1766, 2219, 649, 2280, 664, 3110, 1050, 973, 989, 2481, 240, 1578, 3737, 2418, 285, 1272, 3073, 1688, 3931, 3208, 2337, 3457, 3478, 3410, 222, 1561, 1966, 2160, 3934, 1245, 1311, 2958, 2077, 2897, 2983, 2313, 1722, 3192, 3528, 3523, 3605, 2657, 567, 686, 2596, 3809, 3875, 629, 2503, 1325, 1592, 3109, 983, 988, 4005, 2397, 3205, 758, 3296, 1310, 2997, 1359, 3621, 545, 47, 2425, 110, 3738, 2614, 4095, 1691, 4006, 3355, 714, 1077, 583, 43, 3029, 815, 1501, 605, 2587, 3528, 1065, 2985, 887, 1233,
  /* r 1, c 11201:11300 */  3750, 2760, 1352, 2823, 445, 3205, 2068, 823, 905, 3308, 1595, 633, 1491, 2786, 3720, 849, 3527, 3682, 2844, 3094, 2225, 2018, 1771, 3984, 2284, 2408, 4029, 632, 1313, 1319, 3196, 969, 3591, 2417, 2811, 2759, 3037, 376, 2748, 352, 3573, 1335, 1648, 74, 3360, 892, 2400, 3247, 1818, 2539, 2618, 2780, 2949, 2503, 1435, 2826, 2524, 2642, 3641, 1798, 2741, 2330, 1232, 987, 2691, 1034, 3700, 2610, 1673, 3996, 2468, 3828, 4076, 1406, 906, 90, 1143, 1807, 3209, 3231, 1735, 932, 3226, 1131, 3721, 1442, 2614, 3034, 1669, 1443, 661, 223, 863, 872, 2976, 654, 3724, 1276, 635, 1569,
  /* r 1, c 11301:11400 */  3978, 3377, 726, 1776, 1507, 2961, 517, 3541, 2146, 2287, 1833, 3450, 1751, 2915, 2569, 633, 2157, 735, 2989, 2109, 1525, 3168, 386, 964, 1908, 1430, 3839, 2018, 3429, 3833, 1868, 1206, 363, 431, 1478, 2937, 150, 2604, 102, 2245, 3518, 1321, 162, 660, 1230, 2199, 2776, 3729, 974, 1211, 504, 3874, 1068, 3287, 3725, 1959, 1657, 1245, 1473, 2087, 2915, 2054, 234, 1625, 3514, 1487, 1946, 1241, 2626, 746, 1501, 128, 2774, 2447, 950, 2275, 4002, 2103, 777, 1, 1843, 3939, 3751, 1297, 1321, 2919, 80, 1757, 2967, 2390, 3489, 194, 3359, 3848, 3048, 1312, 1585, 1981, 3086, 523,
  /* r 1, c 11401:11500 */  2037, 1638, 1343, 1204, 3703, 2605, 2438, 3856, 707, 135, 4044, 373, 1961, 480, 2753, 3681, 831, 3460, 558, 539, 2840, 3633, 1095, 1252, 3326, 410, 2826, 236, 3755, 533, 664, 3300, 3173, 1367, 3077, 156, 2649, 1039, 1960, 2968, 2284, 3131, 3106, 3379, 2577, 3385, 3101, 2096, 2644, 3163, 2862, 21, 372, 1432, 521, 618, 79, 3364, 2748, 1997, 455, 260, 3017, 459, 932, 3323, 2234, 883, 100, 3477, 137, 2311, 564, 1066, 1331, 850, 3264, 1450, 1486, 2428, 775, 1895, 3313, 2888, 923, 2405, 1159, 2555, 169, 50, 1265, 1529, 1776, 1366, 2315, 2187, 329, 1113, 2413, 1736,
  /* r 1, c 11501:11600 */  4081, 3477, 1115, 406, 2044, 3415, 557, 2135, 3322, 2082, 2768, 3693, 408, 1280, 1206, 2180, 3453, 3721, 1059, 1146, 1299, 2037, 476, 2372, 2538, 3682, 1738, 1543, 1450, 121, 334, 473, 1621, 695, 1492, 3737, 3060, 284, 921, 1744, 2509, 3120, 3748, 4094, 958, 431, 3619, 587, 1362, 2257, 15, 3983, 2502, 2936, 3918, 1185, 3010, 1521, 1832, 3014, 3422, 620, 2937, 4024, 30, 3816, 775, 1269, 1490, 3234, 3992, 1823, 681, 748, 3778, 4026, 4071, 1404, 3418, 3290, 3319, 3793, 2173, 1474, 1188, 866, 3545, 130, 1353, 1556, 3778, 795, 334, 1857, 1490, 2423, 1358, 580, 963, 971,
  /* r 1, c 11601:11700 */  2838, 3474, 305, 2057, 3988, 3964, 2518, 675, 3790, 3634, 3828, 1943, 479, 1567, 1456, 3357, 3876, 1077, 3683, 506, 490, 261, 2006, 778, 2111, 3853, 2486, 1279, 1299, 421, 1246, 1955, 3860, 3690, 2407, 1219, 1546, 2505, 2953, 1089, 2245, 2968, 2561, 1008, 2308, 1387, 1890, 3465, 3672, 2066, 886, 98, 2860, 679, 659, 774, 3621, 1324, 192, 3395, 3955, 1531, 68, 293, 69, 1547, 2130, 447, 3570, 2853, 53, 1752, 1789, 238, 1073, 1566, 2962, 2469, 639, 1023, 3979, 742, 1685, 154, 3879, 1904, 2604, 1598, 895, 328, 1537, 2287, 4030, 3772, 896, 4016, 2619, 2167, 420, 1025,
  /* r 1, c 11701:11800 */  2206, 501, 2168, 372, 2482, 2184, 2719, 1306, 2189, 2459, 119, 2728, 1835, 2692, 2743, 846, 3459, 2762, 790, 18, 830, 224, 1540, 919, 4044, 657, 3104, 3875, 3411, 3074, 3811, 347, 1532, 2751, 661, 134, 395, 1151, 2088, 20, 2826, 1843, 154, 1559, 3079, 3933, 1711, 2979, 3761, 3466, 3016, 2442, 1395, 3475, 2835, 3480, 650, 880, 2241, 3426, 2561, 2053, 1018, 3115, 1682, 809, 2283, 2627, 3025, 2517, 1659, 471, 1724, 2124, 2272, 2394, 1829, 3752, 3448, 2075, 1386, 2138, 1035, 2202, 2109, 3449, 3906, 3033, 2368, 1764, 2200, 2063, 2186, 1896, 2229, 3176, 4019, 1262, 2592, 403,
  /* r 1, c 11801:11900 */  1775, 3227, 1140, 1002, 3068, 2986, 4009, 1736, 393, 3701, 799, 898, 78, 3324, 2369, 2521, 1662, 1496, 1062, 1250, 1065, 3401, 2059, 3982, 2574, 4091, 3034, 4029, 3782, 1455, 3509, 823, 1959, 104, 987, 2508, 73, 2458, 1596, 176, 2342, 3942, 2128, 1118, 3390, 1031, 95, 2339, 1565, 1710, 221, 1063, 3619, 1100, 709, 334, 831, 1250, 2786, 944, 1363, 2375, 2912, 3785, 3847, 1260, 2363, 1829, 3789, 3204, 1267, 410, 3282, 748, 1648, 1754, 3178, 2049, 4032, 755, 3041, 182, 3948, 3897, 3935, 2101, 202, 3070, 3515, 1359, 2936, 2692, 2028, 3496, 3434, 948, 1731, 2322, 1194, 1420,
  /* r 1, c 11901:12000 */  2941, 2404, 1365, 362, 266, 2745, 3587, 800, 83, 210, 3008, 3088, 2759, 4069, 3558, 1375, 3626, 2134, 579, 898, 2557, 654, 758, 362, 2884, 584, 3005, 113, 2124, 3546, 2911, 470, 3986, 1892, 1206, 1048, 1199, 785, 1390, 37, 2096, 2517, 2616, 2842, 318, 1954, 2674, 2420, 2916, 2228, 161, 4069, 3428, 3456, 2167, 3215, 2012, 642, 3659, 1222, 2387, 1933, 164, 1378, 1845, 2451, 3718, 2396, 3953, 278, 2695, 3634, 2349, 2054, 3891, 3036, 3065, 3708, 2528, 1471, 3741, 3245, 3088, 2180, 737, 682, 384, 3175, 2491, 1597, 4027, 1773, 906, 654, 7, 3575, 1306, 639, 819, 1835,
  /* r 1, c 12001:12100 */  823, 1185, 725, 3711, 3946, 3628, 203, 2230, 2184, 2619, 3019, 1005, 1983, 1, 2223, 1005, 2006, 620, 2263, 3549, 1723, 419, 3393, 3773, 2551, 1431, 560, 1146, 45, 1820, 140, 3788, 1698, 1123, 1329, 2523, 2291, 2046, 30, 2878, 1488, 1206, 2001, 2006, 1659, 2095, 2344, 3260, 3340, 1774, 1342, 2924, 2440, 552, 664, 3914, 2457, 1567, 1304, 3262, 1606, 2256, 2674, 1987, 2049, 3832, 4071, 2042, 2833, 3678, 4052, 1069, 1476, 827, 1892, 2682, 2520, 1, 3373, 3007, 3831, 3493, 703, 3108, 1110, 3795, 3378, 3018, 3571, 2921, 1934, 3801, 1041, 3243, 2713, 3634, 2658, 985, 1773, 1288,
  /* r 1, c 12101:12200 */  3388, 1253, 266, 3436, 2915, 3595, 646, 227, 3929, 3091, 1272, 1673, 3752, 841, 2094, 1195, 1583, 1167, 3569, 336, 3922, 3958, 768, 437, 362, 2417, 1116, 1233, 3653, 131, 3266, 2202, 129, 3116, 718, 3267, 1411, 892, 127, 2556, 1264, 4060, 453, 1465, 3153, 3399, 2630, 2133, 1825, 2348, 397, 822, 3487, 1197, 936, 531, 2870, 1105, 2128, 1029, 158, 1351, 779, 1640, 2444, 936, 619, 3467, 2016, 328, 2832, 3117, 3325, 2144, 3129, 1191, 3272, 2934, 2289, 1176, 1255, 2348, 2724, 1575, 3681, 603, 796, 1943, 3508, 1590, 2058, 2747, 502, 2934, 594, 207, 3429, 800, 2462, 3452,
  /* r 1, c 12201:12300 */  1766, 2701, 806, 2800, 911, 2066, 1020, 1639, 787, 223, 4058, 991, 2814, 457, 1980, 281, 1340, 917, 3443, 1388, 3059, 1067, 3435, 2859, 3747, 2995, 1388, 3584, 1649, 1402, 1401, 3202, 3581, 1688, 866, 3299, 1353, 3635, 444, 3875, 1323, 1331, 1916, 1534, 3683, 979, 354, 619, 440, 1747, 2824, 3297, 2196, 1883, 616, 2462, 882, 2995, 920, 2578, 1665, 307, 1913, 3588, 1698, 2112, 3514, 762, 1804, 2847, 2285, 500, 1273, 355, 3920, 1761, 1284, 1273, 464, 1805, 151, 3135, 4040, 477, 191, 3853, 3351, 1242, 1231, 694, 1502, 1603, 3461, 1382, 2089, 1039, 1508, 1807, 1696, 1626,
  /* r 1, c 12301:12400 */  2520, 3871, 3143, 1102, 1089, 2626, 3585, 641, 208, 2072, 2432, 2471, 2610, 550, 1743, 725, 2230, 3116, 3216, 1662, 3734, 1490, 201, 3664, 1837, 982, 1, 165, 2880, 1755, 3853, 2829, 2692, 2374, 398, 462, 203, 987, 2020, 2623, 252, 1046, 1881, 1163, 3156, 2378, 2474, 1975, 4050, 2292, 3483, 2902, 2529, 184, 2385, 302, 1492, 2, 1053, 1852, 5, 4027, 3071, 2561, 3966, 3748, 2785, 2003, 288, 1253, 2941, 2824, 69, 524, 1292, 522, 3279, 1777, 3505, 62, 3905, 465, 2598, 3899, 3303, 1570, 2118, 3585, 3382, 1302, 3919, 1146, 3591, 3495, 2529, 970, 2998, 1564, 1875, 2731,
  /* r 1, c 12401:12500 */  3610, 3510, 1930, 114, 4043, 3654, 2424, 992, 2287, 349, 2483, 3200, 1200, 3438, 1575, 3540, 2048, 2864, 3166, 565, 2061, 3224, 1443, 1776, 4092, 701, 2497, 1768, 851, 3838, 1029, 1770, 4047, 2996, 872, 1302, 693, 2154, 3836, 4017, 3978, 782, 2733, 657, 3298, 344, 2066, 1698, 2907, 3265, 1306, 3338, 2435, 3043, 3591, 907, 726, 3900, 2174, 1984, 925, 2514, 394, 902, 3726, 3091, 3871, 2322, 1973, 507, 1117, 746, 444, 1989, 3762, 3867, 668, 53, 2336, 441, 950, 2197, 2718, 3732, 541, 2057, 1903, 2267, 2691, 1364, 3580, 523, 3946, 45, 414, 2217, 4016, 3177, 2018, 1953,
  /* r 1, c 12501:12600 */  3224, 881, 3730, 2036, 3544, 3021, 354, 3443, 1845, 3584, 344, 3232, 3415, 2938, 224, 1576, 941, 1730, 2830, 1534, 1274, 3440, 357, 3124, 459, 2598, 3939, 449, 2955, 1927, 1543, 4052, 3451, 3486, 757, 1276, 3259, 3674, 415, 3348, 2628, 2023, 2233, 1243, 2306, 1593, 3489, 4047, 1388, 740, 113, 3343, 801, 1377, 3727, 3478, 2983, 101, 205, 2051, 347, 3503, 1058, 1950, 472, 1462, 3910, 2128, 727, 3616, 272, 1490, 65, 448, 204, 3254, 2989, 893, 376, 2534, 3382, 459, 2425, 2337, 687, 1415, 1877, 2597, 3432, 537, 2015, 3595, 2437, 2669, 4025, 2510, 672, 3954, 310, 2976,
  /* r 1, c 12601:12700 */  572, 1154, 2771, 2346, 1229, 2977, 1921, 2228, 3497, 17, 2261, 1343, 1472, 1787, 2881, 1342, 578, 1426, 2945, 865, 997, 349, 1232, 1659, 1868, 952, 267, 3700, 733, 1412, 1072, 3288, 1154, 241, 2838, 4000, 2049, 1111, 3524, 3593, 1819, 361, 3420, 2959, 3256, 610, 3408, 3104, 1094, 484, 1695, 1568, 2451, 1732, 1232, 637, 3004, 1618, 1580, 1684, 2911, 3007, 1171, 3074, 3747, 2082, 2129, 351, 3070, 1125, 3691, 1843, 3373, 1550, 3983, 1991, 3667, 3659, 3458, 2556, 3567, 1955, 1523, 1768, 2853, 408, 2367, 2677, 1783, 15, 3998, 3282, 1853, 3186, 1146, 2404, 1348, 3003, 952, 3955,
  /* r 1, c 12701:12800 */  1231, 788, 2022, 3599, 86, 2797, 3402, 494, 3671, 2432, 730, 1275, 2471, 3996, 3737, 554, 908, 3879, 3322, 4060, 666, 1980, 1789, 1855, 1718, 180, 3111, 1879, 25, 850, 3068, 2319, 458, 6, 2181, 3286, 1554, 3982, 1309, 2710, 3676, 850, 2196, 525, 1184, 3565, 2397, 4021, 2379, 2007, 3871, 1327, 1365, 178, 1233, 28, 579, 724, 2590, 447, 1674, 3896, 1662, 1878, 1874, 1051, 2091, 3105, 2956, 672, 1852, 494, 2639, 2269, 9, 2436, 3641, 2957, 5, 702, 2145, 452, 2218, 168, 3285, 1231, 3856, 2268, 3814, 3805, 935, 172, 1333, 757, 836, 3488, 3675, 726, 2623, 917,
  /* r 1, c 12801:12900 */  2416, 752, 2902, 2854, 1246, 1783, 310, 2844, 1946, 2710, 3404, 1785, 2138, 1790, 2040, 471, 1215, 952, 2159, 3812, 133, 2523, 1643, 1819, 3041, 3464, 1080, 879, 2569, 67, 2176, 915, 1311, 2116, 3414, 482, 3019, 3167, 1179, 3824, 2331, 2227, 2432, 358, 1340, 3061, 633, 1419, 3923, 3804, 2510, 3878, 2632, 3506, 220, 3527, 3298, 2044, 1548, 1783, 306, 2344, 840, 575, 3438, 177, 1794, 3138, 3806, 493, 2672, 395, 1789, 3353, 147, 564, 3777, 261, 271, 3234, 1745, 3867, 1527, 2956, 3325, 4068, 4074, 2846, 980, 773, 3354, 72, 2357, 1829, 1103, 1413, 1960, 2421, 1278, 2749,
  /* r 1, c 12901:13000 */  3846, 51, 2045, 2161, 1631, 3239, 1610, 2162, 2342, 2958, 2040, 2518, 2540, 1512, 3008, 208, 3045, 2792, 3642, 2686, 297, 2383, 4032, 1811, 2505, 3123, 3768, 973, 2081, 2830, 2776, 491, 2533, 775, 3983, 829, 3592, 2424, 3181, 869, 321, 2897, 2623, 2821, 1997, 3392, 1970, 861, 292, 1507, 706, 1756, 3897, 1910, 1843, 2608, 2970, 1925, 3534, 24, 1984, 3705, 904, 21, 3183, 1433, 386, 1841, 2112, 2247, 3510, 2, 2602, 246, 2911, 181, 779, 2800, 1376, 3643, 817, 2017, 1582, 1335, 1016, 2548, 2636, 508, 283, 3693, 107, 1305, 4074, 1176, 2558, 543, 348, 998, 3071, 2629,
  /* r 1, c 13001:13100 */  2926, 1880, 954, 3596, 757, 2604, 1034, 3394, 2543, 407, 3989, 2200, 3330, 2515, 1927, 2898, 576, 4041, 37, 4080, 1474, 2598, 3048, 128, 3073, 1274, 183, 208, 3137, 2584, 1998, 2043, 2681, 1635, 3957, 1893, 1586, 373, 1098, 1679, 3907, 306, 749, 2527, 342, 1098, 833, 3290, 1662, 3541, 1730, 3971, 3308, 2631, 3483, 3256, 2573, 2227, 2560, 1984, 3454, 2425, 3415, 1970, 2409, 2970, 1830, 2450, 358, 2233, 4025, 1903, 3538, 735, 3240, 1510, 364, 1387, 2427, 1322, 2927, 74, 2742, 706, 3494, 2746, 874, 799, 3001, 1484, 1019, 3053, 1892, 2773, 2669, 1115, 1359, 1578, 474, 3872,
  /* r 1, c 13101:13200 */  137, 2839, 2314, 328, 1199, 3620, 224, 733, 1084, 2477, 2381, 3039, 2443, 2885, 2573, 411, 1823, 1860, 3401, 3555, 821, 1504, 2377, 3190, 3499, 3697, 2446, 3824, 2599, 3823, 2479, 3412, 2760, 2867, 981, 419, 629, 322, 3652, 3662, 3292, 2589, 2879, 2168, 266, 177, 4012, 3818, 1577, 3330, 53, 2729, 1468, 2965, 1374, 4067, 3268, 1303, 3085, 2814, 2359, 3080, 3637, 2041, 3427, 3719, 2224, 1923, 2439, 422, 1064, 1669, 3016, 2199, 3306, 183, 1255, 341, 883, 2830, 1116, 505, 1551, 237, 3340, 1309, 1290, 4051, 4026, 3306, 2538, 3568, 3431, 834, 2561, 2345, 2070, 1147, 181, 1822,
  /* r 1, c 13201:13300 */  2146, 3447, 3134, 2336, 4013, 3075, 609, 3953, 942, 787, 3186, 2940, 3730, 1457, 3016, 1963, 1057, 1650, 1425, 2675, 243, 3297, 2246, 3510, 3170, 999, 247, 1270, 2319, 2428, 2331, 2393, 1970, 2133, 3055, 1376, 1848, 3685, 3252, 3486, 2317, 2306, 2868, 449, 1686, 3500, 1367, 141, 3197, 2643, 3909, 2648, 2977, 3757, 2116, 4026, 2744, 1071, 1910, 1701, 3754, 1765, 3171, 3708, 494, 2608, 3850, 98, 3307, 1528, 1654, 1637, 1040, 1416, 3988, 3095, 2438, 2870, 605, 152, 521, 2812, 336, 1979, 3433, 3274, 102, 858, 4057, 1628, 1339, 264, 451, 2279, 1042, 494, 2846, 537, 320, 1913,
  /* r 1, c 13301:13400 */  3191, 3864, 3196, 1411, 1947, 3251, 3117, 20, 3666, 3304, 84, 2884, 1838, 1943, 3651, 977, 1086, 1040, 3514, 577, 3388, 2010, 2156, 3466, 3939, 189, 2184, 833, 1850, 3756, 2043, 860, 561, 3766, 605, 3095, 1902, 535, 2213, 2921, 1926, 159, 2982, 3710, 794, 1474, 2300, 515, 240, 599, 2020, 3502, 3494, 1360, 797, 63, 2734, 2564, 2820, 1694, 3137, 29, 794, 3647, 1556, 789, 593, 1746, 2562, 313, 2493, 2129, 429, 1102, 2943, 4027, 1945, 2898, 730, 3110, 3456, 985, 2945, 766, 2399, 1733, 194, 2571, 3988, 1937, 3461, 2062, 332, 339, 4007, 2360, 2151, 1371, 2191, 3501,
  /* r 1, c 13401:13500 */  1081, 959, 1432, 2144, 594, 664, 306, 3003, 464, 3194, 2149, 253, 2061, 1873, 2836, 1832, 775, 2850, 2354, 3016, 1861, 4055, 2536, 3019, 758, 2855, 701, 726, 3910, 3830, 2033, 3802, 3708, 1002, 2585, 3030, 2290, 1558, 373, 2270, 1209, 2065, 2627, 1408, 3105, 2710, 1986, 206, 3055, 1638, 2502, 876, 113, 655, 2107, 2858, 2982, 2066, 2452, 1317, 2047, 3123, 2925, 1063, 423, 1975, 3972, 2955, 2937, 3022, 3466, 2180, 3066, 3817, 2237, 3221, 2002, 1926, 3348, 3659, 2945, 3312, 2946, 3388, 1199, 1632, 1085, 1381, 3732, 719, 2880, 1877, 2115, 3502, 1585, 3084, 3754, 1893, 4011, 2697,
  /* r 1, c 13501:13600 */  3939, 2960, 852, 3240, 3688, 736, 551, 3698, 1380, 1140, 921, 4089, 2069, 671, 2907, 808, 2011, 434, 2333, 2950, 2749, 336, 3818, 1270, 200, 3747, 220, 156, 148, 2026, 2821, 1498, 3214, 2893, 113, 3626, 711, 2817, 2068, 1255, 1221, 1321, 1327, 2436, 747, 1905, 2350, 2820, 179, 1798, 1112, 2132, 1223, 2981, 2266, 2855, 1096, 3947, 1975, 2152, 2140, 63, 2542, 3265, 2708, 2216, 1157, 70, 742, 3826, 12, 3493, 1287, 3363, 1531, 3788, 747, 1940, 1755, 3689, 1480, 1232, 3477, 3838, 3868, 4071, 511, 2616, 3894, 3533, 3651, 3016, 877, 2403, 1990, 2470, 3614, 425, 3383, 506,
  /* r 1, c 13601:13700 */  1396, 1888, 2516, 4002, 3477, 3450, 2354, 1237, 3386, 3961, 3876, 2600, 1524, 4033, 3284, 647, 2621, 1934, 3416, 391, 1351, 499, 128, 327, 1718, 2579, 1954, 3507, 3088, 3740, 3780, 1067, 3255, 1256, 987, 4038, 816, 3954, 1321, 1735, 1257, 3618, 3598, 3104, 3118, 2955, 3799, 1077, 208, 3275, 2983, 3558, 1588, 3044, 213, 2554, 2679, 3776, 219, 1288, 364, 1419, 3338, 1523, 3187, 1874, 1799, 3058, 3806, 712, 2292, 3531, 3912, 74, 1946, 2754, 3543, 471, 1118, 3497, 2071, 2852, 85, 131, 679, 1632, 919, 513, 2754, 2962, 956, 1624, 3443, 1774, 2339, 1896, 2246, 68, 1943, 931,
  /* r 1, c 13701:13800 */  534, 93, 2274, 1236, 93, 1518, 2209, 398, 2926, 3627, 2640, 3127, 2412, 1352, 3126, 2070, 2113, 1442, 3765, 894, 460, 2806, 1513, 95, 2647, 1671, 3030, 51, 3648, 1351, 4059, 2590, 2808, 508, 2835, 476, 654, 1205, 3762, 3654, 1231, 3511, 3542, 1622, 601, 1297, 556, 1477, 4074, 1521, 940, 1361, 3499, 2491, 1642, 2499, 1057, 2035, 3698, 2739, 2241, 58, 1859, 128, 3346, 1254, 1298, 1801, 2206, 1741, 3319, 3261, 3246, 3461, 1843, 1933, 1871, 1530, 1021, 554, 2574, 1477, 3631, 1698, 2762, 1839, 1993, 363, 2013, 3432, 2101, 352, 3146, 98, 1272, 2762, 3108, 407, 3253, 3252,
  /* r 1, c 13801:13900 */  1548, 2500, 830, 974, 2987, 1134, 932, 1059, 97, 3478, 2825, 2869, 206, 1488, 1347, 2628, 1874, 3956, 1995, 3087, 2021, 1077, 1890, 1114, 3210, 2681, 1462, 1401, 51, 3549, 2226, 3732, 2344, 3675, 2174, 4093, 1689, 1819, 1126, 1247, 1737, 1190, 997, 1107, 1123, 2296, 3564, 2875, 3905, 1070, 783, 2349, 2882, 3125, 3234, 2805, 3590, 817, 1577, 2837, 187, 3244, 1361, 1275, 4088, 1817, 2069, 2190, 526, 815, 3740, 651, 3238, 146, 3183, 2603, 2441, 1104, 2968, 1718, 2442, 1237, 3341, 641, 1314, 948, 3416, 1421, 2883, 1446, 936, 937, 55, 1292, 3373, 2245, 3758, 3486, 1862, 3333,
  /* r 1, c 13901:14000 */  3186, 3862, 763, 4085, 1682, 4085, 3810, 3980, 124, 940, 2950, 3246, 1318, 2193, 2295, 801, 2799, 2411, 3703, 3952, 2130, 3941, 3937, 1296, 1600, 1653, 17, 2537, 2479, 2498, 2034, 3129, 525, 415, 64, 419, 195, 1758, 906, 1026, 7, 2678, 3652, 1307, 693, 2543, 2961, 4018, 2221, 789, 1050, 2038, 3193, 549, 842, 3207, 2973, 1989, 364, 125, 1216, 4046, 2413, 2395, 3847, 478, 3905, 3787, 720, 1061, 1270, 2345, 3423, 3461, 3908, 3576, 166, 2857, 202, 197, 608, 1916, 3286, 1890, 455, 872, 2508, 635, 1569, 266, 2515, 4045, 2611, 3552, 3777, 815, 1868, 3922, 708, 2015,
  /* r 1, c 14001:14100 */  2344, 3122, 201, 2185, 3181, 2254, 3786, 3389, 3877, 170, 4, 619, 2853, 3071, 326, 2318, 3257, 2629, 43, 134, 568, 1338, 3654, 90, 3458, 735, 1272, 1191, 590, 3798, 83, 548, 3850, 1352, 1940, 1455, 3719, 3719, 3221, 1207, 3773, 500, 1314, 157, 3374, 940, 3791, 4070, 905, 3819, 975, 3619, 3807, 3274, 510, 1931, 172, 464, 527, 2541, 641, 1565, 1679, 1458, 3874, 341, 841, 2457, 1979, 2618, 1361, 2422, 2747, 3793, 3378, 3836, 993, 3209, 238, 1143, 3966, 2288, 22, 1019, 3073, 3061, 67, 3580, 1006, 3526, 544, 1048, 820, 732, 979, 3962, 598, 3254, 3160, 3982,
  /* r 1, c 14101:14200 */  1008, 2118, 569, 1062, 2356, 1285, 877, 3818, 1809, 2951, 155, 2349, 2907, 3392, 724, 2955, 2070, 885, 1850, 3677, 1090, 2479, 1803, 1830, 1266, 944, 2689, 2370, 126, 3565, 166, 931, 2248, 1874, 1991, 3630, 3637, 1677, 384, 1040, 459, 1493, 389, 3540, 295, 1301, 1490, 1996, 1290, 2467, 2890, 3985, 3851, 486, 3490, 226, 1303, 357, 3377, 3690, 1139, 3759, 736, 1858, 2933, 3205, 480, 2459, 428, 640, 2041, 1369, 2524, 825, 2976, 2544, 4011, 806, 568, 898, 163, 1311, 3314, 1427, 179, 3373, 93, 168, 2517, 1281, 1704, 2416, 2016, 3120, 1124, 3431, 3195, 2525, 1687, 952,
  /* r 1, c 14201:14300 */  501, 9, 3960, 1047, 845, 3168, 4041, 2011, 1751, 3256, 574, 361, 2241, 338, 3326, 3306, 1054, 1705, 3123, 2707, 964, 901, 2808, 327, 719, 3288, 412, 3098, 3792, 3497, 3825, 2358, 2047, 3383, 2956, 262, 2265, 1153, 1848, 218, 3484, 1556, 390, 1039, 186, 767, 2104, 1102, 1484, 3692, 1558, 3737, 3875, 2937, 496, 1803, 3891, 806, 2520, 3014, 1272, 9, 1143, 2604, 3686, 3320, 537, 3647, 1950, 3751, 1340, 3356, 283, 1670, 1615, 3490, 1733, 292, 3493, 812, 1441, 2425, 3852, 1234, 127, 2280, 3594, 3866, 2847, 134, 3368, 3500, 3594, 809, 777, 880, 3397, 1455, 2467, 4073,
  /* r 1, c 14301:14400 */  1730, 3993, 194, 2508, 2900, 2253, 2548, 583, 2968, 130, 2202, 544, 3073, 4070, 689, 2259, 1059, 2906, 3576, 4035, 1913, 136, 2859, 2848, 3179, 1756, 3804, 2774, 2293, 3867, 1799, 1093, 1780, 2805, 1578, 3981, 3811, 3372, 496, 690, 3314, 1671, 618, 285, 2820, 3785, 1627, 307, 1795, 3703, 1885, 1427, 1408, 3192, 1748, 1289, 3709, 1711, 3394, 3810, 2891, 15, 2192, 1267, 2028, 1473, 3221, 488, 3794, 2045, 3386, 775, 1369, 1121, 908, 3182, 3591, 666, 2546, 3568, 3105, 4089, 426, 3322, 787, 970, 936, 2867, 2910, 1073, 2347, 472, 3703, 1359, 4065, 148, 962, 961, 1546, 3,
  /* r 1, c 14401:14500 */  3928, 566, 2199, 1760, 1880, 1646, 1755, 2127, 1268, 2304, 1460, 448, 2413, 1909, 2957, 207, 1962, 2658, 1029, 1270, 3519, 2336, 3835, 3349, 1192, 586, 1533, 1490, 1307, 2806, 1314, 3080, 1657, 2844, 2656, 3700, 1262, 2975, 2916, 1662, 3030, 3200, 1511, 3433, 3295, 870, 551, 732, 3646, 2331, 1174, 3190, 2742, 1930, 2431, 1868, 4081, 1563, 3545, 1446, 2808, 2067, 2937, 1741, 92, 414, 3313, 1788, 399, 2642, 1257, 756, 3145, 27, 839, 3820, 2730, 42, 2268, 3761, 237, 3537, 2965, 2455, 3000, 1482, 3336, 1891, 1461, 4026, 3467, 1563, 2854, 340, 1142, 1725, 3800, 1947, 1106, 4051,
  /* r 1, c 14501:14600 */  1579, 454, 3922, 3415, 1574, 1901, 2459, 1530, 2099, 3615, 1601, 914, 1562, 946, 3407, 1427, 3703, 3054, 204, 1351, 2902, 3197, 3016, 1520, 3012, 2343, 1681, 289, 1085, 2650, 1030, 492, 2627, 1554, 2460, 924, 2875, 4093, 96, 1357, 1009, 4012, 902, 854, 2443, 1976, 146, 2747, 2670, 3696, 1169, 1528, 2796, 3158, 1191, 983, 3547, 1204, 4090, 1899, 555, 1241, 53, 2871, 2445, 319, 4055, 1159, 2716, 3744, 3437, 2815, 18, 820, 4014, 4090, 531, 3920, 957, 1416, 2987, 688, 2614, 2213, 3631, 243, 1485, 3886, 2902, 3504, 2836, 951, 1440, 1990, 3951, 3172, 1118, 437, 2889, 444,
  /* r 1, c 14601:14700 */  3715, 274, 2177, 989, 1907, 1965, 21, 1662, 3255, 3885, 3422, 2625, 2343, 1964, 114, 3532, 3755, 2997, 1809, 750, 1794, 2543, 1311, 3890, 3953, 2434, 1346, 1025, 2255, 1997, 2693, 163, 257, 3851, 3419, 1792, 2623, 589, 1692, 2520, 2615, 602, 2687, 517, 1438, 3597, 1461, 589, 3468, 1307, 1109, 1832, 2027, 2249, 3814, 2094, 1095, 3491, 1704, 822, 158, 3269, 3334, 214, 1935, 1708, 908, 2364, 1587, 526, 109, 679, 726, 2050, 2883, 3810, 2665, 895, 2227, 1774, 604, 1626, 2942, 3485, 3186, 2646, 3891, 3789, 3831, 1382, 3737, 531, 400, 2471, 1271, 281, 3798, 2055, 815, 251,
  /* r 1, c 14701:14800 */  622, 4026, 2496, 2482, 1609, 2082, 649, 391, 681, 3932, 3436, 1620, 3492, 1862, 1131, 677, 814, 1421, 3852, 3467, 2269, 540, 3466, 2599, 3880, 2840, 424, 222, 1169, 1407, 2372, 1218, 636, 741, 2012, 2229, 615, 582, 1829, 1064, 2157, 1712, 1357, 4095, 2604, 3194, 786, 631, 3587, 1815, 2867, 3154, 2141, 2523, 559, 211, 1071, 3154, 638, 2003, 2548, 561, 825, 3262, 1791, 1373, 288, 2232, 2029, 2342, 2834, 162, 2327, 691, 3631, 90, 332, 2081, 1240, 3360, 1654, 3459, 1083, 744, 3682, 2630, 3228, 1220, 1838, 805, 1573, 2397, 813, 2311, 253, 220, 3179, 1080, 3607, 1214,
  /* r 1, c 14801:14900 */  2628, 1763, 3461, 379, 3376, 486, 2720, 2814, 1639, 1712, 2528, 1802, 661, 3574, 1012, 2320, 608, 1620, 1071, 3738, 2971, 3731, 862, 1703, 4072, 2813, 479, 184, 2911, 3753, 1807, 655, 2034, 3547, 139, 1425, 3617, 3171, 2386, 3278, 2511, 499, 2358, 4014, 333, 3242, 1224, 3589, 920, 1727, 1885, 1774, 2386, 1757, 87, 3507, 180, 1804, 593, 3757, 340, 2032, 2540, 1452, 2316, 3336, 584, 3914, 904, 232, 244, 1587, 881, 4, 2231, 1239, 1008, 913, 102, 4031, 2623, 2743, 356, 2263, 3106, 2633, 2960, 3479, 294, 1173, 2201, 311, 402, 2119, 1239, 1913, 2852, 2139, 3722, 2960,
  /* r 1, c 14901:15000 */  3811, 2505, 2435, 611, 3895, 2658, 149, 2611, 3893, 795, 2713, 1867, 2158, 3052, 2696, 2122, 1256, 1362, 4018, 488, 3375, 906, 1451, 3451, 3260, 40, 2777, 3141, 933, 1103, 3826, 3011, 3514, 1568, 3010, 1382, 3964, 2767, 2743, 2211, 373, 3891, 3159, 3372, 1745, 251, 2683, 3657, 145, 2384, 3508, 1670, 2193, 447, 406, 2892, 1234, 1686, 2077, 411, 985, 2081, 998, 91, 3285, 3975, 2775, 496, 281, 3305, 2170, 2867, 3324, 1894, 3514, 3006, 3746, 241, 1592, 869, 3423, 420, 4091, 920, 3680, 3592, 11, 2702, 2718, 1401, 3994, 1461, 902, 2393, 1142, 3205, 3209, 3954, 1941, 4083,
  /* r 1, c 15001:15100 */  462, 3773, 28, 1995, 3102, 3054, 1199, 1634, 319, 3944, 2625, 3567, 1530, 2499, 2, 1507, 46, 1833, 2938, 560, 1210, 985, 1850, 2825, 2965, 1965, 1551, 620, 607, 1492, 2770, 3979, 2167, 655, 1301, 147, 2824, 773, 2287, 2827, 3071, 155, 2715, 1920, 2505, 2906, 2156, 1910, 3623, 1869, 2093, 600, 2288, 2807, 246, 4005, 1095, 985, 743, 2534, 3784, 1545, 1859, 3765, 1912, 2095, 983, 315, 1543, 1147, 1716, 2228, 1507, 1443, 1547, 934, 2026, 1001, 21, 2163, 2900, 75, 2623, 250, 3999, 3353, 1085, 19, 2794, 328, 1260, 437, 747, 736, 3755, 3214, 3720, 2248, 2891, 4061,
  /* r 1, c 15101:15200 */  3350, 2069, 173, 3729, 943, 4019, 3177, 4069, 1947, 3612, 3681, 663, 787, 2038, 1756, 1617, 3621, 2508, 74, 1069, 2070, 4049, 3103, 677, 3558, 3533, 2407, 3844, 3982, 2060, 2393, 3145, 2066, 1941, 1827, 428, 315, 2402, 1343, 2231, 1983, 3871, 1259, 2476, 3751, 1726, 299, 683, 2004, 484, 2786, 3254, 1271, 3123, 2633, 816, 3979, 310, 2427, 1676, 2893, 3332, 1916, 1528, 2099, 1668, 2323, 1339, 3475, 1421, 2739, 2870, 576, 1818, 3699, 920, 2224, 1692, 4066, 399, 3771, 310, 2320, 1234, 3552, 3454, 1162, 3587, 3044, 3875, 1439, 3417, 4019, 1617, 3493, 3181, 626, 1012, 3130, 1398,
  /* r 1, c 15201:15300 */  203, 2028, 1950, 1794, 1697, 1914, 1722, 2294, 1115, 1081, 2532, 3106, 2530, 1655, 1261, 1488, 1274, 422, 1139, 2045, 1505, 1917, 321, 2748, 3658, 4082, 1237, 3009, 2922, 573, 337, 2804, 1653, 2039, 1172, 2868, 727, 2128, 603, 3263, 1005, 1604, 1637, 515, 1036, 726, 526, 1919, 825, 1381, 3834, 3258, 667, 2347, 4002, 1502, 4045, 639, 896, 445, 2662, 1135, 1179, 2394, 1894, 609, 765, 3336, 2700, 2848, 1930, 2292, 1683, 2705, 663, 160, 1851, 1658, 3045, 2527, 3851, 181, 2365, 262, 3985, 1376, 2955, 1237, 307, 1195, 1701, 3181, 2998, 3845, 1918, 462, 1232, 3980, 102, 2315,
  /* r 1, c 15301:15400 */  1964, 3221, 1794, 250, 1689, 193, 3784, 399, 3824, 3877, 3814, 2537, 2431, 1210, 517, 3739, 732, 3140, 37, 866, 776, 3611, 1959, 796, 146, 3090, 1493, 3136, 2193, 3159, 803, 3753, 420, 2129, 1861, 306, 801, 4030, 1076, 1220, 1749, 2616, 1958, 3996, 2888, 183, 3262, 2720, 2723, 3177, 3397, 647, 3449, 3186, 2307, 1810, 1556, 2655, 2962, 1503, 3493, 1639, 2050, 766, 1144, 2314, 1238, 490, 3571, 302, 135, 3491, 2814, 1788, 2865, 1204, 1376, 755, 1687, 3872, 3541, 1895, 1685, 886, 2405, 1366, 1485, 3589, 473, 1072, 2610, 2736, 812, 1516, 594, 3941, 1222, 393, 2553, 2089,
  /* r 1, c 15401:15500 */  612, 2458, 1369, 3198, 1086, 1100, 3200, 319, 3415, 2062, 935, 1816, 32, 3670, 3815, 1164, 2478, 714, 3572, 3094, 1797, 2456, 1973, 2767, 3787, 2005, 1274, 1588, 3863, 2464, 3561, 591, 3240, 3894, 731, 586, 1112, 3415, 3572, 1800, 103, 1250, 2585, 1339, 3801, 2508, 808, 30, 2107, 552, 2192, 4073, 2886, 4008, 3042, 2620, 664, 3327, 1987, 1929, 578, 674, 633, 3804, 1006, 703, 2457, 389, 3617, 1508, 2062, 3064, 2172, 656, 1508, 3867, 1009, 1635, 1528, 3658, 3601, 768, 962, 2113, 2646, 2992, 3953, 1640, 687, 3728, 2291, 1530, 3532, 625, 2441, 3859, 1985, 1516, 985, 2929,
  /* r 1, c 15501:15600 */  2952, 3079, 2397, 3753, 2679, 638, 3427, 2154, 2050, 887, 165, 3345, 2994, 3451, 1397, 241, 1129, 2336, 203, 1628, 3207, 2997, 3172, 2170, 1698, 3295, 1532, 572, 2905, 2244, 1333, 2902, 1934, 2006, 3045, 2568, 3601, 1326, 1137, 2461, 3982, 2776, 904, 160, 778, 1174, 2334, 3546, 1466, 2771, 3431, 1344, 3869, 3856, 2391, 3057, 1131, 1668, 3253, 3994, 1833, 3563, 740, 1101, 3321, 3898, 3823, 3261, 701, 2635, 2602, 3954, 3014, 2535, 1097, 2500, 4049, 3288, 2936, 3189, 3186, 196, 3934, 4031, 2862, 1131, 664, 3741, 3029, 359, 2, 786, 1281, 3742, 227, 1611, 1748, 866, 2148, 1552,
  /* r 1, c 15601:15700 */  840, 2499, 3560, 943, 318, 4048, 321, 3216, 3242, 598, 2617, 4083, 3793, 2084, 3992, 3623, 826, 3468, 1961, 3829, 1273, 2652, 2444, 3934, 2964, 1956, 129, 55, 2822, 2928, 3015, 3330, 646, 148, 1418, 3940, 1059, 1109, 1854, 276, 2014, 198, 200, 2420, 2308, 1328, 1029, 285, 2067, 3849, 1921, 624, 2755, 2090, 3797, 512, 3350, 3750, 1231, 661, 474, 2561, 2376, 501, 2442, 1981, 1977, 3893, 2281, 3596, 458, 532, 2328, 3806, 466, 2294, 1145, 3154, 693, 2273, 358, 454, 175, 915, 1051, 1111, 3673, 1227, 516, 3645, 3868, 230, 789, 3781, 3793, 2861, 2138, 2071, 3254, 2444,
  /* r 1, c 15701:15800 */  2543, 2159, 2644, 506, 2053, 3589, 3313, 3043, 3180, 878, 3730, 3147, 4030, 2955, 592, 3125, 1620, 1212, 3106, 407, 3117, 2691, 1243, 2708, 3848, 1089, 618, 1783, 2918, 3571, 144, 1448, 3436, 1610, 680, 934, 1688, 2451, 3247, 4044, 2169, 3222, 3187, 340, 1874, 3211, 846, 1081, 3103, 1704, 3870, 780, 1482, 830, 3144, 2749, 1528, 1584, 1067, 2990, 4048, 3037, 2718, 1379, 1364, 645, 454, 1770, 2999, 2469, 218, 1909, 1913, 3340, 2894, 1627, 1155, 679, 1447, 2912, 743, 1662, 2425, 3814, 952, 1028, 3396, 2777, 3370, 3104, 1949, 1141, 3391, 113, 1991, 116, 127, 2089, 1854, 2610,
  /* r 1, c 15801:15900 */  4078, 3294, 3004, 759, 1572, 2682, 554, 1538, 3547, 2754, 1095, 1183, 582, 3806, 1124, 1710, 660, 1464, 2786, 2244, 2518, 2647, 501, 3130, 880, 2114, 2417, 523, 2126, 905, 3051, 3362, 1896, 2431, 3911, 2821, 2631, 1599, 3300, 1099, 3851, 3435, 248, 2494, 4053, 1355, 3457, 2398, 310, 1140, 2301, 1718, 1583, 1891, 3353, 3327, 104, 3499, 865, 1600, 1384, 3698, 3008, 3343, 2336, 1101, 678, 2273, 3677, 750, 956, 1128, 3448, 2066, 2833, 3084, 3926, 645, 725, 380, 4019, 2667, 1132, 2055, 3176, 1279, 675, 3993, 4077, 3661, 3666, 1648, 2124, 3931, 1302, 718, 533, 3823, 3897, 3303,
  /* r 1, c 15901:16000 */  3141, 2818, 300, 846, 2619, 387, 640, 1366, 2568, 698, 1714, 3253, 1034, 1465, 4051, 4053, 1406, 1682, 3812, 3382, 4035, 325, 2686, 2601, 1603, 3129, 4008, 2722, 482, 3138, 3084, 839, 4000, 3613, 3466, 194, 253, 3658, 3932, 518, 1780, 2978, 1622, 2973, 3897, 698, 979, 2896, 1263, 311, 2581, 3829, 3911, 3654, 1469, 1146, 571, 2577, 1364, 3239, 4056, 2430, 500, 2402, 1213, 3994, 2884, 4059, 579, 3090, 2976, 2110, 1690, 2355, 3837, 860, 2609, 1202, 173, 250, 376, 3743, 3154, 1757, 3808, 1495, 431, 2128, 2644, 3828, 3142, 3607, 3873, 2820, 1247, 3171, 244, 3297, 2882, 2048,
};

int testcases = 7;
